# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"
# include "../HEADER/lib_local_secstr.h"


/*##########################################################################*/
/*###################Ecriture d' un fichier .header#########################*/
/*##########################################################################*/

void header(pdbfile *m){
	FILE *fheader;FILE *fheader2;
	char adress[200]; 
	int s=0;
	int i=0;
	/*int j=0;*/

	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s.header",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s.header",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s.header",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s.header",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s.header",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s.header",m->name);
		
	fheader=fecrire(adress);
	/*fprintf(fheader,"%s\n",m->name);*/
	fprintf(fheader,"%ld\n",m->Nb_residues);
	
	/*for(i=0;i<m->Nb_residues;fprintf(fheader,"%c",m->Nam_residues[i++]));				fprintf(fheader,"\n");*/
	for(i=0;i<m->Nb_residues;i++){
		if(m->CysDSSP[i]==1) {fprintf(fheader,"c");fheader2=fSurecrire("Results/cys.txt");fprintf(fheader2,"%s\n",m->name);of(fheader2);}	/* c : cystine / C : cysteine free*/
		else fprintf(fheader,"%c",m->Nam_residues[i]);
	}
	fprintf(fheader,"\n");
	
	for(i=0;i<m->Nb_residues;fprintf(fheader,"%c",BPtrans(m->Assign_PB[i++])));			fprintf(fheader,"\n");
	if(LECT_DSSP=='T')for(i=0;i<m->Nb_residues;fprintf(fheader,"%d",CEightDssp(m->S2dssp[i++])));	fprintf(fheader,"\n");
	of(fheader);
	
	if(NACESS=='T'){
	sprintf(adress,"./Results/Dist/%s.nAc",m->name);
	fheader=fecrire(adress);
	fprintf(fheader,"%ld\n",m->Nb_residues);
	for(i=0;i<m->Nb_residues;fprintf(fheader,"%8.3lf\n",m->RelativeAccess[i++]));
	of(fheader);}
	
}



/*#############################################################################*/
/*######################Distance Euclidienne###################################*/
/*#############################################################################*/

double distance_interATOM(const double xa,const double ya,const double za,const double X,const double Y,const double Z){
	return(sqrt((((xa-X)*(xa-X))+((ya-Y)*(ya-Y))+((za-Z)*(za-Z)))));
	}



double CoX (int x, int y, pdbfile *m){
	return m->pdbatomtype[m->deb_residues[x]+y].ATOM_CoordX;
}

double CoY (int x, int y, pdbfile *m){
	return m->pdbatomtype[m->deb_residues[x]+y].ATOM_CoordY;
}

double CoZ (int x, int y, pdbfile *m){
	return m->pdbatomtype[m->deb_residues[x]+y].ATOM_CoordZ;
}


double CoBarX(pdbfile *m,int k)
{	
	int i=0;
	double Xa=0.0;
	for(i=0;i<((m->end_residues[k])-(m->deb_residues[k]));i++){
		Xa = Xa + CoX(k,i,m);
	}
	return Xa/((m->end_residues[k])-(m->deb_residues[k]));

}

double CoBarY(pdbfile *m,int k)
{	
	int i=0;
	double Ya=0.0;
	for(i=0;i<((m->end_residues[k])-(m->deb_residues[k]));i++){
		Ya = Ya + CoY(k,i,m);
	}
	return Ya/((m->end_residues[k])-(m->deb_residues[k]));

}

double CoBarZ(pdbfile *m,int k)
{	
	int i=0;
	double Za=0.0;
	for(i=0;i<((m->end_residues[k])-(m->deb_residues[k]));i++){
		Za = Za + CoX(k,i,m);
	}
	return (Za/((m->end_residues[k])-(m->deb_residues[k])));

}

/*#############################################################################*/
/*####Calcul des distances entre les barycentres des residus ##################*/
/*#############################################################################*/

void DistBarycenter(pdbfile *m){
	int k=0;
	int u=0;
	int s=0;
	FILE *fbary;
	char adress[200]; 

	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s_bary.txt",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s_bary.txt",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s_bary.txt",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s_bary.txt",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s_bary.txt",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s_bary.txt",m->name);
	
	printf("adress : %s SCWRL %c SCAP %c IRECS %c SCCOMP %c \n",adress,SCWRL,SCAP,IRECS,SCCOMP);
	
	fbary=fecrire(adress);

	for(k=0;k<(m->Nb_residues);k++){
		for(u=0;u<(m->Nb_residues);u++){
			fprintf(fbary,"%lf\t",distance_interATOM(CoBarX(m,k),CoBarY(m,k),CoBarZ(m,k),CoBarX(m,u),CoBarY(m,u),CoBarZ(m,u)));
		}
		fprintf(fbary,"\n");
	}


	of(fbary);

}

/*#############################################################################*/
/*##########Calcul des distances entre atomes composant le squelette###########*/
/*#############################################################################*/

void Distbackbone(pdbfile *m){
	
	FILE *fbb;
	int i=0;
	int j=0;
	int k=0;
	int u=0;
	int s=0;
	double Xa=0.0,Xb=0.0,Ya=0.0,Yb=0.0,Za=0.0,Zb=0.0;
	double min=99999.0;
	

	char adress[200]; 

	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s_bb.txt",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s_bb.txt",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s_bb.txt",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s_bb.txt",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s_bb.txt",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s_bb.txt",m->name);
	
	fbb=fecrire(adress);
	for(k=0;k<(m->Nb_residues);k++){
		for(u=0;u<(m->Nb_residues);u++){
			min=99999.0;
			for (i=0;i<4;i++){
				for (j=0;j<4;j++){

						Xa = CoX(k,i,m);
						Ya = CoY(k,i,m);
						Za = CoZ(k,i,m);
						Xb = CoX(u,j,m);
						Yb = CoY(u,j,m);
						Zb = CoZ(u,j,m);
						
						if(distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb)<min){
							min= distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb);
							}
				}
			}
			fprintf(fbb,"%lf\t",min);
		}
		fprintf(fbb,"\n");
	}
	of(fbb);
}

/*#########################################*/
/*Test pour savoir si on a une glycine     */
/*@input : nom de l'AA                     */
/*@output : 1 si glycine  0 si pas glycine*/
/*                                        */
/*#######################################*/
int TestGly(char *AA){
	
	char glycine[]="GLY";
	int res=0;
	if(strcmp(AA,glycine)==0){
		res=1;
	}
	return res;
	}




/*#############################################################################*/
/*##########Calcul des distances chaines latérales#############################*/
/*#############################################################################*/
void DistChainLat(pdbfile *m){

	FILE *fcl;	/* pointeur de fichier : tu fis chier */
	int i,j,k,u,s;
	int flag1, flag2;
	double Xa,Xb,Ya,Yb,Za,Zb;
	double min;
	char adress[200];
	
	i=j=k=u=s=0;
	flag1=flag2=4;
	Xa=Xb=Ya=Yb=Za=Zb=0.0;
	min=99999.0;
	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s_sc.txt",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s_sc.txt",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s_sc.txt",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s_sc.txt",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s_sc.txt",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s_sc.txt",m->name);
	
	fcl=fecrire(adress);
	for(k=0;k<(m->Nb_residues);k++){	/* premier residu */
	if(TestGly(m->pdbatomtype[m->deb_residues[k]].ATOM_residuesname)){flag1=1;}
	for(u=0;u<(m->Nb_residues);u++){
		if(TestGly(m->pdbatomtype[m->deb_residues[u]].ATOM_residuesname)){flag2=1;}
		min=99999.0;
		for (i=0;i<=((m->end_residues[k])-((m->deb_residues[k])+flag1));i++){
		Xa = CoX(k,flag1+i,m);Ya = CoY(k,flag1+i,m);Za =CoZ(k,flag1+i,m);
		if(flag1==1)i=25;
		for(j=0;j<=((m->end_residues[u])-((m->deb_residues[u])+flag2));j++){
			Xb=CoX(u,flag2+j,m); Yb=CoY(u,flag2+j,m);Zb=CoZ(u,flag2+j,m);
			if(distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb)<min)min=distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb);
			if(flag2==1)j=25;
			}
		}
		fprintf(fcl,"%lf\t",min);
		flag2=4;
	}
	fprintf(fcl,"\n");
	flag1=4;
	}
	of(fcl);
}

/*#############################################################################*/
/*##########Calcul des distances chaines laterales + backbone##################*/
/*#############################################################################*/

void DistTtAtom(pdbfile *m){
	
	FILE *ftest;
	int i=0;
	int j=0;
	int k=0;
	int u=0;
	int s=0;
	double min=99999.0;

	double Xa=0.0,Xb=0.0,Ya=0.0,Yb=0.0,Za=0.0,Zb=0.0;


	char adress[200]; /*[]="./Results/Dist/";*/

	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s_sc_bb.txt",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s_sc_bb.txt",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s_sc_bb.txt",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s_sc_bb.txt",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s_sc_bb.txt",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s_sc_bb.txt",m->name);
	
	ftest=fecrire(adress);
	
	for(k=0;k<(m->Nb_residues);k++){
		
		for(u=0;u<(m->Nb_residues);u++){

	
			min=99999.0;
			for (i=0;i<=((m->end_residues[k])-(m->deb_residues[k]));i++){
					Xa = CoX(k,i,m);
					Ya = CoY(k,i,m);
					Za = CoZ(k,i,m);
				for (j=0;j<=((m->end_residues[u])-(m->deb_residues[u]));j++){
						Xb = CoX(u,j,m);
						Yb = CoY(u,j,m);
						Zb = CoZ(u,j,m);
						if(distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb)<min){
							min= distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb);
							}
				}
			}
			fprintf(ftest,"%lf\t",min);
		}
		fprintf(ftest,"\n");
	}
	of(ftest);
}



/*#############################################################################*/
/*##########Calcul des distances centre les Cbetas#############################*/
/*#############################################################################*/

void DistCbeta(pdbfile *m){
	
	FILE *fcb;
	int i=0;
	int j=0;
	double Xa=0.0,Xb=0.0,Ya=0.0,Yb=0.0,Za=0.0,Zb=0.0;
	int s=0;

	int RR1=4;
	int RR2=4;

	char adress[200]; /*[]="./Results/Dist/";*/

	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s_cb.txt",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s_cb.txt",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s_cb.txt",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s_cb.txt",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s_cb.txt",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s_cb.txt",m->name);
	
		
	fcb=fecrire(adress);

	for(i=0;i<(m->Nb_residues);i++){
		if(TestGly(m->pdbatomtype[m->deb_residues[i]].ATOM_residuesname)){
			RR1=1;	
			}
		Xa = CoX(i,RR1,m);
		Ya = CoY(i,RR1,m);
 		Za = CoZ(i,RR1,m);
	
		for(j=0;j<(m->Nb_residues);j++){
			if(TestGly(m->pdbatomtype[m->deb_residues[j]].ATOM_residuesname)){
				RR2=1;
			}
				Xb = CoX(j,RR2,m);
				Yb = CoY(j,RR2,m);
				Zb = CoZ(j,RR2,m);
				fprintf(fcb,"%lf\t",distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb));
				RR2=4;
		}
		fprintf(fcb,"\n");
		RR1=4;
	}
	of(fcb);
}




/*#############################################################################*/
/*##########Calcul des distances entre les Calpha #############################*/
/*#############################################################################*/


void DistCa(pdbfile *m){
	/*
	FILE *fca;
	FILE *f90;
	int chaine_use=0;
	int residu_A=0;
	int residu_B=0;
	int long_A=0;
	int long_B=0;
	double dist_calc=DIST_INIT;
	long nbpb=0;
	int lgseq=0;
	float **dist;
	*/
	
	int i=0;
	int j=0;
	int s = 0;
	double Xa=0.0,Xb=0.0,Ya=0.0,Yb=0.0,Za=0.0,Zb=0.0;
	FILE *fcaca;	
	char adress[200]; /*[]="./Results/Dist/";*/

	for (s=0; s<200; s++) {adress[s]='\0';}
	if((SCWRL=='T')||(SCAP=='T')||(SCATD=='T')||(IRECS=='T')||(SCCOMP=='T')){
		if(SCWRL=='T') sprintf(adress,"./Results/Dist/SCWRL-%s_ca.txt",m->name);
		if(SCAP=='T') sprintf(adress,"./Results/Dist/SCAP-%s_ca.txt",m->name);
		if(SCATD=='T') sprintf(adress,"./Results/Dist/SCATD-%s_ca.txt",m->name);
		if(IRECS=='T') sprintf(adress,"./Results/Dist/IRECS-%s_ca.txt",m->name);
		if(SCCOMP=='T') sprintf(adress,"./Results/Dist/SCCOMP-%s_ca.txt",m->name);
	}
	else sprintf(adress,"./Results/Dist/%s_ca.txt",m->name);

	fcaca=fecrire(adress);
	for(i=0;i<(m->Nb_residues);i++){
		for(j=0;j<(m->Nb_residues);j++){
			Xa = CoX(i,1,m);
			Ya = CoY(i,1,m);
 			Za = CoZ(i,1,m);
 			Xb = CoX(j,1,m);
			Yb = CoY(j,1,m);
			Zb = CoZ(j,1,m);
			fprintf(fcaca,"%lf\t",distance_interATOM(Xa,Ya,Za,Xb,Yb,Zb));
		}
	fprintf(fcaca,"\n");
	}
	of(fcaca);

	/*#############################################################################################*/
	
}	


/*###################################################*/
/*############## Fonction principale ################*/
/*###################################################*/

void Dist(pdbfile *m){
	printf("Lancement de Dist\n");
	DistCa(m);
	DistCbeta(m);
	DistTtAtom(m);
	Distbackbone(m);
	DistChainLat(m);
	DistBarycenter(m);
	header(m);
	
}


/*********************************************************************************************/
/*			Calcul de distance minimal entre ch. laterales			     */
/*********************************************************************************************/


void DistanceLAT(pdbfile *m){
	/*FILE *f90;
	int chaine_use=0;
	int residu_A=0;
	int long_A=0;
	int residu_B=0;
	int long_B=0;
	int lgseq=0;
	double **dist;
	double dist_min=DIST_INIT;
	double dist_calc=DIST_INIT;
	int compteur=0;	
	int compteur2=0;
	char dfg[100];
	double distcalpha=DIST_INIT;
	*/
	/*if(Werboze=='T')  printf("Travail sur les distances minimales inter-residus, %lf a refaire (ne passe plus)\n",DIST_INIT);
	
	
	


	
	for(chaine_use=0;chaine_use<((m->NB_chain)+1);chaine_use++){
	
		lgseq=((m->Pos_LastRes[chaine_use])-(m->Pos_FirstRes[chaine_use])+1);
	
		if(Werboze=='T')  printf("Travail sur les distances en cours chaine %2d [%ld-%ld] pour long %d\n",chaine_use+1,m->Pos_FirstRes[chaine_use],m->Pos_LastRes[chaine_use],lgseq);

		dist=AllocMemoireFlFl(lgseq,lgseq);		

		for(residu_A=m->Pos_FirstRes[chaine_use];residu_A<m->Pos_LastRes[chaine_use];residu_A++){
			for(residu_B=m->Pos_FirstRes[chaine_use];residu_B<m->Pos_LastRes[chaine_use];residu_B++){
			        dist_min=DIST_INIT;
				for(long_A=m->deb_residues[residu_A]+0;long_A<m->end_residues[residu_A];long_A++){
					for(long_B=m->deb_residues[residu_B]+0;long_B<m->end_residues[residu_B];long_B++){
						dist_calc=distance_interATOM(m->pdbatomtype[long_A].ATOM_CoordX,m->pdbatomtype[long_A].ATOM_CoordY,m->pdbatomtype[long_A].ATOM_CoordZ,\
							m->pdbatomtype[long_B].ATOM_CoordX,m->pdbatomtype[long_B].ATOM_CoordY,m->pdbatomtype[long_B].ATOM_CoordZ);
				     if(dist_calc<dist_min)
						dist_min=dist_calc;
					}
				}
			dist[residu_A-(m->Pos_FirstRes[chaine_use])][residu_B-(m->Pos_FirstRes[chaine_use])]=dist_min;	
			}
		}
		
		if(Werboze=='T')  
			printf("(ecriture) interm %6.3f close %6.3f\n",100*(float)compteur/(float)(lgseq*lgseq),100*(float)compteur2/(float)(lgseq*lgseq));
		f90=fSurecrire("./Results/Dist/analyse_distance.txt");
		fprintf(f90,"######################################################################################\n");
		fprintf(f90,"###### proteine %s chaine %d longeur %4d interm %6.3f close %6.3f\n",m->name,chaine_use+1,lgseq,100*(float)compteur/(float)(lgseq*lgseq),100*(float)compteur2/(float)(lgseq*lgseq));
		fprintf(f90,"######################################################################################\n");
		fclose(f90);	
		
		clean_str(dfg, 100);
		sprintf(dfg,"./Results/Dist/matdist_%s%d",m->name,chaine_use+1);
		f90=fecrire(dfg);
		for(residu_A=0;residu_A<lgseq;residu_A++){
				for(long_A=0;long_A<lgseq;long_A++){
					fprintf(f90,"%6.3f\t",dist[residu_A][long_A]);
					}
				fprintf(f90,"\n");
				}	
		fclose(f90);	

		DesallocMemoireFlFl(dist,lgseq);
		
		
	}

	f90=fSurecrire("./Results/Dist/dist_db.txt");

	chaine_use=0;	a modifier 

	lgseq=((m->Pos_LastRes[chaine_use])-(m->Pos_FirstRes[chaine_use]));
	fprintf(f90,">%s %5d\n",m->name,lgseq);	
		if(Werboze=='T')  printf("Banque de donnees serge distance en cours \n");
		
		lgseq=((m->Pos_LastRes[chaine_use])-(m->Pos_FirstRes[chaine_use]));
	
		for(residu_A=m->Pos_FirstRes[chaine_use];residu_A<m->Pos_LastRes[chaine_use];residu_A++){
			for(residu_B=residu_A+1;residu_B<m->Pos_LastRes[chaine_use];residu_B++){
			        dist_min=DIST_INIT;
				for(long_A=m->deb_residues[residu_A]+0;long_A<m->end_residues[residu_A];long_A++){
					for(long_B=m->deb_residues[residu_B]+0;long_B<m->end_residues[residu_B];long_B++){
						dist_calc=distance_interATOM(m->pdbatomtype[long_A].ATOM_CoordX,m->pdbatomtype[long_A].ATOM_CoordY,m->pdbatomtype[long_A].ATOM_CoordZ,\
							m->pdbatomtype[long_B].ATOM_CoordX,m->pdbatomtype[long_B].ATOM_CoordY,m->pdbatomtype[long_B].ATOM_CoordZ);
				     if(dist_calc<dist_min)
						dist_min=dist_calc;
					}
				}

			long_A=m->deb_residues[residu_A]+1;
			long_B=m->deb_residues[residu_B]+1;

			distcalpha=dist_calc=distance_interATOM(m->pdbatomtype[long_A].ATOM_CoordX,m->pdbatomtype[long_A].ATOM_CoordY,m->pdbatomtype[long_A].ATOM_CoordZ,\
							m->pdbatomtype[long_B].ATOM_CoordX,m->pdbatomtype[long_B].ATOM_CoordY,m->pdbatomtype[long_B].ATOM_CoordZ);

			fprintf(f90,"%c %c %8.2lf %8.2lf\n",m->Nam_residues[residu_A],m->Nam_residues[residu_B],dist_min,distcalpha);
			}
		}
			

	of(f90);	
	
	f90=fSurecrire("./Results/Dist/dist_db_max20.txt");

	chaine_use=0;	 a modifier 

	lgseq=((m->Pos_LastRes[chaine_use])-(m->Pos_FirstRes[chaine_use]));
	
		if(Werboze=='T')  printf("Banque de donnees serge distance en cours \n");
		fprintf(f90,">%s %5d\n",m->name,lgseq);			
		lgseq=((m->Pos_LastRes[chaine_use])-(m->Pos_FirstRes[chaine_use]));
	
		for(residu_A=m->Pos_FirstRes[chaine_use];residu_A<m->Pos_LastRes[chaine_use];residu_A++){
			for(residu_B=residu_A+2;residu_B<m->Pos_LastRes[chaine_use];residu_B++){
			        dist_min=DIST_INIT;
				for(long_A=m->deb_residues[residu_A]+3;long_A<m->end_residues[residu_A];long_A++){
					for(long_B=m->deb_residues[residu_B]+3;long_B<m->end_residues[residu_B];long_B++){
						dist_calc=distance_interATOM(m->pdbatomtype[long_A].ATOM_CoordX,m->pdbatomtype[long_A].ATOM_CoordY,m->pdbatomtype[long_A].ATOM_CoordZ,\
							m->pdbatomtype[long_B].ATOM_CoordX,m->pdbatomtype[long_B].ATOM_CoordY,m->pdbatomtype[long_B].ATOM_CoordZ);
				     if(dist_calc<dist_min)
						dist_min=dist_calc;
					}
				}

			long_A=m->deb_residues[residu_A]+1;
			long_B=m->deb_residues[residu_B]+1;

			distcalpha=dist_calc=distance_interATOM(m->pdbatomtype[long_A].ATOM_CoordX,m->pdbatomtype[long_A].ATOM_CoordY,m->pdbatomtype[long_A].ATOM_CoordZ,\
							m->pdbatomtype[long_B].ATOM_CoordX,m->pdbatomtype[long_B].ATOM_CoordY,m->pdbatomtype[long_B].ATOM_CoordZ);
			if(dist_min<20.0)
				fprintf(f90,"%c %c %8.2lf %8.2lf\n",m->Nam_residues[residu_A],m->Nam_residues[residu_B],dist_min,distcalpha);
			}
		}
			

	of(f90);
	*/	
}


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
