/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	init.h	(beta version 2003)					      */
/*	----------							      */
/*	initialization of all the parameters (default values)		      */
/*	last modification : 31-10-2003					      */
/******************************************************************************/

pdbfile molecule;				/* la molecule du fichier PDB */

/*************/
/* options : */
/*************/
					/********************************************************************************************/
char nom_fichier[250];			/* opt  1     le nom du fichier  					  		    */
char NO_CHECK='F';			/* opt  2     True pour ne pas verifier les contraintes des fichiers 			    */
float Resolution_autorisee=2.5;		/* opt  3     valeur minimale de resolution 						    */
char WORK_PROLINE='F';			/* opt  4     True si on veut le travail sur les Prolines				    */
char WORK_GLYCINE='F';			/* opt  5     True si on veut le travail sur les Glycines				    */	
char Werboze='F';			/* opt  6     True si on veut du blabla 						    */
char ResearchPB='F';			/* opt  7     True si on veut un travail sur les Protein Blocs 				    */
char ResearchTurn='F'; 			/* opt  8     True si on veut rechercher les turns 					    */
char EcrDiedres='F';			/* opt  9     True pour un fichier de sortie des angles diedres 			    */
char EveryPB='F';			/* opt 10     True pour avoir tous les PBs d'une proteine dans un fichier PDB separe 	    */
char SEARCH_CAV='F';			/* opt 11     True pour la recherche cavite/surface 					    */
char SEARCH_DIS='F';			/* opt 12     True pour les distances minimales					            */
char SEARCH_ALP='F';			/* opt 13     True pour les calculs des Angles alpha par Pblocs Proteiques		    */
char DistAA[2];				/* opt 14     On sort la distance entre 2 types d'acides amines 			    */	
char PRED_TYPE='F';			/* opt 15-16  False pour pas de prediction T pour le 16 et X pour les Familles sequentielles*/
char LECT_SEA='F';			/* opt 17     False pour pas ne pas lancer psea et la lecture des sorties 		    */
char V_SEA='F';		 		/* opt 18     False pour voir les blabla					    	    */
char LECT_DSSP='F';			/* opt 19     False pour pas ne pas lancer dssp et la lecture des sorties 		    */
char V_DSSP='F';			/* opt 20     False pour pas ne pas lancer dssp et la lecture des sorties 		    */
char LECT_STRIDE='F';			/* opt 21     False pour pas ne pas lancer Stride et la lecture des sorties 		    */
char LECT_STRIDEplus='F';		/* opt 22     False pour pas ne pas lancer Stride et la lecture des sorties (Turn precis)   */
char V_STRIDE='F';			/* opt 23     False pour pas ne pas lancer Stride et la lecture des sorties		    */
char V_S2='F';				/* opt 24     lancer les 3 methodes precedentes 					    */
char LECT_DEFINE='F';			/* opt 25     False pour pas ne pas lancer Define et la lecture des sorties 		    */
char V_DEFINE='F';			/* opt 26     False pour pas ne pas lancer Define et la lecture des sorties		    */
char LECT_PCURVE='F';			/* opt 27     False pour pas ne pas lancer PCURVE et la lecture des sorties 		    */
char V_PCURVE='F';			/* opt 28     False pour pas ne pas lancer PCURVE et la lecture des sorties 		    */
char V_S25='F';				/* opt 29     lancer les 5 methodes precedentes 					    */
char ROOM='F';				/* opt 30     Sur le travail de Rooman et Wodak 					    */
char FETROW='F';			/* opt 31     Sur le travail de Fetrow et al. (1997) 					    */
char nom_fetr[250];			/* opt 31     Sur le travail de Fetrow et al. (1997) 					    */
char COLOR='F';				/* opt 32     Pour avoir un fichier pour colorer sour rasmol				    */
char COMPO='F';				/* opt 33     Pour avoir la composition en freq(AA)					    */
char COMPO2='F';			/* opt 34     Pour avoir la composition en freq(S2)					    */
char RAMA='F';			        /* opt 35     Pour avoir les Phi Psi par PB					            */
char WORK_BEST_PB='F';			/* opt 36     True si on veut avoir les PBs les meilleurs et les angles de tous les BPs	    */
char BACK_XYZ='F';			/* opt 37     True pour avoir un fichier desortie xyz (Calpha)			            */
char MODELLER='F';			/* opt 38     True pour lire un fichier Modeller			            	    */
char CHAIN='-';				/* opt 39     True pour choisir une seule chaine			            	    */
char PRAPIA='F';			/* opt 40     True pour ...								    */
char WRITE_DBank_AMTRIX='F';		/* opt 41     True pour ...								    */
char RECOV_CLASSIC='F';			/* opt 42     True pour les  72 SWs dfinis au dpart	       				    */
char RECOV_PAPIA='F';			/* opt 43     True pour les 190 SWs dfinis avec la banque de donnes PAPIA (2002)	    */
char RSMOL_HIR='F';			/* opt 44     True pour sortie d'un script rasmol (color) pour le protein network	    */
char BPin='9';				/* opt 45     True pour calculer soit 5, soit 9 aa pour le recouvrement des SWs		    */
char REPET='F';				/* opt 46     True pour 			            				    */
char PB_RMSD='F';			/* opt 47     True pour superposer tous les PBs localement    				    */
char HELIXES='F';			/* opt 48     True pour la recherche des hlices transmembranaires			    */
char SIPPL='F';				/* opt 49     True pour les superpositions en utilisant les librairies de SIPPL		    */
char PROMOTIF='F';			/* opt 50     True pour lire les sorties de PROMOTIF           				    */
char PROTEIN_NETWORK='F';		/* opt 51     True pour le Protein Network	            				    */
char CHECK_DBG='F';			/* opt 52     True pour faire un suivi du debugage            				    */
char TEST_PDB='F';			/* opt 53     True pour sortir un PDB propre						    */
char ResearchTurn2='F'; 		/* opt 54     True si on veut rechercher les turns 					    */
char PDBTurn2='F'; 			/* opt 55     True si on veut rechercher les turns 					    */
char Writedefi='F';			/* opt 56     True pour ecrire des defintions  (turns)					    */
char LECT_DSSP_cont='F';		/* opt 57     False pour pas ne pas lancer dsspcont et la lecture des sorties 		    */
char LECT_xtlsstr='F';			/* opt 58     False pour pas ne pas lancer dsspcont et la lecture des sorties 		    */
char HELANAL='F';			/* opt 59     False pour pas ne pas lancer helanal (need DSSP)		 		    */
char RKstr='F';				/* opt 60     False pour pas ne pas lancer le script de R. Karchin pour les beta (need DSSP)*/
char Fodje='F';				/* opt 61     False pour pas ne pas lancer secstr (Fodje & Al-K. 2002)			    */
char CutPsiLoops='F';			/* opt 62     False pour pas ne pas decouper toutes les psi-loops (demande Promotif)	    */					
char DBNAME='F';			/* opt 63     False pour "dbank.txt"	    						    */					
char nom_db[250];			/* opt 63(2)  le nom du fichier  					  		    */
char MOLSCRIPT='F';			/* opt 64     False pour pas ne pas demander de scriptage MOLSCRIPT			    */									
char MOLVID='F';			/* opt 65     False pour pas ne pas demander de scriptage MOLSCRIPT			    */									
char MolTrans='F';			/* opt 66     False pour pas ne pas demander de scriptage MOLSCRIPT			    */									
char rot3Dmolscr[250];			/* opt 66(2)  le nom du fichier  					  		    */
int LGFASTA=40;				/* opt 67     Longeur du Fasta ligne (default = 40)					    */									
char SEARCH_PBserie[250];		/* opt 68     Pour chercher une serie de PBs						    */
int lg_SEARCH_PBserie;			/* opt 68(2)  Pour chercher une serie de PBs						    */
char CYS='F';				/* opt 69     Pour chercher les Cys-Cys et Cys- free					    */
char REK='F';				/* opt 70     Pour reconstruction special						    */
char PII='F';				/* opt 71     Pour ecrire les fichiers PDB des PII					    */
char DBT='F';				/* opt 72     Pour un fichier output "simple" pour Dbk					    */
int NBCOL=66;				/* opt 73     For length columm in PDB files					    	    */
char DISTCA='F';			/* opt 74     For 					    	    */
char SEGNO='F';				/* opt 75     For Segno software					    	    */
char NODB='T';				/* opt 76     For Db problem					    	    */
char KAKSI='F';				/* opt 77     For Kaksi software					    	    */
char NACESS='F';			/* opt 78     For Nacess software					    	    */
char CYSDSSP='F';			/* opt 79     For Cysteine  - Cystine DSSP					    	    */					/********************************************************************************************/
char NOMPDB='F';			/* opt 80     For PDB name	    						    */					
char nom_PDB[250];			/* opt 80     For PDB name							    	    */
char PYMOL='F';				/* opt 81     For PyMol	    						    		    */					
char SCWRL='F';				/* opt 82     For scwrl	    						    		    */					
char SCAP='F';			 	/* opt 83     For scwrl								     */ 				 
char SCATD='F';			 	/* opt 84     For scwrl								     */ 				 
char IRECS='F';			 	/* opt 85     For scwrl								     */ 				 
char SCCOMP='F';			/* opt 86     For scwrl								     */ 				 
char PDBbb='F';			/* opt 87     only backbone*/

/************/
/* others : */
/************/

int type_experim=1;
char SEARCH_WORDS='F';			/* True pour une recherche de certains mots */

				
