/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	lib_define.h	(beta version 2003)				      */
/*	-------------							      */
/*	most of the # define used in all the software		              */
/*	version : 1.01							      */
/*	last modification : 10-06-2003					      */
/******************************************************************************/

/***********/
/* comput. */
/***********/

# define Lg_buffer 90		/* longeur du buffer de chaque ligne*/
# define NB_M_LG 7		/*    pour des trucs plus courts    */
# define SIZE_Buffer 250	/* longeur du buffer de chaque ligne*/
# ifndef M_PI
#  define M_PI		3.14159265358979323846
# endif


/***************************/
/* residues and parameters */
/***************************/

# define NB_AA 20			/*  	 Number of amino acids      */
# define NbrAA 20			/*        20 acides amines          */	/* must be changed */
# define Rayon_VdW 2.6			/*     le rayon de Van der Waals    */ 
# define MAX_CONEX 6			/* maximum de connection autorise de 6 per atomes*/

/*********************/
/* PDB specificities */
/*********************/

# define NB_AMX_HEADER 256	/*    longeur maximal du header     */

# define NB_MAX_RES 100000	/* 100000 residus maximum autorises */	
# define NB_MAX_ATOM 910000	/*    nombre maximal d'atomes lus   */	
				/*   max see:  906728 in pdb1htq.ent */
# define NB_MAX_CHAIN 90	/*   nombre maximal de chaines 	  */	
# define NB_MAX_XHI 4		/*      nombre de Xhi possible    */
# define Number_First 58	/*    nombre max de header connu    */

# define NR_type 44
# define ND_type 208
# define LG_MAX_AA 14
# define NB_MAX_NucA 4

# define Nb_Max_Options 89	/* nombre d'options possibles */

# define NB_SEQ 1 
# define NB_TAMP00 20
# define DEFAULT_RES 100.0	/* resolution mise par defaut */


# define MAX_PB .02 		/* 2 % de probleme autorise sur la proteine */

# define DIST_LAT_MIN  2.0
# define DIST_LAT_MAX 10.0
# define DIST_INIT 100.0

# define NB_MAX_helix 500
# define DEFINE_TAB_FASTA 40


/****************************/
/* Protein Blocks (PBs)     */
/* de Brevern et al. (2000) */
/****************************/

# define NB_ANGLES 8			/*    Number of angles for the PBs    */
# define NB_BP 16			/*   Number of Protein Blocks (PBs)   */
# define NB_BP_FS 26			/* Number of Sequence Families (pred.)*/
# define NB_AAinuse 5
# define SIZE_WINDOW_PRED 15
# define MIN_LONGEUR 25
# define TAILLE_MAX_SEQ 10000
# define Occ_SEUILMIN 0.01
# define DEFAULT_ANGLE -999.00

/********************/
/* Turns definition */
/********************/

# define NB_GAMMA_TURN  2
# define NB_BETA_TURN   9 
# define NB_ALPHA_TURN 10 		/* one more than from Pavone et al. */

/**********************/
/* Sec Str definition */
/**********************/

# define NB_DSSP_STATE 9
# define NB_psea_STATE 4
# define NB_XTLSSTR_STATE 10
# define NB_HELANAL_STATE 7
# define NB_DSSPRK_STATE 14
# define NB_secstr_STATE 6
# define NB_betabul_STATE 11
# define NB_segno_STATE 8


