/******************************************************************************/
/*	PDB Dreamer version 1.00					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	options.h	(beta version 2007)				      */
/*	----------							      */
/*	all the different options that could be done			      */
/*	last modification : 02-01-2007					      */
/******************************************************************************/

					/********************************************************************************************/
extern char nom_fichier[250];		/* opt  1     le nom du fichier  					  		    */
extern char NO_CHECK;			/* opt  2     True pour ne pas verifier les contraintes des fichiers 			    */
extern float Resolution_autorisee;	/* opt  3     valeur minimale de resolution 						    */
extern char WORK_PROLINE;		/* opt  4     True si on veut le travail sur les Prolines				    */
extern char WORK_GLYCINE;		/* opt  5     True si on veut le travail sur les Glycines				    */	
extern char Werboze;			/* opt  6     True si on veut du blabla 						    */
extern char ResearchPB;			/* opt  7     True si on veut un travail sur les Protein Blocs 				    */
extern char ResearchTurn; 		/* opt  8     True si on veut rechercher les turns 					    */
extern char EcrDiedres;			/* opt  9     True pour un fichier de sortie des angles diedres 			    */
extern char EveryPB;			/* opt 10     True pour avoir tous les PBs d'une proteine dans un fichier PDB separe 	    */
extern char SEARCH_CAV;			/* opt 11     True pour la recherche cavite/surface 					    */
extern char SEARCH_DIS;			/* opt 12     True pour les distances minimales					            */
extern char SEARCH_ALP;			/* opt 13     True pour les calculs des Angles alpha par Pblocs Proteiques		    */
extern char DistAA[2];			/* opt 14     On sort la distance entre 2 types d'acides amines 			    */	
extern char PRED_TYPE;			/* opt 15-16  False pour pas de prediction T pour le 16 et X pour les Familles sequentielles*/
extern char LECT_SEA;			/* opt 17     False pour pas ne pas lancer psea et la lecture des sorties 		    */
extern char V_SEA;			/* opt 18     False pour voir les blabla					    	    */
extern char LECT_DSSP;			/* opt 19     False pour pas ne pas lancer dssp et la lecture des sorties 		    */
extern char V_DSSP;			/* opt 20     False pour pas ne pas lancer dssp et la lecture des sorties 		    */
extern char LECT_STRIDE;		/* opt 21     False pour pas ne pas lancer Stride et la lecture des sorties 		    */
extern char LECT_STRIDEplus;		/* opt 22     False pour pas ne pas lancer Stride et la lecture des sorties (Turn precis)   */
extern char V_STRIDE;			/* opt 23     False pour pas ne pas lancer Stride et la lecture des sorties		    */
extern char V_S2;			/* opt 24     lancer les 3 methodes precedentes 					    */
extern char LECT_DEFINE;		/* opt 25     False pour pas ne pas lancer Define et la lecture des sorties 		    */
extern char V_DEFINE;			/* opt 26     False pour pas ne pas lancer Define et la lecture des sorties		    */
extern char LECT_PCURVE;		/* opt 27     False pour pas ne pas lancer PCURVE et la lecture des sorties 		    */
extern char V_PCURVE;			/* opt 28     False pour pas ne pas lancer PCURVE et la lecture des sorties 		    */
extern char V_S25;			/* opt 29     lancer les 5 methodes precedentes 					    */
extern char ROOM;			/* opt 30     Sur le travail de Rooman et Wodak 					    */
extern char FETROW;			/* opt 31     Sur le travail de Fetrow et al. (1997) 					    */
extern char nom_fetr[250];		/* opt 31     Sur le travail de Fetrow et al. (1997) 					    */
extern char COLOR;			/* opt 32     Pour avoir un fichier pour colorer sour rasmol				    */
extern char COMPO;			/* opt 33     Pour avoir la composition en freq(AA)					    */
extern char COMPO2;			/* opt 34     Pour avoir la composition en freq(S2)					    */
extern char RAMA;		        /* opt 35     Pour avoir les Phi Psi par PB					            */
extern char WORK_BEST_PB;		/* opt 36     True si on veut avoir les PBs les meilleurs et les angles de tous les BPs	    */
extern char BACK_XYZ;			/* opt 37     True pour avoir un fichier desortie xyz (Calpha)			            */
extern char MODELLER;			/* opt 38     True pour lire un fichier Modeller			            	    */
extern char CHAIN;			/* opt 39     True pour choisir une seule chaine			            	    */
extern char PRAPIA;			/* opt 40     True pour ...								    */
extern char WRITE_DBank_AMTRIX;		/* opt 41     True pour ...								    */
extern char RECOV_CLASSIC;		/* opt 42     True pour les  72 SWs dfinis au dpart	       				    */
extern char RECOV_PAPIA;		/* opt 43     True pour les 190 SWs dfinis avec la banque de donnes PAPIA (2002)	    */
extern char RSMOL_HIR;			/* opt 44     True pour sortie d'un script rasmol (color) pour le protein network	    */
extern char BPin;			/* opt 45     True pour calculer soit 5, soit 9 aa pour le recouvrement des SWs		    */
extern char REPET;			/* opt 46     True pour 			            				    */
extern char PB_RMSD;			/* opt 47     True pour superposer tous les PBs localement    				    */
extern char HELIXES;			/* opt 48     True pour la recherche des hlices transmembranaires			    */
extern char SIPPL;			/* opt 49     True pour les superpositions en utilisant les librairies de SIPPL		    */
extern char PROMOTIF;			/* opt 50     True pour lire les sorties de PROMOTIF           				    */
extern char PROTEIN_NETWORK;		/* opt 51     True pour le Protein Network	            				    */
extern char CHECK_DBG;			/* opt 52     True pour faire un suivi du debugage            				    */
extern char TEST_PDB;			/* opt 53     pour sortir un PDB propre							    */
extern char ResearchTurn2; 		/* opt 54     True si on veut rechercher les turns 					    */
extern char PDBTurn2; 			/* opt 55     True si on veut rechercher les turns 					    */
extern char Writedefi;			/* opt 56     True pour ecrire des defintions  (turns)					    */
extern char LECT_DSSP_cont;		/* opt 57     False pour pas ne pas lancer dsspcont et la lecture des sorties 		    */
extern char LECT_xtlsstr;		/* opt 58     False pour pas ne pas lancer dsspcont et la lecture des sorties 		    */
extern char HELANAL;			/* opt 59     False pour pas ne pas lancer helanal (need DSSP)		 		    */
extern char RKstr;			/* opt 60     False pour pas ne pas lancer le script de R. Karchin pour les beta (need DSSP)*/
extern char Fodje;			/* opt 61     False pour pas ne pas lancer secstr (Fodje & Al-K. 2002)			    */
extern char CutPsiLoops;		/* opt 62     False pour pas ne pas decouper toutes les psi-loops (demande Promotif)	    */					
extern char DBNAME;			/* opt 63     False pour "dbank.txt"	    						    */					
extern char nom_db[250];		/* opt 63(2)  le nom du fichier  					  		    */
extern char MOLSCRIPT;			/* opt 64     False pour pas ne pas demander de scriptage MOLSCRIPT			    */									
extern char MOLVID;			/* opt 65     False pour pas ne pas demander de scriptage MOLSCRIPT			    */									
extern char MolTrans;			/* opt 66     False pour pas ne pas demander de scriptage MOLSCRIPT			    */									
extern char rot3Dmolscr[250];		/* opt 66(2)  le nom du fichier  					  		    */
extern int LGFASTA;			/* opt 67     Longeur du Fasta ligne							    */
extern char SEARCH_PBserie[250];	/* opt 68     Pour chercher une serie de PBs						    */
extern int lg_SEARCH_PBserie;		/* opt 68(2)  Pour chercher une serie de PBs						    */
extern char CYS;			/* opt 69     Pour chercher les Cys-Cys et Cys- free					    */
extern char REK;			/* opt 70     Pour reconstruction special						    */
extern char PII;			/* opt 71     Pour ecrire les fichiers PDB des PII					    */
extern char DBT;			/* opt 72     Pour un fichier output "simple" pour Dbk					    */
extern int NBCOL;			/* opt 73     For length columm in PDB files					    	    */
extern char DISTCA;			/* opt 74     For 					    	    			    */
extern char SEGNO;			/* opt 75     For Segno software					    	    	    */
extern char NODB;			/* opt 76     For Db problem					    	    		    */
extern char KAKSI;			/* opt 77     For Kaksi software					    	    	    */
extern char NACESS;			/* opt 78     For Nacess software					    	    	    */
extern char CYSDSSP;			/* opt 79     For Cysteine  - Cystine DSSP					    	    */
extern char NOMPDB;			/* opt 80     For PDB name	    						    	    */					
extern char nom_PDB[250];		/* opt 80     For PDB name							    	    */
extern char PYMOL;			/* opt 81     For PyMol	    						    		    */					
extern char SCWRL;			/* opt 82     For scwrl	    						    		    */					
extern char SCAP;			/* opt 83     For scwrl	    						    		    */					
extern char SCATD;			/* opt 84     For scwrl	    						    		    */					
extern char IRECS;			/* opt 85     For scwrl	    						    		    */					
extern char SCCOMP;			/* opt 86     For scwrl	    						    		    */					
extern char PDBbb;			/* opt 87 & 88 only backbone / bb et Cbeta                                                  */
					/********************************************************************************************/
extern int type_experim;
extern char SEARCH_WORDS;		/* True pour une recherche de certains mots */

