/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - UMR-S 726 INSERM)			      */
/******************************************************************************/
/*	pymol.c	(beta version 2007)				              */
/*	---------------							      */
/******************************************************************************/

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/lib_local_secstr.h"

char kaksiToPy(char s){
	char a;
	a='C';
	switch(s){
		case  ('H') : a='H'; break;
		case  ('.') : a='C'; break;
		case  ('B') : a='C'; break;
		}
	return(a);
}

char SecstrToPy(char s){
	char a;
	a='C';
	switch(s){
		case  ('H') : a='H'; break;
		case  (' ') : a='C'; break;
		}
	return(a);
}

char SegnoToPy(char s){
	char a;
	a='C';
	switch(s){
		case  ('H') : a='H'; break;
		case  ('O') : a='C'; break;
		}
	return(a);
}

char XtlToPy(char s){
	char a;
	a='C';
	switch(s){
		case  ('H') : a='H'; break;
		case  ('h') : a='H'; break;
		case  ('G') : a='H'; break;
		case  ('g') : a='H'; break;
		case  ('O') : a='C'; break;
		}
	return(a);
}

char BPToPy(short int s){
	char a;
	a='C';
	switch(s){
		case  (12) : a='H'; break;
		}
	return(a);
}


char PcurveToPy(char s){
	char a;
	a='C';
	switch(s){
		case  ('+') : a='H'; break;
		}
	return(a);
}

void pymol(pdbfile *m){
	
	FILE *fpy;
	int ypy;
	int ipy=0;
	char ThreeToPy[3]={'H','L','S'};
	char out[SIZE_Buffer];
	
	if(LECT_DSSP=='T'){
	sprintf(out,"Results/Rasta/%s-dssp.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol Dssp scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			/*printf("%d => %ld %d\n",ipy,m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,TroisEtatsDssp(m->S2dssp[ipy]));*/
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,ThreeToPy[TroisEtatsDssp(m->S2dssp[ipy])]);
		}
	}
	fclose(fpy);
	}
	
	
	if(LECT_STRIDE=='T'){
	sprintf(out,"Results/Rasta/%s-stride.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol Stride scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,ThreeToPy[TroisEtatsDssp(m->S2stride[ipy])]);
		}
	}
	fclose(fpy);
	}
	
	if(KAKSI=='T'){
	sprintf(out,"Results/Rasta/%s-kaksi.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol Kaksi scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,kaksiToPy(m->S2Kaksi[ipy]));
		}
	}
	fclose(fpy);
	}
	
	if(SEGNO=='T'){
	sprintf(out,"Results/Rasta/%s-segno.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol Segno scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,SegnoToPy(m->S2Segno[ipy]));
		}
	}
	fclose(fpy);
	}
	
	if(Fodje=='T'){
	sprintf(out,"Results/Rasta/%s-secstr.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol Secstr scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,SecstrToPy(m->S2Fodje[ipy]));
		}
	}
	fclose(fpy);
	}
	
	if(LECT_xtlsstr=='T'){
	sprintf(out,"Results/Rasta/%s-xtlsstr.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol Xtlsstr scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,XtlToPy(m->S2xtlsstr[ipy]));
		}
	}
	fclose(fpy);
	}
	
	if(LECT_PCURVE=='T'){
	sprintf(out,"Results/Rasta/%s-pcurve.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol pcurve scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,PcurveToPy(m->S2pcurve[ipy]));
		}
	}
	fclose(fpy);
	}
	sprintf(out,"Results/Rasta/%s-PB.pml",m->name);
	fpy=fopen(out,"w");
	for(ypy=0;ypy<((m->NB_chain)+1);ypy++){
	printf("PyMol PBs scripting here [%ld-%ld]\n",m->Pos_FirstRes[ypy],m->Pos_LastRes[ypy]);
		for(ipy=m->Pos_FirstRes[ypy];ipy<m->Pos_LastRes[ypy];ipy++){
			fprintf(fpy,"alter resi %ld, ss= \"%c\"\n",m->pdbatomtype[m->deb_residues[ipy]].ATOM_residuesnumber,BPToPy(m->Assign_PB[ipy]));
		}
	}
	fclose(fpy);
	
}
