# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/lib_local_secstr.h"
# include "secondary_structure.h"

short int ReadDbS2(pdbfile *m,short int state);
void RK_dssp(pdbfile *m, char out[SIZE_Buffer]);
void writechainHELA(pdbfile *m, char sys[SIZE_Buffer]);

void clean(char x[], int lg){
	int q;
	for(q=0;q<lg;q++)
		 x[q]='\0';
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/********************************************************************************************/
/*		Pour trouver ou est le repertoire des autres programmes			    */
/********************************************************************************************/

/*********************************************************************************************
				 exemple pour psea

#################################################################
#	Les autres programmes qui sont interfaces		#
#################################################################
#	Pour psea ==> psea:
#################################################################
psea:
INSTALL
Y
DIR
./Special/PSEA/psea
#################################################################

*********************************************************************************************/

/***##***/
/* XX02 */
/***##***/

int prgsearch(char *tofind, char *sortie){
	FILE *fx1;
	char buffer[SIZE_Buffer];
	int x1;
	
	fx1=flire("CODE/other_prog.txt");
	while(fgets(buffer,SIZE_Buffer,fx1)!=0){		/* prend chaque ligne et compte */
		/*printf(" deb |%s|%s|\n",buffer,tofind);*/
		if(strcmp(buffer,tofind)==0){
			/*printf("ok\n");*/
			fgets(buffer,SIZE_Buffer,fx1);
			/*printf("%s\n",buffer);*/
			fgets(buffer,SIZE_Buffer,fx1);
			if(buffer[0]=='Y'){ 
				/*printf("%s\n",buffer);*/
				fgets(buffer,SIZE_Buffer,fx1);
				/*printf("%s\n",buffer);*/
				fgets(buffer,SIZE_Buffer,fx1);
				for(x1=0;x1<strlen(buffer)-1;x1++)
				sortie[x1]=buffer[x1];
				p(sortie);
			return(0);
			}
			else return(1);	
		}
	}
	return(1);
}

char itisaa(char t){
	char ret='F';
	if((t>='A')&&(t<'Z'))ret='T';
	return(ret);
}


/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/********/
/* 0056 */	
/********/

void CompositionS2(pdbfile *m){		
	FILE *f56;
	long y21;
	long /*t21,*/i21/*,u21*/;
	int S2cp[4];	/* a cause des X de DSSP */
	int NbS2=0;

if(m->Nb_residues>0){
	for(y21=0;y21<4;S2cp[y21++]=0);
	NbS2=0;
	for(y21=0;y21<((m->NB_chain)+1);y21++){
		for(i21=m->Pos_FirstRes[y21];i21<m->Pos_LastRes[y21];i21++){
			S2cp[TroisEtatsDssp(m->S2dssp[i21])]++;
			NbS2++;
		}	
	}
	
	f56=fopen("Results/compos_S2.txt","a+");
		for(y21=0;y21<4;fprintf(f56,"%6.2f\t",100*((float)S2cp[y21++])/(float)NbS2));
	fprintf(f56,"\n");	
	fclose(f56);
	
	f56=fopen("Results/compos_S2c.txt","a+");	/* illisible */
	if((((float)S2cp[3])/(float)NbS2)>0.10)
		for(y21=0;y21<4;fprintf(f56,"%6.2f\t",0.00),y21++);
	fprintf(f56,"\n");	
	fclose(f56);
	
	f56=fopen("Results/compos_S2b.txt","a+");
	fprintf(f56,"%s%d %d\n",m->name,((m->NB_chain)+1),NbS2);
	fclose(f56);
	}
}

void writechain(pdbfile *m, char sys[SIZE_Buffer]){
	FILE *f06;
	int chain;
	long y06, deb, fin,nbres,nbline, nbcar;
	nbres=0;
	nbline=1;
	if(CHAIN=='-') { if(Werboze=='T') printf("chaine :*%c*\n",CHAIN);	
	chain=0;
	}
	else{
	chain=(int)(CHAIN)-(int)('A');;
	}
	
	deb=m->deb_residues[m->Pos_FirstRes[chain]];
	fin=m->end_residues[m->Pos_LastRes[chain]-1];
	
/*	printf("chain : %d deb: %ld fin :%ld %ld %ld [%ld]\n",chain,deb,fin,m->Pos_FirstRes[chain],m->Pos_LastRes[chain],m->deb_residues[m->Pos_LastRes[chain]]);
	
	printf("%ld %ld %ld %ld\n",m->deb_residues[m->Pos_FirstRes[chain]],m->end_residues[m->Pos_FirstRes[chain]],m->deb_residues[m->Pos_FirstRes[chain]+1],m->end_residues[m->Pos_FirstRes[chain]+1]);
	printf("%ld %ld %ld %ld\n",m->deb_residues[m->Pos_LastRes[chain]-1],m->end_residues[m->Pos_LastRes[chain]-1],m->deb_residues[m->Pos_FirstRes[chain]],m->end_residues[m->Pos_FirstRes[chain]]);
*/	f06=fecrire(sys);
	fprintf(f06,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',m->Pos_LastRes[chain]-m->Pos_FirstRes[chain]+1,m->resolution);
	
	/* 28 april 2005 false SEQRES for KAKSI */
	
	nbcar=13;
	for(y06=m->Pos_FirstRes[chain];y06<m->Pos_LastRes[chain]-1;){
		if(nbcar>=13) fprintf(f06,"SEQRES%4ld %6ld ",nbline,m->pdbatomtype[fin].ATOM_residuesnumber-m->pdbatomtype[deb].ATOM_residuesnumber+1);
		for(nbcar=0;nbcar<13;nbcar++,y06++){
			if((y06)>m->Pos_LastRes[chain]-1) 
			fprintf(f06,"%4s","    ");
			else fprintf(f06,"%4s",m->pdbatomtype[m->deb_residues[y06]].ATOM_residuesname);
			}
		fprintf(f06,"  153L%4ld\n",nbline);
		nbline++;
		}
	
		for(y06=deb;y06<fin;y06++){
			fprintf(f06,"ATOM  %5.0ld",y06+1);
			fprintf(f06,"  %-4s",m->pdbatomtype[y06].ATOM_name);
			fprintf(f06,"%3s  ",m->pdbatomtype[y06].ATOM_residuesname);
			fprintf(f06,"%4ld  ",m->pdbatomtype[y06].ATOM_residuesnumber);
			fprintf(f06,"  %8.3f%8.3f%8.3f                  153L%4ld\n",m->pdbatomtype[y06].ATOM_CoordX,m->pdbatomtype[y06].ATOM_CoordY,m->pdbatomtype[y06].ATOM_CoordZ,nbline);
			
			/*fprintf(f06,"                   %c \n",m->pdbatomtype[y06].ATOM_real);*/
			nbline++;
			}
		fprintf(f06,"END\n");	
		of(f06);
}		


/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/********************************************/
/* replacement des s2 dans les champs       */
/* pour DSSP, DSSPcont, DSSPextended, Fodje */
/********************************************/

void distribAAS2(pdbfile *m, int state, int nbaaseen, char *AA, char *S2, float *f){
	FILE *fdssp_suivi;
	long i2004,j2004,u;
	int pos;	
	long decal;
	
	long test1, test2;

	test1=0;test2=0;
	printf("step 02 : find the correspondance between AA - PB and AA - DSSP\n");

	pos=0;
	decal=0;
	
	for(i2004=0;i2004<nbaaseen;i2004++){
		if((m->Nam_residues[pos+decal]==AA[i2004])||(m->Nam_residues[pos+decal]=='X')||(state==20)){	/* if there's no problemo */
			switch (state){								/* mis pour Acces des Pus*/
				case  (0) : m->S2dssp[pos+decal]=S2[i2004]; 		break;
				case  (1) : m->S2dsspcont[pos+decal]=S2[i2004]; 	break;
				case  (2) : m->S2sea[pos+decal]=S2[i2004]; 		break;
				case  (7) : m->S2RKdssp[pos+decal]=S2[i2004]; 		break;
				case  (9) : m->S2Fodje[pos+decal]=S2[i2004]; 		break;
				case  (10) : m->S2Segno[pos+decal]=S2[i2004]; 		break;
				case  (20) : m->RelativeAccess[pos+decal]=f[i2004]; 	
					/*printf("%d %c %f\n",i2004,m->Nam_residues[pos+decal],m->RelativeAccess[pos+decal]);*/
					break;
			}
			pos++;
		}
		else{
		if((AA[i2004]=='!')||(AA[i2004]=='X')){
			switch (state){
				case  (0) : m->S2dssp[pos+decal]='U'; 		break;
				case  (1) : m->S2dsspcont[pos+decal]='U'; 	break;
				case  (2) : m->S2sea[pos+decal]='U'; 		break;
				case  (7) : m->S2RKdssp[pos+decal]='U'; 	break;
				case  (9) : m->S2Fodje[pos+decal]='U'; 		break;
				case  (10) : m->S2Segno[pos+decal]='U'; 	break;
				case  (20) : m->RelativeAccess[pos+decal]=999.999; 	break;				
				
			}
			if(V_DSSP=='T'){ 
			if(state==0)printf(" AA ILLISIBLE par DSSP %d (dssp) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dssp[pos+decal]);
			else printf(" AA ILLISIBLE par DSSPcont %d (dssp) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dsspcont[pos+decal]);
			}
			pos++;
			}
		else{
		if((AA[i2004]>='a')&&(AA[i2004]<='z')&&(m->Nam_residues[pos+decal]=='C')){  /* disulfide bonds */		
			
			 switch (state){
				 case  (0) : m->S2dssp[pos+decal]=S2[i2004];		
				 	     m->CysDSSP[pos+decal]=1;
						break;
				 case  (1) : m->S2dsspcont[pos+decal]=S2[i2004];	break;
				 case  (2) : m->S2sea[pos+decal]=S2[i2004];		break;
				 case  (7) : m->S2RKdssp[pos+decal]=S2[i2004];		break;
				 case  (9) : m->S2Fodje[pos+decal]=S2[i2004];		break;
				 case  (10) : m->S2Segno[pos+decal]=S2[i2004];		break;
 				 case  (20) : m->RelativeAccess[pos+decal]=f[i2004]; 	break;
			}
			pos++;
			
			printf("AA cystine %c => 'C'",AA[i2004]);
		}
		else {
			 switch (state){
			 case  (0) : printf(" AA pas bon par DSSP %d %4ld(dssp) %c AA (pdb) %c avec %c %c \n",pos,i2004,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dssp[pos+decal]);
				break;
			 case  (1) : printf(" AA pas bon par DSSPcont %d %4ld(dsspcont) %c AA (pdb) %c avec %c %c \n",pos,i2004,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dsspcont[pos+decal]);
				break;			 
			  case  (2) : printf(" AA pas bon par P-SEA %d %4ld(psea) %c AA (pdb) %c avec %c %c \n",pos,i2004,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2sea[pos+decal]);
				break;			 
			 case  (7) : printf(" AA pas bon par DSSPRK %d %4ld(dsspRK) %c AA (pdb) %c avec %c %c \n",pos,i2004,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2RKdssp[pos+decal]);
				break;		
			 case  (9) : printf(" AA pas bon par S2Fodje %d %4ld(fodje) %c AA (pdb) %c avec %c %c \n",pos,i2004,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2Fodje[pos+decal]);
				break;	
			 case  (10) : printf(" AA pas bon par S2Segno %d %4ld(segno) %c AA (pdb) %c avec %c %c \n",pos,i2004,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2Segno[pos+decal]);
				break;	
			 }
			
			
			
			if((AA[i2004]>='a')&&(AA[i2004]<='z'))AA[i2004]='C';
			
			for(j2004=0;j2004<nbaaseen/2;j2004++){
			
				test1=0;
				if(pos+5-j2004<nbaaseen){
				for(u=0;u<5;u++){
					if(m->Nam_residues[pos+u+j2004]!=AA[i2004+u]) test1++;
					printf("%4ld %c %c %d %4ld %4ld\n",j2004,m->Nam_residues[pos+u+j2004],AA[i2004+u],pos,u,test1);
					}
				}		
				else 	test1++;
				
				test2=0;
				if(pos-j2004>=0){
				for(u=0;u<5;u++){
					if(m->Nam_residues[pos+u-j2004]!=AA[i2004+u]) test2++;
					printf("%4ld %c %c %d %4ld %4ld\n",j2004,m->Nam_residues[pos+u-j2004],AA[i2004+u],pos,u,test2);
					}
				}
				else 	test2++;	
				
				if(test1==0) decal=j2004;
				if(test2==0) decal=(-j2004);
				if((test1==0)||(test2==0)) {j2004=nbaaseen; i2004--;} /* we must go out */
			}
			
		   if((test1!=0)&&(test2!=0)){	
			if(V_DSSP=='T') {
			
			switch (state){
				case  (0) : printf("NON COMPATIBLE AA %d (dssp) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dssp[pos+decal]);
				break;
				case  (1) : printf("NON COMPATIBLE AA %d (dsspcont) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dsspcont[pos+decal]);
				break;
				case  (2) : printf("NON COMPATIBLE AA %d (P-SEA) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2sea[pos+decal]);
				break;
				case  (7) : printf("NON COMPATIBLE AA %d (dssprk) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2RKdssp[pos+decal]);
				break;	
				case  (9) : printf("NON COMPATIBLE AA %d (S2Fodje) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2Fodje[pos+decal]);
				break;	
				case  (20) : printf("NON COMPATIBLE AA %d (Nacess) %c AA (pdb) %c avec %c %c \n",pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dssp[pos+decal]);
				break;	
											
			}
			
			}
		     	fdssp_suivi=fSurecrire("Results/Zx/dssp_pb.txt");
			if(state==0) fprintf(fdssp_suivi,"%s| AA %d (dssp) %c AA (pdb) %c avec %c %c \n",m->name,pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dssp[pos+decal]);
			else fprintf(fdssp_suivi,"%s| AA %d (cont) %c AA (pdb) %c avec %c %c \n",m->name,pos,AA[i2004],m->Nam_residues[pos+decal],S2[i2004],m->S2dsspcont[pos+decal]);
			of(fdssp_suivi);
			if(state==0) m->S2dssp[pos+decal]='U';
			else m->S2dsspcont[pos+decal]='U';
			pos++;
			}
		 else 	{
		 	printf("bon decalage bien trouve : %4ld %4ld \n",i2004,decal);}	
		     	}	
		}
		}
		
	}	
}	

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 00- DSSP */

/*********************************************************************************************/
/*			Assignation de la structure secondaire par DSSP		             */
/*********************************************************************************************/

void LectureFichierDsspS2(pdbfile *m,char *fich, int state){
	
	FILE *f0;
	long i47;
	char buffer[SIZE_Buffer];				/* Fichier DSSP de longeur == 136 au max */
	char search[SIZE_Buffer];				
	char *AA;
	char *S2;
	
	int nbaaseen=0;
	
	
	char lect='N';
	float *fff;
	fff=NULL;
	
	AA=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	S2=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);

	
	/*********************************/
	/* step 01 : all the AA are read */
	/*********************************/

	printf("step 01 : all the AA are read\n");
	f0=fopen(fich,"r");
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	
	for(i47=0;i47<SIZE_Buffer;search[i47++]='\0');
	for(i47=0;i47<16;i47++)
		search[i47]=buffer[i47];

	if(strcmp(search,"  #  RESIDUE AA ")==(0)){		/* on a bien trouver la banniere */
			/*printf("1-%s %s",search,buffer);*/
			lect='Y';
			fgets(buffer,SIZE_Buffer,f0);
			}
	if(lect=='Y'){
		/*	printf("AA |%c| S2 |%c|\n",buffer[POS_AA_DSSP],buffer[POS_S2_DSSP]);
		*/	AA[nbaaseen]=buffer[POS_AA_DSSP];
			S2[nbaaseen]=buffer[POS_S2_DSSP];
			nbaaseen++;
			if(nbaaseen+1>=NB_MAX_RES)
				nbaaseen--;
		}
	}
	fclose(f0);

	/*******************************************************************/
	/* step 02 : find the correspondance between AA - PB and AA - DSSP */
	/*******************************************************************/

	distribAAS2(m,state,nbaaseen,AA,S2,fff);
	
	free(AA);
	free(S2);
}

/************************************/
/* Lancement de DSSP - version CMBI */
/************************************/

void S2dssp(pdbfile *m){
	int i47;
	int last=0;
	char sys[SIZE_Buffer];
	char out[SIZE_Buffer];
	/*char *reppsea={"./Special/dssp/dssp"};*/
	char *reppsea={"/home/bergman/logiciels/BIN/dssp -ssa"};
	int test=0;
	
	if((RKstr=='T')&&(ReadDbS2(m,7)!=0))test=1;
	
	if((ReadDbS2(m,0)!=0)||(test==1)){
	
		for(i47=0;i47<SIZE_Buffer;sys[i47++]='\0');
	
		for(i47=0;i47<SIZE_Buffer;out[i47++]='\0');
	
		for(i47=0;i47<strlen(nom_fichier)-1;i47++)
			if(nom_fichier[i47]=='/') last=i47;
	
		for(i47=last+1;i47<strlen(nom_fichier)-4;i47++)
			out[i47-(last+1)]=nom_fichier[i47];
	
		printf("\n%s %d %d|%s|\n",nom_fichier,(int)strlen(nom_fichier),last,out);
	
		strcat(out,".dssp");
		
		sprintf(sys,"%s %s %s",reppsea,nom_fichier,out);
			
		printf("lancement de %s\n",sys);
	
		system(sys);
	
		printf("fin de %s\n",sys);
	
		LectureFichierDsspS2(m,out,0);
	
		for(i47=0;i47<SIZE_Buffer;sys[i47++]='\0');
	
		if(RKstr=='T'){		/* mettre str ici (Rachel Karchin) */
			RK_dssp(m,out);
			}
	
		clean(sys,SIZE_Buffer);
		/*sprintf(sys,"rm %s",out);*/
		system(sys);
	
	}

	if(HELANAL=='T') {
		if(ReadDbS2(m,6)!=0){
			printf("debut de writechainHELA\n");
			writechainHELA(m,"pdb1zob.ent");
			clean(sys,SIZE_Buffer);
			}
		}
}



/************************************/
/* Lancement de DSSP - version cont */
/************************************/

void S2dsspcont(pdbfile *m){
	int i47;
	int last=0;
	char sys[SIZE_Buffer];
	char out[SIZE_Buffer];
	/*char *repdssp={"/home/asterix/local/DSSP-2/"};*/
	
	for(i47=0;i47<SIZE_Buffer;sys[i47++]='\0');
	
	for(i47=0;i47<SIZE_Buffer;out[i47++]='\0');
	
	for(i47=0;i47<strlen(nom_fichier)-1;i47++)
		if(nom_fichier[i47]=='/') last=i47;
	
	for(i47=last+1;i47<strlen(nom_fichier)-4;i47++)
		out[i47-(last+1)]=nom_fichier[i47];

	sprintf(sys,"\nperl DSSPcont %s > test.out \n",nom_fichier);
	printf("4- %s",sys);
	
	system(sys);
	
	sprintf(out,"test.out");
	
	printf("5- %s",out);
	
	system(sys);
	
	LectureFichierDsspS2(m,out,1);
	
	for(i47=0;i47<SIZE_Buffer;sys[i47++]='\0');
	
	sprintf(sys,"rm %s",out);
	
	system(sys);
	
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 01- STRIDE */

/*********************************************************************************************/
/*		Assignation de la structure secondaire par Stride		             */
/*********************************************************************************************/


void LectureFichierStrideS2(pdbfile *m,char *fich){
	FILE *f0;
	int i48,j48;
	char buffer[SIZE_Buffer];				/* Fichier STRIDE de longeur == 136 au max */
	char search[SIZE_Buffer];				
	char S2[NB_MAX_RES];
	char AA[NB_MAX_RES];
	int nbchain=0;
	int lgchain;
	int pos;
	
	/* attention probleme; voir sos1-stride !!! */
	lgchain=0;
	printf("L0-%s\n",fich);printf("L0-%s\n",fich);
	
	
	
	for(i48=0;i48<NB_MAX_CHAIN;i48++)AA[i48]=S2[i48]='\0';
		
	f0=fopen(fich,"r");
	while(fgets(buffer,SIZE_Buffer,f0)!=(0)){		/* prend chaque ligne et compte */
	
	for(i48=0;i48<SIZE_Buffer;search[i48++]='\0');
	for(i48=0;i48<3;i48++)
		search[i48]=buffer[i48];

	/*printf("L1-%3d %s %s",lgchain[nbchain],search,buffer);*/
	if(strcmp(search,"ASG")==(0)){				/* on a bien trouver la banniere */
		for(i48=POS_AA_STRIDE;i48<POS_AA_STRIDE+3;i48++) search[i48-POS_AA_STRIDE]=buffer[i48];
		/*printf("%3d pour %d chaine avec AA |%c| %d %s S2 |%c|\n",lgchain,nbchain,AALogictrans((long)AAthreeToone(search)),AAthreeToone(search),search,buffer[POS_S2_STRIDE]);	*/
		AA[lgchain]=AALogictrans((long)AAthreeToone(search));
		S2[lgchain]=buffer[POS_S2_STRIDE];
		/*printf("%d %d %c %c\n",nbchain,lgchain,AA[lgchain],S2[lgchain]);*/
		/*printf("1-la chaine %d avec une longeur de %d\n",nbchain,lgchain);*/
		lgchain=lgchain+1;
		/*printf("2-la chaine %d avec une longeur de %d\n",nbchain,lgchain);*/
		if(lgchain+1>=NB_MAX_RES) {lgchain--; printf("argll STRIDE lgchain+1>=NB_MAX_RES\n");}
		/*printf("3-la chaine %d avec une longeur de %d\n",nbchain,lgchain);*/
		}
		
	}
	/*printf("nbchain : %d lgchain %d\n",nbchain,lgchain);*/
	/* A VOIR JE N"EN EST PAS FAIT ENCORE  ==> */	nbchain++;
	fclose(f0);
	
	
	
	if(V_STRIDE=='T') printf("avec %d acides amines [%d-%d]\n---\n|",lgchain,NB_MAX_CHAIN,NB_MAX_RES);
	pos=m->Pos_FirstRes[i48];
	printf("m->Pos_FirstRes[i48] %ld\n",m->Pos_FirstRes[i48]);
		for(j48=0;j48<lgchain;j48++){
		if(V_STRIDE=='T') printf("lgchain %d %d\n",lgchain,j48);		
		if(m->Nam_residues[pos]==AA[j48]){
			/*printf("aaaaaaaaaaaaaaaa %c\n",AA[j48]);*/
			/*printf("aaaaaaaaaaaaaaaa %c\n",S2[j48]);*/
			m->S2stride[pos]=S2[j48];
			if(V_STRIDE=='T')printf("AA %d (stride) %c AA (pdb) %c avec %c %c OK\n",pos,AA[j48],m->Nam_residues[pos],S2[j48],m->S2stride[pos]);
			}	
		else {  /*printf("bbbbbbbbbbbbbb %c\n",S2[j48]);*/
			if(V_STRIDE=='T') printf("NON COMPATIBLE AA %d (stride) %c AA (pdb) %c avec %c %c \n",pos,AA[j48],m->Nam_residues[pos],S2[j48],m->S2stride[pos]);
			}
		pos++;	
		}
		
		
	/*if(V_STRIDE=='T'){	
		for(j48=0;j48<lgchain[i48];j48++)
			printf("%c",AA[i48][j48]);
		printf("|\nS2:\n---\n|");
		for(j48=0;j48<lgchain[i48];j48++)
			printf("%c",S2[i48][j48]);
		printf("|\n");
		}*/
		

	
	
}

void S2stride(pdbfile *m){
	int i48;
	int last=0;
	char sys[SIZE_Buffer];
	char out[SIZE_Buffer];
	/*char *reppsea={"./Special/Stride/stride"};*/
	char *reppsea={" stride "};
	if(ReadDbS2(m,1)!=0){
	
	for(i48=0;i48<SIZE_Buffer;sys[i48++]='\0');
	
	for(i48=0;i48<SIZE_Buffer;out[i48++]='\0');
	
	for(i48=0;i48<strlen(nom_fichier)-1;i48++)
		if(nom_fichier[i48]=='/') last=i48;
	
	for(i48=last+1;i48<strlen(nom_fichier)-4;i48++)
		out[i48-(last+1)]=nom_fichier[i48];
	
	strcat(out,".stride");
	
	sprintf(sys,"%s %s -f%s",reppsea,nom_fichier,out);
		
	system(sys);
	
	printf("1-lecture de %s\n",out);
	
	LectureFichierStrideS2(m,out);
	
	for(i48=0;i48<SIZE_Buffer;sys[i48++]='\0');
	
	sprintf(sys,"rm %s",out);
	
	system(sys);
	}
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 02- PSEA */

/*********************************************************************************************/
/*		Assignation de la structure secondaire par P-SEA		             */
/*********************************************************************************************/

void OldLectureFichierSea(pdbfile *m,char *use){
	FILE *f0;
	int i,j;
	char buffer[Lg_buffer];				/*Fichier P-SEA de longeur == 80 au max */
	char AA[NB_MAX_CHAIN][NB_MAX_RES];
	char S2[NB_MAX_CHAIN][NB_MAX_RES];
	int nbchainaa=0;
	int nbchainS2=0;
	int lgchainaa[NB_MAX_CHAIN];
	int lgchains2[NB_MAX_CHAIN];
	short int iss2=0;
	short int cp=0;
/*	char nameprot[11];*/
	int maxlg=0;
	int nbsup=0;
	int pos;
	
	f0=flire(use);
	iss2=-1;
	while(fgets(buffer,Lg_buffer,f0)!=NULL){		/* prend chaque ligne et compte */

	cp=0;
	
	if((buffer[0]=='+')||(buffer[0]=='>')){
			if(buffer[0]=='>'){
				iss2++;
				}
			if((buffer[0]=='+')){
					if(iss2==0){
					if(lgchainaa[nbchainaa]>maxlg) maxlg=lgchainaa[nbchainaa];
					if(lgchainaa[nbchainaa]+5>NB_MAX_RES) nbsup++;
					nbchainaa++;}	
				else    nbchainS2++;


			}
		}	
	
			
	else    {
			if (iss2==0){
				while((cp<80)&&(buffer[cp+1]!='\0')){
					AA[nbchainaa][lgchainaa[nbchainaa]++]=buffer[cp++];
					if(lgchainaa[nbchainaa]+1>=NB_MAX_RES)
						lgchainaa[nbchainaa]--;

					}
				   }	
			else 	   {
				while((cp<80)&&(buffer[cp+1]!='\0')){
					S2[nbchainS2][lgchains2[nbchainS2]++]=buffer[cp++];
					if(lgchains2[nbchainS2]+1>=NB_MAX_RES)
						lgchains2[nbchainS2]--;

					}
				   }	
		}
	}
	nbchainaa++;nbchainS2++; /* pour le prochain tour*/
	fclose(f0);

	for(i=0;i<nbchainaa;i++){
	if(V_SEA=='T') printf("chaine %d avec %d acides amines\nAA:\n---\n|",i,lgchainaa[i]);
	pos=m->Pos_FirstRes[i];
		for(j=0;j<lgchainaa[i];j++){
		if(m->Nam_residues[pos]==AA[i][j]){
			m->S2sea[pos]=S2[i][j];
			if(V_SEA=='T')printf("AA %d (sea) %c AA (pdb) %c avec %c %c OK\n",pos,AA[i][j],m->Nam_residues[pos],S2[i][j],m->S2sea[pos]);
			}	
		else if(V_SEA=='T') printf("NON COMPATIBLE AA %d (sea) %c AA (pdb) %c avec %c %c \n",pos,AA[i][j],m->Nam_residues[pos],S2[i][j],m->S2sea[pos]);
		pos++;	
		}
		
		
	if(V_SEA=='T'){	for(j=0;j<lgchains2[i];j++)
			printf("%c",AA[i][j]);
		printf("|\nS2:\n---\n|");
		for(j=0;j<lgchains2[i];j++)
			printf("%c",S2[i][j]);
		printf("|\n");
		}
		
		pos++;		
		
		}
}


void LectureFichierSea(pdbfile *m,char *use){
	
	FILE *f0;
	long i_sea;
	char buffer[SIZE_Buffer];				/* Fichier DSSP de longeur == 136 au max */
	char *AA;
	char *S2;
	int true=0;
	int nbaaseen=0;
	int nbs2seen=0;
	float  *fff;
	fff=NULL;
	AA=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	S2=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);

	
	/*********************************/
	/* step 01 : all the AA are read */
	/*********************************/

	if(V_SEA=='T')printf("PSEA : all the AA / S2 must be read\n");
	
	
	f0=fopen(use,"r");
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	if(V_SEA=='T') printf("%d\n",true);
	
	if(buffer[0]=='>'){
			true++;
			}
	else {
	      if((true==1)&&(buffer[0]!='+')){ /* la squence */
	        i_sea=0;
	        while((buffer[i_sea]>=((int)('A')))&&(buffer[i_sea]<((int)('Z')))) {AA[nbaaseen]=buffer[i_sea];nbaaseen++; i_sea++;}	 
	      }
	
	if((true==2)&&(buffer[0]!='+')){ /* la structure */
	        i_sea=0;
	        while((buffer[i_sea]>=((int)('a')))&&(buffer[i_sea]<((int)('d')))) {S2[nbs2seen]=buffer[i_sea];nbs2seen++; i_sea++;}	      
	      }
	   }		
	}
	if(V_SEA=='T') printf("%d\n",true);
	fclose(f0);
	
	if(V_SEA=='T') printf("nbaaseen %d nbs2seen %d\n",nbaaseen,nbs2seen);
	
	if(V_SEA=='T') for(i_sea=0;i_sea<nbaaseen;i_sea++)printf("%ld %c %c\n",i_sea,AA[i_sea],S2[i_sea]);
	
	/*******************************************************************/
	/* step 02 : find the correspondance between AA - PB and AA - DSSP */
	/*******************************************************************/

	distribAAS2(m,2,nbaaseen,AA,S2,fff);
	
	free(AA);
	free(S2);
	
}

void S2sea(pdbfile *m){
	int i46;
	int last=0;
	char sys[SIZE_Buffer];
	char use[SIZE_Buffer];
	char reppsea[SIZE_Buffer];
	
	clean(sys,SIZE_Buffer);
	/*strcat(sys,"rm -rf *.sea");*/
	system(sys);
	clean(sys,SIZE_Buffer);
	
	if(ReadDbS2(m,2)!=0){
	
		clean(reppsea,SIZE_Buffer);
	
		if(prgsearch("psea:\n",reppsea)==0){
	
			for(i46=0;i46<SIZE_Buffer;sys[i46++]='\0');

			sprintf(sys,"%s %s",reppsea,nom_fichier);
		
			if (V_SEA=='T') printf("PEA 1- lancement de %s\n",sys);
	
			system(sys);
			system(sys);
	
			if (V_SEA=='T') printf("PEA 2- fin de %s\n",sys);
	
			clean(use,SIZE_Buffer);
	
			for(i46=0;i46<strlen(nom_fichier)-1;i46++)if(nom_fichier[i46]=='/') last=i46+1;
	
			for(i46=last;i46<strlen(nom_fichier)-4;i46++)
				use[i46-(last)]=nom_fichier[i46];
	
			if (V_SEA=='T') printf("PEA 3- last+1 %d\n",last+1);
	
			if (V_SEA=='T') printf("PEA 4- \n%s %d %d|%s|\n",nom_fichier,(int)strlen(nom_fichier),last,use);
		
			strcat(use,".sea");
	
			if (V_SEA=='T') printf("PEA 5- \n|%s|\n",use);
	
/*0046*/		LectureFichierSea(m,use);
	
			clean(sys,SIZE_Buffer);
	
			/*sprintf(sys,"rm -rf %s",use);*/
		if (V_SEA=='T') printf("PEA 6- \n|%s|\n",sys);
		system(sys);
		}
	else printf("P sea ne semble pas avoir ete installe ici\n");
	}
	
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 03- Define */

/*********************************************************************************************/
/*		Assignation de la structure secondaire par Define		             */
/*********************************************************************************************/
/*  Attention le fichier check.fil doit toujours etre dans le reperoitre ou tout est lance   */
/*********************************************************************************************/


void LectureFichierDefineS2(pdbfile *m,char *fich){
	FILE *f0;
	int i50,j50;
	char buffer[SIZE_Buffer];			
	char search[SIZE_Buffer];			
	char search2[SIZE_Buffer];				
/*	char AA[NB_MAX_CHAIN][NB_MAX_RES];
	char S2[NB_MAX_CHAIN][NB_MAX_RES];*/
	int nbchain=0;
	int lgchain[NB_MAX_CHAIN];
	char lectA='F';
	char lectB='F';
	int cpa=0;
	int cpb=0;
	int end,deb;
		
	f0=fopen(fich,"r");
	for(i50=0;i50<NB_MAX_CHAIN;i50++)
		lgchain[i50]=0;
		
	
	if(V_DEFINE=='T')	printf("DEFINE debut !!!\n");
	
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	
	for(i50=0;i50<SIZE_Buffer;search[i50++]='\0');
	for(i50=0;i50<25;i50++)
		search[i50]=buffer[i50];
	
	for(i50=0;i50<SIZE_Buffer;search2[i50++]='\0');
	for(i50=0;i50<10;i50++)
		search2[i50]=buffer[i50];

	/*printf("%3d %s %s",lgchain[nbchain],search,buffer);*/
	if(strcmp(search," SECND : HELIX DIMENSIONS")==(0)){				/* on a bien trouver la banniere */
		if(V_DEFINE=='T')	printf("ok pour alpha\n");
		lectA='T';
		}
	
	if(strcmp(search," SECND : STRAND DIMENSION")==(0)){				/* on a bien trouver la banniere */
		if(V_DEFINE=='T')	printf("ok pour beta\n");
		lectB='T'; lectA='B';
		}

	if((lectA=='B')&&(lectB=='T')){
		cpb++;
		if(cpb>=5){
			/*printf("%3d %s %s",lgchain[nbchain],search,buffer);	*/
			if(strcmp(search2,(" SECND :  "))==(0)){
		
		for(i50=0;i50<SIZE_Buffer;search2[i50++]='\0');
		for(i50=DEB_POS_DEFINE_1;i50<END_POS_DEFINE_1;i50++)
			search2[i50-DEB_POS_DEFINE_1]=buffer[i50];

			if(V_DEFINE=='T')printf("deb feuillet : %d\n",atoi(search2));
			deb=atoi(search2);
			
		for(i50=0;i50<SIZE_Buffer;search2[i50++]='\0');
		for(i50=DEB_POS_DEFINE_2;i50<END_POS_DEFINE_2;i50++)
			search2[i50-DEB_POS_DEFINE_2]=buffer[i50];
		
			if(V_DEFINE=='T')printf("end feuillet : %d\n",atoi(search2));		
			end=atoi(search2);
			
			for(i50=deb;i50<end;i50++)
				m->S2define[i50]='B';	
			
			}
		else 	{lectA='N';lectB='N';}
			
			}
			
		}
	
	if((lectA=='T')&&(lectB=='F')){
		cpa++;
		if(cpa>=5){
			/*printf("%3d %s %s",lgchain[nbchain],search,buffer);*/
			if(strcmp(search2,(" SECND :  "))==(0)){
		
		for(i50=0;i50<SIZE_Buffer;search2[i50++]='\0');
		for(i50=DEB_POS_DEFINE_1;i50<END_POS_DEFINE_1;i50++)
			search2[i50-DEB_POS_DEFINE_1]=buffer[i50];

			if(V_DEFINE=='T') printf("deb helice : %d\n",atoi(search2));
			deb=atoi(search2);
			
		for(i50=0;i50<SIZE_Buffer;search2[i50++]='\0');
		for(i50=DEB_POS_DEFINE_2;i50<END_POS_DEFINE_2;i50++)
			search2[i50-DEB_POS_DEFINE_2]=buffer[i50];
		
			if(V_DEFINE=='T')printf("end helice : %d\n",atoi(search2));		
			end=atoi(search2);
			
			for(i50=deb;i50<end;i50++)
				m->S2define[i50]='A';	
			
			}
		else 	lectA='N';
			
			}
		}

	/*printf("%5d %5d\n",cpa,cpb);*/
		
	}
	/* A VOIR JE N"EN EST PAS FAIT ENCORE  ==> */	nbchain++;
	fclose(f0);

	if(V_DEFINE=='T')	printf("DEFINE fin %d %d !!!\n",cpa, cpb);

	if((cpa>0)||(cpb>0)){
	for(i50=0;i50<m->NB_chain+1;i50++){
	if(V_DEFINE=='T')printf("Define nettoyage par le coil\n");
		for(j50=m->Pos_FirstRes[i50];j50<m->Pos_LastRes[i50];j50++){
			printf("%c\t",m->S2define[j50]);
			if((m->S2define[j50]=='U')||(m->S2define[j50]=='X')){
				m->S2define[j50]='C';
			}		
			printf("==> %c\n",m->S2define[j50]);		
			}				
		}
	}
		
	if(V_DEFINE=='T'){	
		printf("|\nS2:\n---\n|");
		for(i50=0;i50<m->NB_chain+1;i50++){
		for(j50=m->Pos_FirstRes[i50];j50<m->Pos_LastRes[i50];j50++)
			printf("%c",m->S2define[j50]);	
		printf("|\n");
		}
	
	}
		
	if(V_DEFINE=='T')	printf("DEFINE out !!!\n");
}

void S2define(pdbfile *m){
	int i50;
/*	int last=0;*/
	char sys[SIZE_Buffer];
/*	char use[SIZE_Buffer];*/
	char out[SIZE_Buffer];
	char *repdefine={"./Special/dfnstruc_v2/"};	/* repertoire de define */
	/* esai louip char *repdefine={"/home/glenan/logiciels/define/"};*/
	
	
	/*char *head={"ligne.header"};	*/		/* un fichier avec un faux header pour define */
/*	reproduit ici :
HEADER    UBIQUITIN CONJUGATION                   06-NOV-97   TEST
*/
	char *fichier_execution={"submit2"};		/* un fichier avec un faux header pour define */
/*	reproduit ici :	define est le binaire
echo "test.pdb\ntest.out\ntest.header\ntest.struct\nN\nN\nN\nN\nN\nN\ntest.ps\n"|define
*/	


	if(ReadDbS2(m,3)!=0){

	for(i50=0;i50<SIZE_Buffer;sys[i50++]='\0');

	sprintf(sys,"%stest.pdb",repdefine);
	printf("sys :%s",sys);
	system(sys);

	writechain(m,sys);

	/*sprintf(sys,"nedit %stest.pdb &",repdefine);	system(sys);*/
	
	sprintf(sys,"cp %schek.fil .",repdefine);
	system(sys);
	
	/*	sprintf(sys,"rm -rf %stest*",repdefine);*/

	if(V_DEFINE=='T')	printf("0- %s\n",sys);

	system(sys);
	
	for(i50=0;i50<SIZE_Buffer;sys[i50++]='\0');

	for(i50=0;i50<SIZE_Buffer;sys[i50++]='\0');

	sprintf(sys,"%s%s",repdefine,fichier_execution);
	
	if(V_DEFINE=='T')	printf("1- %s\n",sys);	
	
	system(sys);
	
	sprintf(out,"%s/test.out",repdefine);
		
	LectureFichierDefineS2(m,out);

	/*sprintf(sys,"nedit %s/test*",repdefine);	system(sys);*/

/*	sprintf(sys,"rm -rf %s/test*",repdefine);

	system(sys);
*/
/*	sprintf(sys,"rm chek.fil");	system(sys);*/

	}
}


/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 04- Pcurve */

/*********************************************************************************************/
/*		Assignation de la structure secondaire par P-curve		             */
/*********************************************************************************************/

void LectureFichierPcurveS2(pdbfile *m,char *fich){
	FILE *f0;
	int i51,j51;
	char buffer[SIZE_Buffer];			
	char search[SIZE_Buffer];			
	char search2[SIZE_Buffer];				
/*	char AA[NB_MAX_CHAIN][NB_MAX_RES];
	char S2[NB_MAX_CHAIN][NB_MAX_RES];
	int nbchain=0;*/
/*	int lgchain[NB_MAX_CHAIN];*/
	char lectH='F';
	int cpp=0;
	int pos;
	
	f0=fopen(fich,"r");
	/*for(i51=0;i51<NB_MAX_CHAIN;i51++)
		lgchain[i51]=0;*/
		
	if(CHAIN=='-') {printf("chaine :*%c*\n",CHAIN);	
	i51=0;
	}
	else{
	i51=(int)(CHAIN)-(int)('A');;

	}
		

	pos=m->Pos_FirstRes[i51];	/* a nettoyer */
	
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	
	for(i51=0;i51<SIZE_Buffer;search[i51++]='\0');
	for(i51=0;i51<34;i51++)
		search[i51]=buffer[i51];
	
	if(strcmp(search,"  Residues   No.    SDL     SDC   ")==(0)){				/* on a bien trouver la banniere */
		if(V_PCURVE=='T')	printf("fini la lecture des S2\n");
		lectH='P';
	}
	else
	if(strcmp(search,"  Location of secondary structures")==(0)){				/* on a bien trouver la banniere */
		if(V_PCURVE=='T')	printf("ok pour le header des structures secondaires\n");
		lectH='T';
		cpp=-1;	
		}
	/*printf("0 %d\t",cpp);*/
	if(lectH=='T')	cpp++;
	/*printf("1 %d\t",cpp);	*/
	if((lectH=='T')&&(cpp==3)){
	
	for(j51=0;j51<MAXL_IGN_PCURVE;j51++)
		search2[j51]=buffer[j51];
	/*	printf(" OK %s\t",cpp,search2);	*/
		}
	/*printf("2 %d\n",cpp);	*/
	if((lectH=='T')&&(cpp==4)){
		
		printf("A*%s*\nB*%s*\n",buffer,search2);
		

		for(j51=2;j51<MAXL_IGN_PCURVE;j51++){
			if(itisaa(search2[j51])=='T'){
			if(m->Nam_residues[pos]==search2[j51]){
				m->S2pcurve[pos]=buffer[j51];
if(V_PCURVE=='T')
		printf("AA %d (pcurve) %c AA (pdb) %c avec %c %c OK\n",pos,search2[j51],m->Nam_residues[pos],buffer[j51],m->S2pcurve[pos]);
				}
			else	{
	/*		 	j51=MAXL_IGN_PCURVE;*/
if(V_PCURVE=='T')
		printf("ARGLLL PAS en %d pour AA %d (pcurve) %c AA (pdb) %c avec %c \n",pos,search2[j51],m->Nam_residues[pos],buffer[j51],m->S2pcurve[pos]);
				
			 	}
			pos++;
			}
		}	
			
		cpp=0;	
		}
	}
}	


void S2pcurve(pdbfile *m){
	
	int i50;
	char sys[SIZE_Buffer];
	char *reppcurve={"./Special/pcurve/"};		/* repertoire de pcurve */
	/* loup char *reppcurve={"/home/glenan/logiciels/P-CURVE/"};	*/	/* repertoire de pcurve */
	
/*	char *head={"ligne.header"};*/			/* un fichier avec un faux header pour pcurve */

	char *fichier_execution={"submit"};		/* un fichier avec un faux header pour pcurve */
	
	
	
/*	reproduit ici :	pcur_h est le binaire
rm out.*
Special/pcurve/Pcur_h <<!
 &inp file='Special/pcurve/test.pdb',spline=3,lis='out',mini=.t.,pdb='out', & 
!
*/	

	if(ReadDbS2(m,4)!=0){

	printf("Ecriture pour PCURVE !!\n");
	sprintf(sys,"rm %stest.pdb",reppcurve);
	
	if(V_PCURVE=='T')	printf("0- %s\n",sys);

	sprintf(sys,"%stest.pdb",reppcurve);
	
	writechain(m,sys);
	
	/*sprintf(sys,"nedit %stest.pdb &",reppcurve); system(sys);*/

	for(i50=0;i50<SIZE_Buffer;sys[i50++]='\0');

	sprintf(sys,"%s%s",reppcurve,fichier_execution);
	
	system(sys);

	/*sprintf(sys,"nedit out.lis &");
	system(sys);
	*/
	LectureFichierPcurveS2(m,"out.lis");
	
	
	for(i50=0;i50<SIZE_Buffer;sys[i50++]='\0');
		
	sprintf(sys,"rm %s.*","out");

	/*system(sys);*/
	
/*	sprintf(sys,"nedit out.lis &");
	system(sys);*/
	}
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 05- xtlsstr */

void LectureFichierXTLSSTRS2(pdbfile *m,char *fich){
	FILE *f0;
	int i,j,i51,j51;
	char buffer[SIZE_Buffer];			
	char search[SIZE_Buffer];			
	char search2[SIZE_Buffer];				
	long nbligne=0;
	long ligneutile=0;
	/*char AA[NB_MAX_CHAIN][NB_MAX_RES]; meme pepin !!!
	char S2[NB_MAX_CHAIN][NB_MAX_RES];*/
	char AA[NB_MAX_RES]; 
	char S2[NB_MAX_RES];
	
	
	int nbres[NB_MAX_CHAIN];
	int numchain,pos;
	
	printf("xtl 1\n");
	
	for(i51=0;i51<NB_MAX_CHAIN;nbres[i51++]=0);
	
	printf("xtl 2 fich %s\n",fich);
	
	f0=flire(fich);
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){
	nbligne++;
	}
	of(f0);

	printf("xtl 3\n");

	ligneutile=nbligne-5; /* header  */
	ligneutile/=4;

	printf("%5ld lignes %5ld \n",nbligne,ligneutile);
	numchain=0;
	f0=flire(fich);	
	
	for(i51=0;i51<5;i51++){
		fgets(buffer,SIZE_Buffer,f0);
		}
	for(i51=0;i51<ligneutile+1;i51++){		
		fgets(search,SIZE_Buffer,f0);
		fgets(search2,SIZE_Buffer,f0);
		printf("%s %s",search,search2);
		printf("%c %c %c\n",search2[1],search[15],search2[15]);
		numchain=(int)(search2[1])-(int)('1');
		printf("%d\n",numchain);
		for(j51=10;j51<65;j51++){
			if((search2[j51]=='\n')||(search2[j51]=='\0')){
			j51=150;
			}
			else {if(itisaa(search2[j51])=='T'){
				AA[nbres[numchain]]=search2[j51];
				S2[nbres[numchain]]=search[j51];
				nbres[numchain]++;
				}
			}
		}
		if(i51<ligneutile){fgets(buffer,SIZE_Buffer,f0);fgets(buffer,SIZE_Buffer,f0);}
	}
	of(f0);
	
	/*printf("%d\n",nbres[0]);
	for(i51=0;i51<nbres[0];i51++)
		printf("%5d %c %c\n",i51,AA[0][i51],S2[0][i51]);*/
		
	for(i=0;i<numchain+1;i++){
	/*printf("XTL chaine %d avec %d acides amines\nAA:\n---\n|",i,nbres[i]);*/
	pos=m->Pos_FirstRes[i];
		for(j=0;j<nbres[i];j++){
		if(m->Nam_residues[pos]==AA[j]){
			m->S2xtlsstr[pos]=S2[j];
			/*printf("XTL AA %d (sea) %c AA (pdb) %c avec %c %c OK\n",pos,AA[i][j],m->Nam_residues[pos],S2[i][j],m->S2xtlsstr[pos]);*/
			}	
		else  printf("XTL NON COMPATIBLE AA %d (sea) %c AA (pdb) %c avec %c %c \n",pos,AA[j],m->Nam_residues[pos],S2[j],m->S2xtlsstr[pos]);
		pos++;	
		}		
	}	
		
}



void S2xtlsstr(pdbfile *m){
	char sys[SIZE_Buffer];
	char out[SIZE_Buffer];

	if(ReadDbS2(m,5)!=0){
		
	clean(sys,SIZE_Buffer);	clean(out,SIZE_Buffer);
	
	sprintf(out,"cp %s test.pdb",nom_fichier);
	printf("sys :%s\n",out);
	system(out);

	/*writechain(m,out);*/

	sprintf(sys,"xtlsstr <<!\n%s\n!\n","test.pdb");
	
	printf("xtllstr: %s\n",sys);
	
	printf("one a one 1 \n");
	system(sys);
	
	printf("one a one 2 \n");
	
	LectureFichierXTLSSTRS2(m,"test.pd.vtr");
	
	clean(out,SIZE_Buffer);
	sprintf(out,"rm -rf test.pdb test.pd.*");
	
	printf("one a one 3\n");
	
	printf("sys :%s\n",out);
	system(out);
	}
	
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 06- helanal */

void ReadHELA(pdbfile *m,long debh[100], long finh[100], long posy1[100], long posy2[100], long nbhelix, char *sys){
	FILE *fhel;
	long i,j,u89;
	long localdeb;
	long localfin;
	char localaadeb;
	char localaafin;
	char type='X';
	char test='X';
	char buffer[SIZE_Buffer];
	char buffer2[SIZE_Buffer];
	
	fhel=flire(sys);
	
	for(i=0;i<3;i++){
		fgets(buffer,SIZE_Buffer,fhel);	/*printf("%s",buffer);*/
		}
	
	/*for(i=0;i<nbhelix;i++)
		printf(" %4d %ld %ld %c %ld  %ld%c\n",i,debh[i],posy1[i],m->Nam_residues[posy1[i]],finh[i],posy2[i],m->Nam_residues[posy2[i]]);*/
	
	
	for(i=0;i<nbhelix;i++){
		fgets(buffer,SIZE_Buffer,fhel);/*	printf("ici : %s",buffer);*/
		if(buffer[1]=='p'){
			/* printf("ok\n");*/
			 clean(buffer2,SIZE_Buffer);
			 for(j=0;j<4;j++) buffer2[j]=buffer[j+14];
			 /*printf("%s => %d\n",buffer2,atoi(buffer2));*/
			 localdeb=atoi(buffer2);
			 localaadeb=buffer[j+14];
			 for(j=0;j<4;j++) buffer2[j]=buffer[j+21];
			/* printf("%s => %d\n",buffer2,atoi(buffer2));*/
			 localfin=atoi(buffer2);
			 localaafin=buffer[j+21];		
 			 type=buffer[73];	
			 /*printf("%ld %c %ld %c %c\n",localdeb,localaadeb,localfin,localaafin,type);*/
			 test='F';
			 while(test=='F'){
			 	if(((debh[i])!=localdeb)||((finh[i])!=localfin)||((m->Nam_residues[posy1[i]])!=localaadeb)||((m->Nam_residues[posy2[i]])!=localaafin)){
					i++;
					if(i==nbhelix) test='X';
					}
				else test='T';	
				}
			if(test=='T'){
				printf("ok\n");
				for(u89=posy1[i];u89<posy2[i]+1;u89++){
					m->S2dssphel[u89]=type;
					}
				
				}
			else 	printf("%c\n",test);
			 }
		else i=nbhelix;
		fgets(buffer2,SIZE_Buffer,fhel);	
	}
	
	of(fhel);

}

void writechainHELA(pdbfile *m, char sys[SIZE_Buffer]){
	FILE *f06;
	int chain;
	long y06, deb, fin,nbres;
	long nbalphahelix;
	long debh[100],finh[100];
	long posy1[100],posy2[100];
	char buffer[SIZE_Buffer];

for(chain=0;chain<((m->NB_chain)+1);chain++){
		
	nbres=0;

	/*if(CHAIN=='-') {printf("chaine :*%c*\n",CHAIN);	
	chain=0;
	}
	else{
	chain=(int)(CHAIN)-(int)('A');;

	}*/
	
	
	f06=fecrire(sys);
	fprintf(f06,"HEADER    FERTILIZATION PROTEIN                   29-JUN-93   1ZOB      1ZOB   2\n");
	
	nbalphahelix=1;
	deb=-1;
	fin=-1;
	for(y06=m->Pos_FirstRes[chain];y06<m->Pos_LastRes[chain];y06++){
		if(m->S2dssp[y06]=='H'){
			if(deb==(-1)){
				deb=y06;
				/*printf("%ld %c deb %ld fin %ld\n",y06,m->S2dssp[y06],deb,fin);*/
				}
				m->S2dssphel[y06]=m->S2dssp[y06];
			}
		else {
			m->S2dssphel[y06]='-';
		     	if(deb!=(-1)){
				fin=y06-1;
				printf("%ld %c deb %ld fin %ld\n",y06,m->S2dssp[y06],deb,fin);
				fprintf(f06,"HELIX  %3ld %3ld %3s   %4ld  %3s   %4ld  1                                1ZOB  49\n",nbalphahelix,nbalphahelix,m->pdbatomtype[m->deb_residues[deb]].ATOM_residuesname,m->pdbatomtype[m->deb_residues[deb]].ATOM_residuesnumber,m->pdbatomtype[m->deb_residues[fin]].ATOM_residuesname,m->pdbatomtype[m->deb_residues[fin]].ATOM_residuesnumber);
				debh[nbalphahelix-1]=m->pdbatomtype[m->deb_residues[deb]].ATOM_residuesnumber;
				finh[nbalphahelix-1]=m->pdbatomtype[m->deb_residues[fin]].ATOM_residuesnumber;
				posy1[nbalphahelix-1]=deb;
				posy2[nbalphahelix-1]=fin;
				deb=-1;
				fin=-1;
				nbalphahelix++;
			}
		     }	
		
	}
	
	if(deb!=-1) {
	fin=y06-1;
	fprintf(f06,"HELIX  %3ld %3ld %3s   %4ld  %3s   %4ld  1                                1ZOB  49\n",nbalphahelix,nbalphahelix,m->pdbatomtype[m->deb_residues[deb]].ATOM_residuesname,m->pdbatomtype[m->deb_residues[deb]].ATOM_residuesnumber,m->pdbatomtype[m->deb_residues[fin]].ATOM_residuesname,m->pdbatomtype[m->deb_residues[fin]].ATOM_residuesnumber);
	debh[nbalphahelix]=m->pdbatomtype[m->deb_residues[deb]].ATOM_residuesnumber;
	finh[nbalphahelix]=m->pdbatomtype[m->deb_residues[fin]].ATOM_residuesnumber;
	posy1[nbalphahelix-1]=deb;
	posy2[nbalphahelix-1]=fin;
	nbalphahelix++;			
	}
	
	
/*	
HELIX    1   1 LYS     13  HIS     38  1                                1ZOB  49
HELIX    2   2 THR     44  ASP     74  1 KINK AT HIS 61                 1ZOB  50
HELIX    3   3 VAL     82  ARG     95  1                                1ZOB  51
HELIX    4   4 ALA     99  ASP    107  1                                1ZOB  52
*/
	deb=m->deb_residues[m->Pos_FirstRes[chain]];
	fin=m->end_residues[m->Pos_LastRes[chain]-1];
	
	/*printf("chain : %d deb: %ld fin :%ld %ld %ld [%ld]\n",chain,deb,fin,m->Pos_FirstRes[chain],m->Pos_LastRes[chain],m->deb_residues[m->Pos_LastRes[chain]]);
	
	printf("%ld %ld %ld %ld\n",m->deb_residues[m->Pos_FirstRes[chain]],m->end_residues[m->Pos_FirstRes[chain]],m->deb_residues[m->Pos_FirstRes[chain]+1],m->end_residues[m->Pos_FirstRes[chain]+1]);
	printf("%ld %ld %ld %ld\n",m->deb_residues[m->Pos_LastRes[chain]-1],m->end_residues[m->Pos_LastRes[chain]-1],m->deb_residues[m->Pos_FirstRes[chain]],m->end_residues[m->Pos_FirstRes[chain]]);
	*/
	
		for(y06=deb;y06<fin;y06++){
			fprintf(f06,"ATOM  %5.0ld ",y06+1);
			fprintf(f06," %-3s",m->pdbatomtype[y06].ATOM_name);
			fprintf(f06," %3s ",m->pdbatomtype[y06].ATOM_residuesname);
			fprintf(f06," %4ld ",m->pdbatomtype[y06].ATOM_residuesnumber);
			fprintf(f06,"  %8.2f%8.2f%8.2f  ",m->pdbatomtype[y06].ATOM_CoordX,m->pdbatomtype[y06].ATOM_CoordY,m->pdbatomtype[y06].ATOM_CoordZ);
			fprintf(f06,"                 1ZOB%4ld\n",y06+1);
			}
		fprintf(f06,"TER\n");	
		of(f06);
		
		
	clean(buffer,SIZE_Buffer);		
	strcat(buffer,"helanal << !\ny\ny\npdb1zob.ent\n\nn\n!\n");
	system(buffer);
		
	ReadHELA(m,debh,finh,posy1,posy2,nbalphahelix-1,"pdb1zob.tab");
		
	clean(buffer,SIZE_Buffer);
	strcat(buffer,"rm -rf pdb1zob.ent helinfo.out pdb1zob.tab pdb1zob.prm origin.out nh.out helca.out axes.out angle.out RUN.ANS\n");
}
}		

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/* 07- DSSP extended (Rachel Karchin) */

void RK_dssp(pdbfile *m, char out[SIZE_Buffer]){
	
	FILE *f0;
	char systm[SIZE_Buffer];
	char buffer[SIZE_Buffer];
	char chain;
	long yrk;
	char *AA;
	char *S2;
	long nbaaseen;
	float *fff;
		fff=NULL;
	AA=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	S2=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	nbaaseen=0;
	
	 /* 1- on copie le dssp dans 1aaa.dssp*/
	
	 clean(systm,SIZE_Buffer);
	 sprintf(systm,"cp %s 1aaa.dssp ",out);
	 system(systm);
	 
	 clean(systm,SIZE_Buffer);
	 
	 for(yrk=0;yrk<((m->NB_chain)+1);yrk++){
		 if((m->NB_chain)==0)	chain='_';
		 else chain=(char)(((int)('A'))+yrk);
	 
		 sprintf(systm,"build-str-string_adb 1aaa%c < 1aaa.dssp > output.kar ",chain);
		/* printf("RK de %s %d\n",systm,m->NB_chain);*/
		 system(systm);
		 /*clean(systm,SIZE_Buffer);
		 sprintf(systm,"nedit output.kar %s &",out);
		 system(systm);*/
		 
		 /*lire et comparer */
		f0=fopen("output.kar","r");
		while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */

			/*printf("buffer |%s] AA |%c| S2 |%c|\n",buffer,buffer[POS_AA_RK_DSSP],buffer[POS_S2_RK_DSSP]);*/
			AA[nbaaseen]=buffer[POS_AA_RK_DSSP];
			S2[nbaaseen]=buffer[POS_S2_RK_DSSP];
			nbaaseen++;
			if(nbaaseen+1>=NB_MAX_RES)
				nbaaseen--;
		}
	
		fclose(f0);

		clean(systm,SIZE_Buffer);
		sprintf(systm,"rm -rf output.kar ");
		system(systm);
	 }
 	distribAAS2(m,7,nbaaseen,AA,S2,fff);
	
	free(AA);
	free(S2);
		
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/

/**********************************************/
/* 09 - SecStr (Fodje et Al. K 2002 Prot Eng) */
/**********************************************/

void LectureFichierS2FodjeAlK(pdbfile *m, char *name, int state){

	FILE *f0;
	long vcompt;
	char buffer[SIZE_Buffer];
	char search[SIZE_Buffer];	
	char sequ[SIZE_Buffer];
	char stru[SIZE_Buffer];	
	char beta[SIZE_Buffer];		
	char *AA;
	char *S2;
	float *fff;
	
	int nbaaseen=0;

	char seq='N';
	char strct='N';
	char bet='N';

		fff=NULL;
	
	AA=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	S2=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);

	
	/*********************************/
	/* step 01 : all the AA are read */
	/*********************************/

	/*printf("Fodje step 01 : all the AA are read\n");*/
	f0=fopen(name,"r");
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	
	for(vcompt=0;vcompt<SIZE_Buffer;search[vcompt++]='\0');
	for(vcompt=0;vcompt<8;vcompt++)
		search[vcompt]=buffer[vcompt];

	if(strcmp(search,"SEQUENCE")==(0)){		/* on a bien trouver la banniere */
			/*printf("1-%s %s",search,buffer);*/
			seq='Y';
			/*printf("sequence :%s\n",buffer);*/
			for(vcompt=0;vcompt<SIZE_Buffer;sequ[vcompt++]='\0');
			for(vcompt=0;vcompt<SIZE_Buffer;vcompt++)sequ[vcompt]=buffer[(vcompt+POS_FODJE_DEB)];
			/*printf("sequence :|%s]\n",sequ);*/
			}
			
			  
	if(strcmp(search,"SUMMARY.")==(0)){		/* on a bien trouver la banniere */
			/*printf("1-%s %s",search,buffer);*/
			strct='Y';
			/*printf("struct :%s\n",buffer);*/
			for(vcompt=0;vcompt<SIZE_Buffer;stru[vcompt++]='\0');
/*pb ici*/			for(vcompt=0;vcompt<SIZE_Buffer;vcompt++)stru[vcompt]=buffer[vcompt+POS_FODJE_DEB];
			
			}

	if(strcmp(search,"STRANDS.")==(0)){		/* on a bien trouver la banniere */
			/*printf("1-%s %s",search,buffer);*/
			bet='Y';
			/*printf("struct :%s\n",buffer);*/
			for(vcompt=0;vcompt<SIZE_Buffer;beta[vcompt++]='\0');
			for(vcompt=0;vcompt<SIZE_Buffer;vcompt++)beta[vcompt]=buffer[vcompt+POS_FODJE_DEB];
			
			}
			
	if((seq=='Y')&&((strct=='Y'))&&(bet=='Y')){
			for(vcompt=0;vcompt<SIZE_Buffer;vcompt++){
				AA[nbaaseen]=sequ[vcompt];
				S2[nbaaseen]=' ';
				if((stru[vcompt]=='H')||(stru[vcompt]=='G')||(stru[vcompt]=='I'))S2[nbaaseen]=stru[vcompt];
				if(beta[vcompt]=='E')S2[nbaaseen]=beta[vcompt];
				if(beta[vcompt]=='e')S2[nbaaseen]=beta[vcompt];
				nbaaseen++;
				if(nbaaseen+1>=NB_MAX_RES)
					nbaaseen--;
				if(((int)sequ[vcompt+1]<(int)'A')||((int)sequ[vcompt+1]>(int)'Z'))vcompt=SIZE_Buffer+1;
					
			}
			seq='N';
			bet='N';
			strct='N';	
		}
	}
	fclose(f0);

	/*for(vcompt=0;vcompt<nbaaseen;vcompt++)printf("%4ld %c |%c|\n",vcompt,AA[vcompt],S2[vcompt]);*/
	

	/*******************************************************************/
	/* step 02 : find the correspondance between AA - PB and AA - DSSP */
	/*******************************************************************/

	distribAAS2(m,state,nbaaseen,AA,S2,fff);
	
	free(AA);
	free(S2);
}

void S2FodjeAlK(pdbfile *m){

	int i47;
	int last=0;
	char sys[SIZE_Buffer];
	char out[SIZE_Buffer];
	
	printf("1\n");
	
	if(ReadDbS2(m,9)!=0){
	printf("2\n");
		for(i47=0;i47<SIZE_Buffer;sys[i47++]='\0');
	
		for(i47=0;i47<SIZE_Buffer;out[i47++]='\0');
	
		for(i47=0;i47<strlen(nom_fichier)-1;i47++)
			if(nom_fichier[i47]=='/') last=i47;
	
		for(i47=last+1;i47<strlen(nom_fichier)-4;i47++)
			out[i47-(last+1)]=nom_fichier[i47];
	
		sprintf(out,"secstr -detail %s > secstr.txt \n",nom_fichier);
		system(out);
	
		LectureFichierS2FodjeAlK(m,"secstr.txt",9);
		sprintf(out,"rm secstr.txt \n");
		system(out);
	}
	
	printf("3\n");
}

/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/
/*************************************************************************************************************************************************************************/


void LectureFichierSegno2(pdbfile *m,char *fich, int state){
	
	FILE *f0;
	long i47;
	char buffer[SIZE_Buffer];				
	char *AA;
	char *S2;
	char AA3[4];
	float *fff;
	
	int nbaaseen=0;
	
	fff=NULL;
	
	AA=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	S2=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);

	AA3[3]='\n';
	
	/*********************************/
	/* step 01 : all the AA are read */
	/*********************************/

	printf("step 01 : all the AA are read\n");
	f0=fopen(fich,"r");
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	
		for(i47=0;i47<3;i47++)
			AA3[i47]=buffer[POS_AA_SEGNO_deb+i47];
			
		AA[nbaaseen]=AALogictrans(AAthreeToone(AA3));
		S2[nbaaseen]=buffer[POS_S2_SEGNO];

	/*	printf("here => %d[%c[%c]\n%s",SIZE_Buffer,S2[nbaaseen],AA[nbaaseen],buffer);*/
		nbaaseen++;
		if(nbaaseen+1>=NB_MAX_RES)
		nbaaseen--;
		
	}
	fclose(f0);

	/*******************************************************************/
	/* step 02 : find the correspondance between AA - PB and AA - SEGNO */
	/*******************************************************************/

	distribAAS2(m,state,nbaaseen,AA,S2,fff);
	
	free(AA);
	free(S2);
}

void S2Segno(pdbfile *m){
	char sys[SIZE_Buffer];
	char out[SIZE_Buffer];

	/*if(ReadDbS2(m,10)!=0){*/
		
	clean(sys,SIZE_Buffer);	clean(out,SIZE_Buffer);
	
	sprintf(out,"cp %s test.pdb",nom_fichier);
	printf("SEGNO sys :%s\n",out);
	system(out);

	sprintf(sys,"segno -pdb test.pdb > test.segno");

	system(sys);
	
	LectureFichierSegno2(m,"test.segno",10);
	
	clean(out,SIZE_Buffer);
	sprintf(out,"rm -rf test.pdb");
	printf("SEGNO sys :%s\n",out);
	system(out);
	/*}*/
	
}

void LectureFichierKaksi(pdbfile *m,char *fich){
	FILE *f0;
	char buffer[NB_MAX_CHAIN*NB_MAX_RES];
	long chain,deb,ikak=0;
	
	if(CHAIN=='-') chain=0;
	else chain=(int)(CHAIN)-(int)('A');
	
	deb=m->deb_residues[m->Pos_FirstRes[chain]];
	

	
	f0=flire(fich);
	fgets(buffer,NB_MAX_CHAIN*NB_MAX_RES,f0);
	if(Werboze=='T')printf("%s",buffer);
	fgets(buffer,NB_MAX_CHAIN*NB_MAX_RES,f0);
	while((buffer[ikak]!='\n')&&(buffer[ikak]!='\0')) {
		/*printf("%s[%c|%c|%ld]",buffer,buffer[ikak-1],buffer[ikak],ikak);*/
		m->S2Kaksi[ikak+deb]=buffer[ikak];
		ikak++;
		}
/*	printf("%s[%c|%c]",buffer,buffer[ikak-1],buffer[ikak]);*/
	of(f0);
}

void S2Kaksi(pdbfile *m){
	char out[SIZE_Buffer];

	/*if(ReadDbS2(m,10)!=0){*/

	if(Werboze=='T')printf("KAKSI 01\n");
	
	writechain(m,"kaksi.pdb");
	
	clean(out,SIZE_Buffer);
	sprintf(out,"kaksi -pf kaksi.pdb > kaksi.xml");
	if(Werboze=='T')printf("kaksi sys :%s\n",out);
	system(out);
	
	clean(out,SIZE_Buffer);
	sprintf(out,"k2r -kxo kaksi.xml -ow -1 -pks > out.kaksi");
	if(Werboze=='T')printf("kaksi sys :%s\n",out);
	system(out);

	if(Werboze=='T')printf("KAKSI 02\n");
	
	LectureFichierKaksi(m,"out.kaksi");
	
	clean(out,SIZE_Buffer);
	sprintf(out,"rm -rf kaksi.* out.kaksi");
	system(out);
	
	/*}*/
	
}

void LectureFichierAces(pdbfile *m,char *fich){
	
	FILE *f0;
	char buffer[NB_MAX_CHAIN*NB_MAX_RES];
	char *AA;
	char *S2;
	float *Acc;
	char aa[4];
	char ac[6];
	int u;
	int nbaaseen=0;
	int state=20;
	
	S2=NULL;
	AA=AllocMemoireChar(NB_MAX_CHAIN*NB_MAX_RES);
	Acc=AllocMemoireFl(NB_MAX_CHAIN*NB_MAX_RES);

	f0=fopen(fich,"r");
	while(fgets(buffer,SIZE_Buffer,f0)!=NULL){		/* prend chaque ligne et compte */
	aa[3]='\0';
	ac[5]='\0';
	if(buffer[2]=='S') 
		{
		/*printf("\n|[[[[%s+",buffer);*/
		for(u=0;u<3;u++)aa[u]=buffer[u+4];
		/*printf("[%s-/-%c]\n",aa,AALogictrans(AAthreeToone(aa)));*/
		AA[nbaaseen]=AALogictrans(AAthreeToone(aa));
		for(u=0;u<5;u++)ac[u]=buffer[u+23];
		/*printf("%d[%s-/-%6lf]\n",nbaaseen,ac,atof(ac));*/
		Acc[nbaaseen]=atof(ac);
		/*printf("Acc %d[%6lf]\n",nbaaseen,Acc[nbaaseen]);*/
		nbaaseen++;
		}
	}
	
	of(f0);
	
	distribAAS2(m,state,nbaaseen,AA,S2,Acc);
	
	free(AA);
	free(Acc);
	
}


void ReadNaxes(pdbfile *m){
	char out[SIZE_Buffer];
	
	printf("access\n");
	
	sprintf(out,"cp %s test.pdb",nom_fichier);
	printf("sys :%s\n",out);
	system(out);

	sprintf(out,"/home/bergman/logiciels/naccess2.1.1/naccess test.pdb > test.rsa");
	system(out);
	
	LectureFichierAces(m,"test.rsa");
	
	clean(out,SIZE_Buffer);
	sprintf(out,"rm -rf test.pdb");
	system(out);
	printf("fin access\n");
		
		

}
