/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	definition.c	(beta version 2003)				      */
/*	------------							      */
/*	to write the different usages					      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

/*# include "../HEADER/turn.h"*/

void WriteDef(){

					/*******************/
	FILE *fdef;			/* for the outputs */
	int i_def,j_def,k_def;		/*      count      */
	double bp[NB_BP][NB_ANGLES];	/*   for the PBs   */
					/*******************/
	
	fdef=flire("CODE/DATA/Angular_values.txt");
		for(i_def=0;i_def<NB_BP;i_def++)
			for(j_def=0;j_def<NB_ANGLES;fscanf(fdef,"%lf ",&bp[i_def][j_def++]));
	fclose(fdef);
	
			
	fdef=fecrire("Results/definition.txt");

	/******************/
	/* Protein Blocks */
	/******************/
	
	fprintf(fdef,"\nProtein Blocks definitions taken from  %s\n\n",PBs_ref);
	fprintf(fdef,"      ");	
	for(i_def=0;i_def<NB_ANGLES/2;i_def++){
		if(((i_def)-2)<=0)		fprintf(fdef,"psi i%2d  ",(i_def)-2);
		else		fprintf(fdef,"psi i+%d  ",(i_def)-2);
		if(((i_def+1)-2)<=0)		fprintf(fdef,"phi i%2d  ",(i_def+1)-2);
		else 		fprintf(fdef,"psi i+%d  ",(i_def+1)-2);
		}
	fprintf(fdef,"\n");
	for(i_def=0;i_def<NB_BP;i_def++){
	fprintf(fdef,"PB %c ",BPtrans(i_def));	
		for(j_def=0;j_def<NB_ANGLES;j_def++)
			fprintf(fdef,"%8.2lf ",bp[i_def][j_def]);
			fprintf(fdef,"\n");
		}	
	fprintf(fdef,"\nSWs definitions taken from %s\n\n",SWs_ref);
	
	fprintf(fdef,"to be completed\n");
	
	/***************/
	/* gamma-turns */
	/***************/
	
	fprintf(fdef,"\ngamma turns definitions taken from  %s\n\n",gamma_turn_ref);
	fprintf(fdef,"               ");	
	for(i_def=0;i_def<1;i_def++){
		fprintf(fdef,"phi i+%d ",i_def+1);
		fprintf(fdef,"psi i+%d ",i_def+1);
		}
	fprintf(fdef,"\n");
	
	for(j_def=0;j_def<NB_GAMMA_TURN;j_def++){
		fprintf(fdef,"%s ",gamma_turn_name[j_def]);
		for(i_def=0;i_def<2;i_def++){
			fprintf(fdef,"%8.2lf",gamma_turn[j_def][i_def]);
			}
		fprintf(fdef,"\n");
	}	
	fprintf(fdef,"\n%s\n",gamma_turn_note);

	/***************/
	/* beta-turns */
	/***************/
	

	fprintf(fdef,"\nbeta turns definitions taken from  %s\n\n",beta_turn_ref);
	fprintf(fdef,"                      ");	
	for(i_def=0;i_def<2;i_def++){
		fprintf(fdef,"phi i+%d ",i_def+1);
		fprintf(fdef,"psi i+%d ",i_def+1);
		}
	fprintf(fdef,"\n");
	
	for(j_def=0;j_def<NB_BETA_TURN-1;j_def++){
		fprintf(fdef,"%s ",beta_turn_name[j_def]);
		for(i_def=0;i_def<4;i_def++){
			fprintf(fdef,"%8.2lf",beta_turn[j_def][i_def]);
			}
		fprintf(fdef,"\n");
	}
	fprintf(fdef,"%s ",beta_turn_name[j_def]);
	for(i_def=0;i_def<4;i_def++)
		fprintf(fdef,"    ----");fprintf(fdef,"\n");
		
	fprintf(fdef,"\n%s\n",beta_turn_note);

	
	fprintf(fdef,"\nalpha turns definitions taken from  %s\n\n",alpha_turn_ref);
	fprintf(fdef,"                    ");	
	for(i_def=0;i_def<3;i_def++){
		fprintf(fdef,"phi i+%d ",i_def+1);
		fprintf(fdef,"psi i+%d ",i_def+1);
		}
	fprintf(fdef,"\n");

	/***************/
	/* alpha-turns */
	/***************/
	
	for(j_def=0;j_def<NB_ALPHA_TURN;j_def++){
		fprintf(fdef,"%s ",alpha_turn_name[j_def]);
		for(i_def=0;i_def<6;i_def++){
			fprintf(fdef,"%8.2lf",alpha_turn[j_def][i_def]);
			}
		fprintf(fdef,"\n");
	}	
	fprintf(fdef,"\n%s\n",alpha_turn_note);
	
	
	fprintf(fdef,"\n\nSecondary structures\n----------------------\n");	
	
	/*********/
	/* DSSP  */
	/*********/
	
	fprintf(fdef,"\ndssp code taken from  %s\n\n",dssp_ref);
	
	for(j_def=0;j_def<NB_DSSP_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_dssp_name[j_def],j_def,dssp_name[j_def]);
	
	fprintf(fdef,"\n");

	/***********/
	/* STRIDE  */
	/***********/
	
	fprintf(fdef,"\nstride code taken from  %s\n\n",stride_ref);
	
	fprintf(fdef,"\n%s\n\n",stride_notes);
	
	/*********/
	/* P-SEA  */
	/*********/
	
	fprintf(fdef,"\npsea code taken from  %s\n\n",psea_ref);
	
	for(j_def=0;j_def<NB_psea_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_psea_name[j_def],j_def,psea_name[j_def]);
	
	fprintf(fdef,"\n");
	
	/***********/
	/* DEFINE  */
	/***********/
	
	fprintf(fdef,"\ndefine code taken from  %s\n\n",define_ref);
	
	for(j_def=0;j_def<NB_psea_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_define_name[j_def],j_def,define_name[j_def]);
	
	fprintf(fdef,"\n");

	/***********/
	/* PCURVE  */
	/***********/
	
	fprintf(fdef,"\npcurve code taken from  %s\n\n",pcurve_ref);
	
	for(j_def=0;j_def<NB_psea_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_pcurve_name[j_def],j_def,pcurve_name[j_def]);
	
	fprintf(fdef,"\n");
	
	/**************/
	/* consensus  */
	/**************/
	
	fprintf(fdef,"\nconsensus of dssp, define and pcurve:  %s\n\n",pcons93_ref);
	
	
	/***********/
	/* xtllstr */
	/***********/
	
	fprintf(fdef,"\nxtllstr code taken from  %s\n\n",xtllstr_ref);
	
	for(j_def=0;j_def<NB_XTLSSTR_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_xtllstr_name[j_def],j_def,xtllstr_name[j_def]);
	
	fprintf(fdef,"\n");
	
	
	/***********/
	/* helanal */
	/***********/
	
	fprintf(fdef,"\nhelanal code taken from  %s\n\n",helanal_ref);
	
	for(j_def=0;j_def<NB_HELANAL_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_helanal_name[j_def],j_def,helanal_name[j_def]);
	
	fprintf(fdef,"\n");
	
	/*****************/
	/* DSSP extended */
	/*****************/
	
	fprintf(fdef,"\ndssp extended code taken from  %s\n\n",dssprk_ref);
	
	for(j_def=0;j_def<NB_DSSPRK_STATE;j_def++)
		fprintf(fdef," %s (%2d) %s\n",short_dssprk_name[j_def],j_def,dssprk_name[j_def]);
	
	fprintf(fdef,"\n");

	fprintf(fdef,"\n%s\n\n",dssprk_notes);
	
	/***********/
	/* Fodje */
	/***********/
	
	fprintf(fdef,"\nsecstr code taken from  %s\n\n",secstr_ref);
	
	for(j_def=0;j_def<NB_secstr_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_secstr_name[j_def],j_def,secstr_name[j_def]);
	
	fprintf(fdef,"\n");
	
	/***********/
	/* Segno */
	/***********/
	
	fprintf(fdef,"\nSegno code taken from  %s\n\n",segno_ref);
	
	for(j_def=0;j_def<NB_segno_STATE;j_def++)
		fprintf(fdef," %s (%d) %s\n",short_segno_name[j_def],j_def,segno_name[j_def]);
	
	fprintf(fdef,"\n");
	
	
	/***************/
	/* Beta-bulges */
	/***************/
	
	fprintf(fdef,"\nBeta-bulges code taken from  %s [see %s]\n\n",betabul_ref,beta_turn_ref);
	
	for(j_def=0;j_def<NB_betabul_STATE;j_def++)
		fprintf(fdef," %s (%2d) %s\n",short_betabul_name[j_def],j_def+1,betabul_name[j_def]);
	
	fprintf(fdef,"\n");
	
	/***********************/
	/* Kolodony prototypes */
	/***********************/

	fprintf(fdef,"\nprototypes definitions (serie 1) taken from  %s\n\n",kolo_ref);
	fprintf(fdef,"\t\t\t     X       Y       Z\n");	
	
	for(i_def=0;i_def<10;i_def++){
	fprintf(fdef,"prototypes (%2d/%2d):\n",i_def+1,10);
		for(j_def=0;j_def<5;j_def++){
			fprintf(fdef,"i %2d\t\t\t",j_def-2);
				for(k_def=0;k_def<3;k_def++)
					fprintf(fdef,"%8.2lf",Kolodny_10_5[i_def][j_def][k_def]);
			fprintf(fdef,"\n");
		}
	}	
	
	
	fprintf(fdef,"\nprototypes definitions (serie 2) taken from  %s\n\n",kolo_ref);
	fprintf(fdef,"\t\t\t     X       Y       Z\n");	
	
	for(i_def=0;i_def<20;i_def++){
	fprintf(fdef,"prototypes (%2d/%2d):\n",i_def+1,20);
		for(j_def=0;j_def<5;j_def++){
			fprintf(fdef,"i %2d\t\t\t",j_def-2);
				for(k_def=0;k_def<3;k_def++)
					fprintf(fdef,"%8.2lf",Kolodny_20_5[i_def][j_def][k_def]);
			fprintf(fdef,"\n");
		}
	}	
	
	/*************************/
	/* Micheletti prototypes */
	/*************************/

	fprintf(fdef,"\nprototypes definitions taken from  %s\n\n",Oligons_ref);
	fprintf(fdef,"\t\t\t     X       Y       Z\n");	
	
	for(i_def=0;i_def<40;i_def++){
	fprintf(fdef,"prototypes (%2d/%2d):\n",i_def+1,40);
		for(j_def=0;j_def<5;j_def++){
			fprintf(fdef,"i %2d\t\t\t",j_def-2);
				for(k_def=0;k_def<3;k_def++)
					fprintf(fdef,"%8.2lf",Oligons[i_def][j_def][k_def]);
			fprintf(fdef,"\n");
		}
	}	
	
	
	
	of(fdef);				
	
}	


void TransTypeNext(){

					/*******************/
	FILE *fdef;			/* for the outputs */
	int i_def;		/*      count      */
	long num[25];
					/*******************/

	fdef=fopen(".typenext2","r");
	for(i_def=0;i_def<25;i_def++)
		fscanf(fdef,"%ld",&num[i_def]);
	fclose(fdef);
	
	fdef=fecrire("Results/turn_traduction.txt");
	/*i_def=0; fprintf(fdef,"double assignation     : %6ld\n",num[i_def]);*/
	fprintf(fdef,"gamma-turns :\n");
	fprintf(fdef,"-------------\n");
	for(i_def=10;i_def<10+NB_GAMMA_TURN;i_def++)
		fprintf(fdef,"%s        : %6ld\n",gamma_turn_name[(i_def-10)],num[i_def]);
	fprintf(fdef,"\nbeta-turns :\n");
	fprintf(fdef,"------------\n");
	
	for(i_def=1;i_def<1+NB_BETA_TURN;i_def++)
		fprintf(fdef,"%s : %6ld\n",beta_turn_name[(i_def-1)],num[i_def]);
	fprintf(fdef,"\nalpha-turns :\n");
	fprintf(fdef,"-------------\n");
	
	for(i_def=12;i_def<12+NB_ALPHA_TURN;i_def++)
		fprintf(fdef,"%s   : %6ld\n",alpha_turn_name[(i_def-12)],num[i_def]);
		
	fclose(fdef);		
	
	
}
