# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_protoC.h"


void ligne_pdbI(pdbfile *m, FILE *f_f, long i,long j){
	
	fprintf(f_f,"ATOM   %4.0ld  %-3s%4s %c%4ld ",j,m->pdbatomtype[j].ATOM_name,m->pdbatomtype[j].ATOM_residuesname,'A',m->pdbatomtype[j].ATOM_residuesnumber);
	fprintf(f_f,"   %8.3f%8.3f%8.3f  1.00 19.19             %c\n",m->pdbatomtype[j].ATOM_CoordX,m->pdbatomtype[j].ATOM_CoordY,m->pdbatomtype[j].ATOM_CoordZ,m->pdbatomtype[j].ATOM_real);
								

}


void WritePartPdbI(pdbfile *m,long begin,long end,long und){

	FILE *f_pdbout;
	char file_name[SIZE_Buffer];
	long tm,i_loc,j_loc;
	char *mot;
	
	
	mot=AllocMemoireChar(lg_SEARCH_PBserie);
	for(tm=0;tm<lg_SEARCH_PBserie;tm++) mot[tm]=SEARCH_PBserie[tm];	
	file_name[0]='\0';

	sprintf(file_name,"Results/Rasmol/%s_%s_%ld.pdb",m->name,mot,und);
	
	f_pdbout=fecrire(file_name);
	fprintf(f_pdbout,"HEADER\t\t\t\t\t%4s%c %6ld AdB  %1.1f\n",m->name,'A',end-begin,m->resolution);
	fprintf(f_pdbout,"REMARK\t SEARCH PBs MOTIF :");
	for(tm=0;tm<lg_SEARCH_PBserie;fprintf(f_pdbout,"%c",SEARCH_PBserie[tm++]));
	fprintf(f_pdbout,"\nREMARK\t cut-cut [%ld-%ld]",begin,end);
	fprintf(f_pdbout,"\nREMARK\t Sequence : [");
	for(tm=begin;tm<end;fprintf(f_pdbout,"%c",m->Nam_residues[tm++]));
	fprintf(f_pdbout,"]\nREMARK\t Distance Calpha [%ld] - Calpha [%ld] : %8.4lf\n",begin+2,end-2,sqrt(distance_intercarbone(m->pdbatomtype[((m->deb_residues[begin+2])+1)].ATOM_CoordX,m->pdbatomtype[((m->deb_residues[begin+2])+1)].ATOM_CoordY,m->pdbatomtype[((m->deb_residues[begin+2])+1)].ATOM_CoordZ,m->pdbatomtype[((m->deb_residues[end-2])+1)].ATOM_CoordX,m->pdbatomtype[((m->deb_residues[end-2])+1)].ATOM_CoordY,m->pdbatomtype[((m->deb_residues[end-2])+1)].ATOM_CoordZ)));
	for(i_loc=begin;i_loc<end;i_loc++){
		for(j_loc=m->deb_residues[i_loc];j_loc<m->end_residues[i_loc]+1;j_loc++){
			ligne_pdbI(m,f_pdbout,i_loc,j_loc);
			}
		}	
	fprintf(f_pdbout,"END\n");		
	of(f_pdbout);

	free(mot);
}


void SearchPBmotifs(pdbfile *m){

	long im,ym,tm;
	long pos;
	long nb;
	long deb;
	long end;
	
	pos=nb=0;
	if(lg_SEARCH_PBserie>0) {
		printf("Search of the PB motifs [");
		for(tm=0;tm<lg_SEARCH_PBserie;tm++)
			printf("%c",SEARCH_PBserie[tm]);
		printf("]\n");
		
		for(ym=0;ym<((m->NB_chain)+1);ym++){
			if((m->Pos_LastRes[ym]-m->Pos_FirstRes[ym]+1)>MIN_LONGEUR){
				for(im=m->Pos_FirstRes[ym];im<m->Pos_LastRes[ym];im++){
					if((m->Next_AA[im]==1)&&(((m->Assign_PB[im])<16)&&((m->Assign_PB[im])>-1))){		
						if(BPtrans(m->Assign_PB[im])==SEARCH_PBserie[pos]){
							/*printf("%d %c %c\n",pos,BPtrans(m->Assign_PB[im]),SEARCH_PBserie[pos]);*/
							pos++;
							}
						else {if(pos>0){im-=(pos-1); pos=0;}}
						if(pos==lg_SEARCH_PBserie){nb++;printf("PB motif found at position %ld\n",im);
						if((im-pos-2)<(m->Pos_FirstRes[ym]))	deb=(im-pos);else deb=(im-pos-2);
						if((im+2)>(m->Pos_LastRes[ym]))		end=(im);else end=(im+2);
						WritePartPdbI(m,deb,end,nb);im-=(pos-1); pos=0;}
						}
					}
				}	
			}
		}
	else printf("wrong coding\n");	
}

