/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	turn.c	(beta version 2003)				      	      */
/*	--------							      */
/*	research on turns						      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/Kolodony.h"
# include "../HEADER/Micheletti.h"

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

void Kolocomparison(){	
	
	FILE *fkolo;
	FILE *fkolo2;
	int ik, jk, kk;
	double X1[5],Y1[5],Z1[5];
	double X2[5],Y2[5],Z2[5];
	double KoloCompare2010[20][10];
	double KoloCompare20BP[20][16];
	double KoloCompare10BP[10][16];
	double KoloCompareALL[46][46];
	double MicCompareALL[56][56];
	
	char stmp56[150];
	char name[150];
	char file[150];

	for(ik=0;ik<56;ik++)
		for(kk=0;kk<56;kk++)MicCompareALL[ik][kk]=0.0;
			
	printf("begin\n");
	
	for(ik=0;ik<56;ik++){
		for(kk=ik+1;kk<56;kk++){	/* 00-40 : oligons  40-56 : PB */
			if(ik<40){
				for(jk=0;jk<5;jk++){
					X1[jk]=Oligons[ik][jk][0];
					Y1[jk]=Oligons[ik][jk][1];
					Z1[jk]=Oligons[ik][jk][2];
				}
			}
			else {
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",ik-40);
					fkolo=flire(stmp56);		
					for(jk=0;jk<5;jk++){
					fscanf(fkolo,"%lf\n",&X1[jk]);
					fscanf(fkolo,"%lf\n",&Y1[jk]);
					fscanf(fkolo,"%lf\n",&Z1[jk]);
					}
					of(fkolo);		
				}		

			if(kk<40){
				for(jk=0;jk<5;jk++){
					X2[jk]=Oligons[kk][jk][0];
					Y2[jk]=Oligons[kk][jk][1];
					Z2[jk]=Oligons[kk][jk][2];
				}
			}
			else {
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",kk-40);
					fkolo=flire(stmp56);		
					for(jk=0;jk<5;jk++){
					fscanf(fkolo,"%lf\n",&X2[jk]);
					fscanf(fkolo,"%lf\n",&Y2[jk]);
					fscanf(fkolo,"%lf\n",&Z2[jk]);
					}
					of(fkolo);		
				}

			
			Sippl(X1,Y1,Z1,X2,Y2,Z2,5);
			printf("psot Sippl %8.3lf\n",rmsd(X1,Y1,Z1,X2,Y2,Z2,5));
			MicCompareALL[ik][kk]=superposit(X1,Y1,Z1,X2,Y2,Z2,5,2,2,2);
			MicCompareALL[kk][ik]=MicCompareALL[ik][kk];
			printf("%d %d %lf\n",ik,kk,MicCompareALL[ik][kk]);
		}	
	}


	fkolo=fecrire("Results/mic-pb.txt");
	for(ik=0;ik<56;ik++){
		for(jk=0;jk<56;fprintf(fkolo,"%lf\t",MicCompareALL[ik][jk++]));
		fprintf(fkolo,"\n");
		}
	of(fkolo);

	for(ik=0;ik<46;ik++)
		for(kk=ik+1;kk<46;kk++)
			KoloCompareALL[ik][kk]=0.0;
		
	for(ik=0;ik<46;ik++){
		for(kk=ik+1;kk<46;kk++){	/* 00-19 : 20 20-29 : 10 30-45 : PB */
			if(ik<20){
				for(jk=0;jk<5;jk++){
					X1[jk]=Kolodny_20_5[ik][jk][0];
					Y1[jk]=Kolodny_20_5[ik][jk][1];
					Z1[jk]=Kolodny_20_5[ik][jk][2];
				}
			}
			else {
				if(ik<30){
					for(jk=0;jk<5;jk++){
						X1[jk]=Kolodny_10_5[ik-20][jk][0];
						Y1[jk]=Kolodny_10_5[ik-20][jk][1];
						Z1[jk]=Kolodny_10_5[ik-20][jk][2];
						}
				}
				else{
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",ik-30);
					fkolo=flire(stmp56);		
					for(jk=0;jk<5;jk++){
					fscanf(fkolo,"%lf\n",&X1[jk]);
					fscanf(fkolo,"%lf\n",&Y1[jk]);
					fscanf(fkolo,"%lf\n",&Z1[jk]);
						}
					of(fkolo);		
					}	
				}
			if(kk<20){
				for(jk=0;jk<5;jk++){
				X2[jk]=Kolodny_20_5[kk][jk][0];
				Y2[jk]=Kolodny_20_5[kk][jk][1];
				Z2[jk]=Kolodny_20_5[kk][jk][2];
				}
			}
			else {
				if(kk<30){
					for(jk=0;jk<5;jk++){
						X2[jk]=Kolodny_10_5[kk-20][jk][0];
						Y2[jk]=Kolodny_10_5[kk-20][jk][1];
						Z2[jk]=Kolodny_10_5[kk-20][jk][2];
						}
				}
				else{
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",kk-30);
					fkolo=flire(stmp56);		
					for(jk=0;jk<5;jk++){
					fscanf(fkolo,"%lf\n",&X2[jk]);
					fscanf(fkolo,"%lf\n",&Y2[jk]);
					fscanf(fkolo,"%lf\n",&Z2[jk]);
						}
					of(fkolo);		
					}	
				}	
			
			Sippl(X1,Y1,Z1,X2,Y2,Z2,5);
			printf("psot Sippl %8.3lf\n",rmsd(X1,Y1,Z1,X2,Y2,Z2,5));
			KoloCompareALL[ik][kk]=superposit(X1,Y1,Z1,X2,Y2,Z2,5,2,2,2);
			KoloCompareALL[kk][ik]=KoloCompareALL[ik][kk];
			printf("%d %d %lf\n",ik,kk,KoloCompareALL[ik][kk]);
		}	
	}


	fkolo=fecrire("Results/kolodony-all.txt");
	for(ik=0;ik<46;ik++){
		for(jk=0;jk<46;fprintf(fkolo,"%lf\t",KoloCompareALL[ik][jk++]));
		fprintf(fkolo,"\n");
		}
	of(fkolo);

	for(ik=0;ik<10;ik++){
		for(kk=0;kk<16;kk++){
			sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",kk);
			fkolo=flire(stmp56);		
			for(jk=0;jk<5;jk++){
				fscanf(fkolo,"%lf\n",&X2[jk]);
				fscanf(fkolo,"%lf\n",&Y2[jk]);
				fscanf(fkolo,"%lf\n",&Z2[jk]);
				X1[jk]=Kolodny_10_5[ik][jk][0];
				Y1[jk]=Kolodny_10_5[ik][jk][1];
				Z1[jk]=Kolodny_10_5[ik][jk][2];
				
			/*printf("%lf %lf %lf \n",X2[jk],Y2[jk],Z2[jk]);*/
			}
			of(fkolo);	
			Sippl(X1,Y1,Z1,X2,Y2,Z2,5);
			KoloCompare10BP[ik][kk]=superposit(X1,Y1,Z1,X2,Y2,Z2,5,0,0,0);
			printf("rmsd %d %d %8.3lf\n",ik,kk,KoloCompare10BP[ik][kk]);
			sprintf(name,"kolo10_%d",ik);
			sprintf(file,"Results/XYZ/%s_sup.pdb",name);
			create_PDB_CA(X1,Y1,Z1,name,file,1,5);
			sprintf(name,"kolo%d",ik);
			sprintf(file,"Results/XYZ/%s-BP%d.pdb",name,kk);
			create_PDB_CA(X2,Y2,Z2,name,file,1,5);

		}	
	}
		
	fkolo=fecrire("Results/kolodony-10-16.txt");
	for(ik=0;ik<10;ik++){
		for(jk=0;jk<16;fprintf(fkolo,"%lf\t",KoloCompare10BP[ik][jk++]));
		fprintf(fkolo,"\n");
		}
	of(fkolo);	

	for(ik=0;ik<20;ik++){
		for(kk=0;kk<16;kk++){
			sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",kk);
			fkolo=flire(stmp56);		
			for(jk=0;jk<5;jk++){
				fscanf(fkolo,"%lf\n",&X2[jk]);
				fscanf(fkolo,"%lf\n",&Y2[jk]);
				fscanf(fkolo,"%lf\n",&Z2[jk]);
				X1[jk]=Kolodny_20_5[ik][jk][0];
				Y1[jk]=Kolodny_20_5[ik][jk][1];
				Z1[jk]=Kolodny_20_5[ik][jk][2];
				
			/*printf("%lf %lf %lf \n",X2[jk],Y2[jk],Z2[jk]);*/
			}
			of(fkolo);	
			Sippl(X1,Y1,Z1,X2,Y2,Z2,5);
			KoloCompare20BP[ik][kk]=superposit(X1,Y1,Z1,X2,Y2,Z2,5,0,0,0);
			printf("rmsd %d %d %8.3lf\n",ik,kk,KoloCompare20BP[ik][kk]);
			sprintf(name,"kolo20_%d",ik);
			sprintf(file,"Results/XYZ/%s_sup.pdb",name);
			create_PDB_CA(X1,Y1,Z1,name,file,1,5);
			sprintf(name,"kolo%d",ik);
			sprintf(file,"Results/XYZ/%s-BP%d.pdb",name,kk);
			create_PDB_CA(X2,Y2,Z2,name,file,1,5);

		}	
	}
		
	fkolo=fecrire("Results/kolodony-20-16.txt");
	for(ik=0;ik<20;ik++){
		for(jk=0;jk<16;fprintf(fkolo,"%lf\t",KoloCompare20BP[ik][jk++]));
		fprintf(fkolo,"\n");
		}
	of(fkolo);	
			
		
	
	for(ik=0;ik<20;ik++){
		for(jk=0;jk<5;jk++){
				X1[jk]=Kolodny_20_5[ik][jk][0];
				Y1[jk]=Kolodny_20_5[ik][jk][1];
				Z1[jk]=Kolodny_20_5[ik][jk][2];
		
			}
		for(kk=0;kk<10;kk++){
			for(jk=0;jk<5;jk++){
				X2[jk]=Kolodny_10_5[kk][jk][0];
				Y2[jk]=Kolodny_10_5[kk][jk][1];
				Z2[jk]=Kolodny_10_5[kk][jk][2];
			}
			mainpassSippl(X1,Y1,Z1,X2,Y2,Z2,5);
			printf("Sippl pass\n");
			printf("rmsd %d %d %8.3lf\n",ik,kk,KoloCompare2010[ik][kk]=superposit(X1,Y1,Z1,X2,Y2,Z2,5,10,10,2));
		}	
	}
	
	fkolo2=fecrire("Results/kolodony-20-10.txt");
	for(ik=0;ik<20;ik++){
		for(jk=0;jk<10;fprintf(fkolo2,"%lf\t",KoloCompare2010[ik][jk++]));
		fprintf(fkolo2,"\n");
		}
	of(fkolo2);
	
}			
		
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

