# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_struct.h"
# include "rooman.h"

int FetrowAAthreeToone(char *aa)	
		{
		int AA=-1;
		switch (aa[0])  
			{
			case ('A') : /*alanine , arginine, acide asparagique, asparate */
					switch (aa[2])  
						{
						case ('A') : AA=0 ; break; /* ALA (A) alanine */
						case ('G') : AA=14; break; /* ARG (R) arginine */						
						case ('N') : AA=11; break; /* ASN (N) acide asparagique */
						case ('P') : AA=2;  break; /* ASP (D) asparate */
						} break;
			case ('C') : AA=1; break; 			      /* CYS (C) cysteine */
			case ('G') : /* glycine, glutamate, acide glutamique */
					switch (aa[2])  
						{
						case ('N') : AA=13;  break; /* GLN (Q) acide glutamique */
						case ('Y') : AA=5;   break; /* GLY (G) glycine */
						case ('U') : AA=3;   break; /* GLU (E) glutamate */
						} break;
			case ('H') : AA=6;   break; 			       /* HIS (H) histidine */
			case ('I') : AA=7;   break;	        	       /* ILE (I) isoleucine */
			case ('L') : /* leucine ,lysine */
					switch (aa[1])  
						{
						case ('E') : AA=9;  break; /* LEU (L) leucine */
						case ('Y') : AA=8;  break; /* LYS (K) lysine */
						} break;						
			case ('M') : AA=10;  break;			      /* MET (M) methionine */
			case ('P') : /* phenilalanine, proline */
					switch (aa[1])  
						{
						case ('H') : AA=4;  break; /* PHE (F) phenilalanine */
						case ('R') : AA=12; break; /* PRO (P) proline */
						} break;			
			case ('S') : AA=15;  break;			      /* SER (S) serine */
			case ('T') : /* threonine, tyrosine , tryptophane */
					switch (aa[1])  
						{
						case ('H') : AA=16;  break; /* THR (T) threonine */
						case ('R') : AA=18;  break; /* TRP (W) tryptophane */
						case ('Y') : AA=19;  break; /* TYR (Y) tyrosine */
						} break;						
			case ('V') : AA=17;  break; 			      /* VAL (V) valine */
			default : AA=-1;
			}
		return AA;
	}		


void FetrowStruct(pdbfile *m){
	FILE *f53;
	char buffer[SIZE_Buffer];			
	int i53,y53;
	char seq[1500];
	char sbb[1500];
	int lgseq=0;
	int test=0;
	int av;
	char search[4];
	f53=fopen(nom_fetr,"r");

	while(fgets(buffer,SIZE_Buffer,f53)!=NULL){
	/*	printf("%s",buffer);*/
		sbb[lgseq]=buffer[5];	/* pour les .sbb*/
		sbb[lgseq]=buffer[6];	/* pour les .cat*/
		test=0;
		search[3]='\0';
		av=19;
		while(test==0){
		for(i53=0;i53<3;i53++)
			search[i53]=buffer[i53+av];
		
		if(FetrowAAthreeToone(search)!=(-1)){
				seq[lgseq]=AALogictrans(FetrowAAthreeToone(search));
		/*		printf("oui ==>  %c\n",seq[lgseq]);*/
				lgseq++;
				test=1;
				}
				
		if((test==0)&&(strlen(buffer)-3)<av){
			printf("PB %s %d rien trouve");
			test=1;
			}
			
		av++;
		}
	}
	fclose (f53);

	/*printf("\n---------\npos %d\n------------\n",test);
		
	
	for(i53=0;i53<lgseq;printf("%c",seq[i53++]));
	
	printf("\n---------\npos %d\n------------\n",test);*/
		
	av=0;
	test=0;
	while(test==0){
	for(y53=0;y53<((m->NB_chain)+1);y53++){
		for(i53=m->Pos_FirstRes[y53];i53<m->Pos_LastRes[y53];i53++){
		/*printf("%c",m->Nam_residues[i53]);*/
			if(((m->Nam_residues[i53])==(seq[av]))&&\
			((m->Nam_residues[i53+1])==(seq[av+1]))&&((m->Nam_residues[i53+3])==(seq[av+3]))){
				test=i53;	
				y53=1000;
				i53=1000;
				}

		}
	}
	if((y53!=1000)&&(i53!=1000))av++;
	}
	
	test=0;
	
	printf("\n---------\npos %d\n------------\n",test);
	
	
	for(i53=test;i53<lgseq;printf("%c",seq[i53++]));
	
	printf("\n---------\npos %d\n------------\n",test);
	
	f53=fopen("Results/frt.zrt","a+");
	for(i53=test;i53<(test+lgseq);i53++)
		if((m->Nam_residues[i53])==(seq[i53-test]))
			fprintf(f53,"%c %c %c %c %3d %c %c\n",sbb[i53-test],BPtrans(m->Assign_PB[i53]),BPtrans(m->Assign_PB[i53+1]),BPtrans(m->Assign_PB[i53+2]),i53,(m->Nam_residues[i53]),(seq[i53-test]));
		else printf("y a pb %c %c\n",(m->Nam_residues[i53]),(seq[i53-test]));
	fprintf(f53,"---------------------------------\n");
	fclose (f53);


}



void RoomanStruct(struct pdbfile *m){
	FILE *f52;
	int i52,j52,k52,l52;
	double bp[NB_BP][NB_ANGLES];
	double rmsda5[NB_ROO_MOT][NB_BP];
	double rmsda6[NB_ROO_MOT][NB_BP][2];
	
	for(i52=0;i52<NB_ROO_MOT;i52++)
	   for(j52=0;j52<NB_BP;rmsda5[i52][j52++]=0);

	for(i52=0;i52<NB_ROO_MOT;i52++)
	   for(j52=0;j52<NB_BP;j52++)
	   	 for(k52=0;k52<2;k52++)
			rmsda6[i52][j52][k52]=0;
			

	if(Werboze=='T')  printf("Rooman Work Lect One %s\n",m->name);
		
	f52=fopen("./Donnees/BSP_init_16.ord","r");
	for(i52=0;i52<NB_BP;i52++)
		for(j52=0;j52<NB_ANGLES;fscanf(f52,"%lf ",&bp[i52][j52++]));
	fclose(f52);
		
	/*for(i52=0;i52<NB_BP;i52++){
		for(j52=0;j52<NB_ANGLES;j52++)
			printf("%d %8.2f ",i52+1,bp[i52][j52]);
			printf("\n");
			}*/

	for(i52=0;i52<NB_ROO_MOT;i52++){
	   for(j52=0;j52<NB_BP;j52++){
		for(k52=0;k52<NB_ANGLES;k52++){
			rmsda5[i52][j52]+=DistAngMin(RLMotifs5[i52][k52+1],bp[j52][k52])*DistAngMin(RLMotifs5[i52][k52+1],bp[j52][k52]);	/* attention le premier et le dernier ne serve a rien */
		
		/*printf("%d %d %6.2f %6.2f %6.2f\t",i52,j52,rmsda5[i52][j52],RLMotifs5[i52][k52+1],bp[j52][k52]);
		*/}
		/*printf("\n");*/
	    }  	
	}	
	for(i52=0;i52<NB_ROO_MOT;i52++)
	   for(j52=0;j52<NB_BP;j52++)
		   for(k52=0;k52<NB_ANGLES;k52++)
		   	 for(l52=0;l52<2;l52++)
				rmsda6[i52][j52][l52]+=DistAngMin(RLMotifs6[i52][k52+((2*l52)+1)],bp[j52][k52])*DistAngMin(RLMotifs6[i52][k52+((2*l52)+1)],bp[j52][k52]);	/* attention le premier et le dernier ne serve a rien */


	
	
	f52=fopen("Results/rooman5.txt","w");
	for(i52=0;i52<NB_ROO_MOT;i52++){
	   for(j52=0;j52<NB_BP;j52++)
	   	fprintf(f52,"%8.2f\t",sqrt(rmsda5[i52][j52]/(float)NB_ANGLES));
		fprintf(f52,"\n");
		}
	fclose(f52);

	f52=fopen("Results/rooman6deb.txt","w");
	for(i52=0;i52<NB_ROO_MOT;i52++){
	   for(j52=0;j52<NB_BP;j52++)
	   	fprintf(f52,"%8.2f\t",sqrt(rmsda6[i52][j52][0]/(float)NB_ANGLES));
		fprintf(f52,"\n");
		}
	fclose(f52);

	f52=fopen("Results/rooman6end.txt","w");
	for(i52=0;i52<NB_ROO_MOT;i52++){
	   for(j52=0;j52<NB_BP;j52++)
	   	fprintf(f52,"%8.2f\t",sqrt(rmsda6[i52][j52][1]/(float)NB_ANGLES));
		fprintf(f52,"\n");
		}
	fclose(f52);



}





