/******************************************************************************/
/*	PDB Dreamer version x.yz					      */
/*      (A.G. de Brevern - EBGM - E0346 INSERM)				      */
/******************************************************************************/
/*	turn.c	(beta version 2003)				      	      */
/*	--------							      */
/*	research on turns						      */
/******************************************************************************/

# include "../HEADER/basic_h.h"

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

/*# include "../HEADER/turn.h"*/

void superpos(int nbresidu,char* name, long pos, pdbfile *m){	
	
	FILE *fxyz;
	double *X,*Y,*Z,*X_frag,*Y_frag,*Z_frag;
	long x, /*y,*/x2,y2;
	long w20=pos;
	char stmp[60];
	int nbres=nbresidu*4;
	/*a voir en prenant l'ensemble du backbone */
		
	X=(double*)calloc(4*nbres,sizeof(double));
	Y=(double*)calloc(4*nbres,sizeof(double));
	Z=(double*)calloc(4*nbres,sizeof(double));
	X_frag=(double*)calloc(4*nbres,sizeof(double));
	Y_frag=(double*)calloc(4*nbres,sizeof(double));
	Z_frag=(double*)calloc(4*nbres,sizeof(double));
		
	printf("test PB_RMSD en position %ld\n",w20);
		
	y2=0;
	for(x2=0;x2<nbresidu;x2++){
		x=m->deb_residues[pos+x2];	
		X_frag[y2++]=m->pdbatomtype[x++].ATOM_CoordX;
		Y_frag[y2++]=m->pdbatomtype[x++].ATOM_CoordY;
		Z_frag[y2++]=m->pdbatomtype[x++].ATOM_CoordZ;
		}
		
		
	clean_str(stmp,60);
	sprintf(stmp,"CODE/DATA/TURN/best_pdb_turn_%s.xyz",name);
	
	fxyz=flire(stmp);		
	for(x2=0;x2<nbres;x2++){
		fscanf(fxyz,"%lf\n",&X[x2]);
		fscanf(fxyz,"%lf\n",&Y[x2]);
		fscanf(fxyz,"%lf\n",&Z[x2]);
		}
	of(fxyz);
	mainpassSippl(X,Y,Z,X_frag,Y_frag,Z_frag,nbres);
	mainpass3bis(X,Y,Z,X_frag,Y_frag,Z_frag,name,w20,nbres);
	
				
	free(X);free(Y);free(Z);free(X_frag);free(Y_frag);free(Z_frag);
							
		
}			
		
void WriteTurnInfo(pdbfile *m,int typeturn, long posres,long atomX,long atomY, long pos1, long pos2,long nbres){
	FILE *f_turn;
	char stmp[60];
	int i;
	clean_str(stmp,60);
	
	sprintf(stmp,"Results/Zx/resume_%d_turn.txt",typeturn);
	/*printf("passage %s\n",stmp);*/
	f_turn=fSurecrire(stmp);
	for(i=0;i<nbres;i++) fprintf(f_turn,"%2d\t",m->Assign_PB[posres+i]);
	for(i=0;i<nbres;i++) fprintf(f_turn,"%2d\t",transAAlogic(m->Nam_residues[posres+i]));
	for(i=0;i<nbres-2;i++) fprintf(f_turn,"%6.2lf\t%6.2lf\t",m->Phi[posres+i+1],m->Psi[posres+i+1]);
	fprintf(f_turn,"%6.2lf\n",distance_interATOM(m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordZ,\
		m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordZ));
	of(f_turn);

}

void nospace(char *s, char sos[150]){
	int i;
	int j=0;
/*	printf("s: '%s'\n",s);*/
	for(i=0;i<strlen(s);i++)
		if(s[i]!=' ')
			sos[j++]=s[i];
		sos[j++]='\0';
}

void WriteThePDBturn(char *stmp, char *stmp2, int nbresidue, pdbfile *m, long i21, long y21){
	FILE *f21;
	FILE *f22;	
        long x,x2,y;
	char cp='A';	/* to be modified */
	long cp2=0;
	int end=4;	/* only the backbone */
	
	if(Werboze=='T') printf("WriteThePDBturn : %s %s\n",stmp,stmp2);
        f21=fopen(stmp,"w");
        f22=fopen(stmp2,"a+");
	fprintf(f21,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,cp,m->Pos_LastRes[y21]-m->Pos_FirstRes[y21]+1,m->resolution);
	
	cp2=1;

        /* residues with only the backbone */
	
	for(x2=0;x2<nbresidue;x2++){
   		   x=m->deb_residues[i21+x2];
	   	   for(y=0;y<end;y++){
   			fprintf(f21,"ATOM    %3.0ld %3s %4s %c%4ld ",\
   			cp2,m->pdbatomtype[x+y].ATOM_name,m->pdbatomtype[x+y].ATOM_residuesname,\
	   		cp,m->pdbatomtype[x+y].ATOM_residuesnumber);
   			fprintf(f21,"	%8.3f%8.3f%8.3f  1.00 19.19		%c\n",\
	   		m->pdbatomtype[x+y].ATOM_CoordX,m->pdbatomtype[x+y].ATOM_CoordY,m->pdbatomtype[x+y].ATOM_CoordZ,m->pdbatomtype[x+y].ATOM_real);
	   		cp2++;
   			}
	   	   fprintf(f22,"%c",BPtrans(m->Assign_PB[i21+x2]));	   
   		   }
	   fprintf(f22,"\n");	   
	   of(f22);
	   fprintf(f21,"END\n");
	   of(f21);
}


void WriteTheXYZturn(char *stmp, int nbresidue, pdbfile *m, long i21, long y21){
	FILE *f21;
        long x,x2,y;
	/*char cp='A';*/	/* to be modified */
	long cp2=0;
	int end=4;	/* only the backbone */
	
	if(Werboze=='T') printf("WriteTheXYZturn : %s\n",stmp);
        f21=fopen(stmp,"w");
       
        cp2=1;

        /* residues with only the backbone */
	
	for(x2=0;x2<nbresidue;x2++){
   		   x=m->deb_residues[i21+x2];
	   	   for(y=0;y<end;y++){
   			fprintf(f21,"%8.3f%8.3f%8.3f\n",\
	   		m->pdbatomtype[x+y].ATOM_CoordX,m->pdbatomtype[x+y].ATOM_CoordY,m->pdbatomtype[x+y].ATOM_CoordZ);
	   		cp2++;
   			}
   		   }
	   of(f21);
}

double CalculSum(pdbfile *m, int test, int decal,int nbres, long i21){	
	int u;
	double sum=0;

       for(u=0;u<nbres;u++)
 	sum+=(DistAngMin(m->Phi[i21+1+u],alpha_turn[test-decal][2*u]))+(DistAngMin(m->Psi[i21+1+u],alpha_turn[test-decal][(2*u)+1]));
       /*printf("%lf\n",sum);*/
	return(sum);
}	

void researchbestturn(char *stmp, char *stmp2, int nbresidue, pdbfile *m, long i21, long y21, double sumdist,int test, int decal, char *name){
	FILE *fres;
	double val=-452.;;
	clean_str(stmp,60);
	clean_str(stmp2,60);
	
	/*sprintf(stmp,"CODE/DATA/TURN/best_pdb_turn_%d.val",test);*/
	sprintf(stmp,"CODE/DATA/TURN/best_pdb_turn_%s.val",name);
	fres=flire(stmp);
	fscanf(fres,"%lf\n",&val);
	of(fres);
	
	if(val>sumdist){
		printf("valeur sup (%d) : %lf < %lf\n",test,val,sumdist);
		clean_str(stmp,60);
		sprintf(stmp,"CODE/DATA/TURN/best_pdb_turn_%s.pdb",name);
		sprintf(stmp2,"CODE/DATA/TURN/best_pdb_turn_%s.bp",name);		
		WriteThePDBturn(stmp, stmp2,nbresidue, m, i21, y21);
		clean_str(stmp,60);
		sprintf(stmp,"CODE/DATA/TURN/best_pdb_turn_%s.xyz",name);
		WriteTheXYZturn(stmp,nbresidue, m, i21, y21);
		clean_str(stmp,60);
		sprintf(stmp,"CODE/DATA/TURN/best_pdb_turn_%s.val",name);
		fres=fecrire(stmp);
		fprintf(fres,"%lf\n",sumdist);
		of(fres);
		}
	/*superpos(nbresidue,name,i21,m);*/
}
	
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/



char MaxDist(pdbfile *m,long atomX,long atomY, long pos1, long pos2, double max){	

if(fabsf(distance_interATOM(m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordZ,\
		m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordZ))<(max))
		return('T');
		else return('F');
}


char SearchPhiEvol(pdbfile *m,long pos,double angle,double ecart_autorise_max,double (*ecart_autorise_maxmax)){
	char ret='F';
	double diff=DistAngMin(m->Phi[pos],angle);
	if(diff<ecart_autorise_max){ret='T';}
	else{
	if(diff<(*ecart_autorise_maxmax)){ret='T';(*ecart_autorise_maxmax)=-15.0;}
	}
	return(ret);
}

char SearchPsiEvol(pdbfile *m,long pos,double angle,double ecart_autorise_max,double (*ecart_autorise_maxmax)){
	char ret='F';
	double diff=DistAngMin(m->Psi[pos],angle);
	if(diff<ecart_autorise_max){ret='T';}
	else{
	if(diff<(*ecart_autorise_maxmax)){ret='T';(*ecart_autorise_maxmax)=-15.0;}
	}
	return(ret);
}

/* gamma */
char EntreDist2(pdbfile *m,long atomX,long atomY, long pos1, long pos2, double min, double max){	

	double dist=fabsf(distance_interATOM(m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordZ,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordZ));
	/*printf("%lf %lf %lf \n",dist,min,max);*/
	if((dist>min)&&(dist<max))
		return('T');
		else return('F');
}

char SearchPhi2(pdbfile *m,long pos,double angle,double ecart_autorise_max){		
	if(DistAngMin(m->Phi[pos],(angle))<ecart_autorise_max)return('T');
	else return('F');
}

char SearchPsi2(pdbfile *m,long pos,double angle,double ecart_autorise_max){		
	if(DistAngMin(m->Psi[pos],(angle))<ecart_autorise_max)return('T');
	else return('F');
}


/***##***/
/* 0036 bis */
/***##***/

/*********************************************************************************************/
/*			pour avoir une distance entre 2 atomes			             */
/*********************************************************************************************/

char EntreDist(pdbfile *m,long atomX,long atomY, long pos1, long pos2, double min, double max){	

if(fabsf(distance_interATOM(m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomX]+pos1].ATOM_CoordZ,\
		m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordX,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordY,m->pdbatomtype[m->deb_residues[atomY]+pos2].ATOM_CoordZ)-min)<(max-min))
		return('T');
		else return('F');
}

char SearchPhi(pdbfile *m,long pos,double angle,double ecart_autorise_max){		
	if(fabsf(m->Phi[pos]-(angle))<ecart_autorise_max)return('T');
	else return('F');
}

char SearchPsi(pdbfile *m,long pos,double angle,double ecart_autorise_max){		
	if(fabsf(m->Psi[pos]-(angle))<ecart_autorise_max)return('T');
	else return('F');
}
			
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
void TurnClean(pdbfile *m){

	FILE *f_al;
	long y21;
	short int test=0;
	long t21,i21;
	/*short int numchain=0;*/
	char stmp[60];
	char stmp2[60];
	long num[25];
	long i,io;
	int nbturn=0;
	
	int numtype;	
	double anglediff=30.0;
	double anglediffmax=45.0;
	double phi1,psi1,phi2,psi2,phi3,psi3;
	char ok='B';
	char naming[150];
	double sumdist;
	
	short int turnturn;
	
	/* for the numbering of PDB files */		
	
	f_al=fopen(".typenext2","r");
	for(i=0;i<25;i++)
		fscanf(f_al,"%ld",&num[i]);
	fclose(f_al);
	
	if(Werboze=='T')  printf("Recherche des clean turns en cours\t==>\t");
	
	t21=0;
	if(m->Nb_residues>0){
	for(y21=0;y21<((m->NB_chain)+1);y21++){
	if((m->Pos_LastRes[y21]-m->Pos_FirstRes[y21]+1)>10){
	for(i21=m->Pos_FirstRes[y21]+4;i21<m->Pos_LastRes[y21]-4;i21++){
		
		
		/***********************************/	
		/* 0- Turn for Serge: 3-6 residues */
		/***********************************/
		
		for(turnturn=3;turnturn<7;turnturn++){
		
		
		/* 1- Maximum distance is 7 Angstroms between Calpha residue i and Calpha residue i+turnturn */		

		if(MaxDist(m,i21,i21+turnturn,1,1,7.0)=='T'){

		/*2 - pas 2 mm consecutifs */
		
		test=0;
		for(io=0;io<turnturn;io++)
				if(m->Assign_PB[i21+io]<0)test=19;
		
		for(io=0;io<turnturn-1;io++){
			/*printf("alpha %2ld|%2d %2d %2d\n",io,m->Assign_PB[i21+io],m->Assign_PB[i21+io+1],test);*/
			if((m->Assign_PB[i21+io]==12)&&(m->Assign_PB[i21+io+1]==12)){
				test++;
			/*printf("==> %2d %2d %2d\n",m->Assign_PB[i21+io],m->Assign_PB[i21+io+1],test);*/
			}	
		}	
		
		
		/*3 - pas 3 c et/ou d  consecutifs */
		
		for(io=0;io<turnturn-2;io++){
			/*printf("beta %2ld|%2d %2d %2d %2d\n",io,m->Assign_PB[i21+io],m->Assign_PB[i21+io+1],m->Assign_PB[i21+io+2],test);*/
			if(((m->Assign_PB[i21+io]==2)||(m->Assign_PB[i21+io]==3))&&((m->Assign_PB[i21+io+1]==2)||(m->Assign_PB[i21+io+1]==3))&&((m->Assign_PB[i21+io+2]==2)||(m->Assign_PB[i21+io+2]==3))){
				test++;
			/*printf("==> %2d %2d %2d\n",m->Assign_PB[i21+io],m->Assign_PB[i21+io+1],test);*/
			}	
		}
		
		if(test==0){
		
		f_al=fSurecrire("Results/db_serge.txt");
		
		fprintf(f_al,"%3s%c %d ",m->name,CHAIN,turnturn);
		
		for(io=0;io<turnturn;io++)
			fprintf(f_al,"%c ",m->Nam_residues[i21+io]);
		for(;io<6;io++)
			fprintf(f_al,"%c ",'X');
		for(io=0;io<turnturn;io++)
			fprintf(f_al,"%c ",BPtrans(m->Assign_PB[i21+io]));
		for(;io<6;io++)
			fprintf(f_al,"%c ",'X');			
		fprintf(f_al,"\n");			
		of(f_al);
		
		}
		
		
		} /* dist Calpha*/
		}/*turnturn */
		
	
		/*****************************/	
		/* A- Beta-turn : 4 residues */
		/*****************************/
					
		/* 1- Maximum distance is 7 Angstroms between Calpha residue i and Calpha residue i+3 */		

		if(MaxDist(m,i21,i21+3,1,1,7.0)=='T'){

		/* 2- i+1 and i+2 cannot be alpha-helix (PB m) */
	
		if((m->Assign_PB[i21+1]!=12)&&(m->Assign_PB[i21+2]!=12)){
	
		/* 3- i to i+3 could not be beta-strand (PB d) */
	
		test=0;
		for(io=0;io<4;io++)
			if((m->Assign_PB[i21+io]!=2)||(m->Assign_PB[i21+io]!=3)||(m->Assign_PB[i21+io]!=4)){if(test!=0)test++;}
			else test=0;
			
		if(test==0){
		
		/* 4 -no structural problems */
		
		if((m->Assign_PB[i21]!=(-1))&&(m->Assign_PB[i21+1]!=(-1))&&(m->Assign_PB[i21+2]!=(-1))&&(m->Assign_PB[i21+3]!=(-1))){ 
		
		test=0;
		for(numtype=0;numtype<NB_BETA_TURN;numtype++){ 
		
			phi1=beta_turn[numtype][0]; psi1=beta_turn[numtype][1]; phi2=beta_turn[numtype][2];psi2=beta_turn[numtype][3]; 
			
			anglediff=30.0;
			anglediffmax=45.0;
			
			if((SearchPhiEvol(m,i21+1,phi1,anglediff,&anglediffmax)=='T')&&(SearchPsiEvol(m,i21+1,psi1,anglediff,&anglediffmax)=='T')&&(SearchPhiEvol(m,i21+2,phi2,anglediff,&anglediffmax)=='T')&&(SearchPsiEvol(m,i21+2,psi2,anglediff,&anglediffmax)=='T')){
			if(Werboze=='T') printf("Clean %s trouve avec : i+1 %6.2f (%6.2f) %6.2f (%6.2f) i+2 %6.2f (%6.2f) %6.2f (%6.2f) [difangmax:%6.2f]\n",\
				beta_turn_name[numtype],m->Phi[i21+1],phi1,m->Psi[i21+1],psi1,m->Phi[i21+2],phi2,m->Psi[i21+2],psi2,anglediffmax);
				if(test!=0)num[0]++;				
				test=numtype+1;nbturn++;
				
				for(i=0;i<4;i++){
					switch(test){
					case(1) : m->Turn_Type1[i21+i]=1; break;
					case(2) : m->Turn_Type2[i21+i]=1; break;
					case(3) : m->Turn_Type8[i21+i]=1; break;
					case(4) : m->Turn_Type1I[i21+i]=1; break;
					case(5) : m->Turn_Type2I[i21+i]=1; break;
					case(6) : m->Turn_Type6a1[i21+i]=1; break;
					case(7) : m->Turn_Type6a2[i21+i]=1; break;
					case(8) : m->Turn_Type6b[i21+i]=1; break;
					default : printf("Turn Pb : not assigned %d \n",test);
					}
				}
				
			}
		}				
			if(test==0){ /* no other choice*/
				
				
				if(Werboze=='T') printf("Clean Turn Type IV trouve avec : i+1 %6.2f %6.2f  i+2 %6.2f  %6.2f \n",\
				m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2]);
				for(i=0;i<4;i++)m->Turn_Type4[i21+i]=1;
				test=9;nbturn++;
			}
			

			if((test!=0)){
				num[test]++;
				WriteTurnInfo(m,test,i21,i21,i21+3,1,1,4);
				if(PDBTurn2=='T'){		/* write PDB if needed */
				
					nospace(beta_turn_name[test-1],naming);
					
					clean_str(stmp,60);
					if((test>=1)&&(test<=9))
						sprintf(stmp,"Results/Zx/%s_%ld.pdb",naming,num[test]);
					else sprintf(stmp,"Results/Zx/Problem_%d_will_%ld.pdb",test,num[test]);
				
					if(Werboze=='T') printf("Writing PDB turn files %s\n",stmp);
				 	clean_str(stmp2,60);
	  				sprintf(stmp2,"Results/Zx/Clean_BetaTurns_%d.txt",test);
					WriteThePDBturn(stmp, stmp2,4, m, i21, y21);
				        if(test==9) sumdist=180.0; 						/* for turn IV */
					else sumdist=CalculSum(m,test,1,2,i21);
					researchbestturn(stmp, stmp2,4, m, i21, y21,sumdist,test,1,naming);
					}
			} else printf("ne passe pas %c %d\n,",PDBTurn2,test);
			
		}/* 4-end */
		}/* 3-end */
		}/* 2-end */
		}/* 1-end */
	
		/******************************/	
		/* B- Gamma-turn : 3 residues */
		/******************************/
		
		/* 1- No structural problems */
		
		if((m->Assign_PB[i21]!=(-1))&&(m->Assign_PB[i21+1]!=(-1))&&(m->Assign_PB[i21+2]!=(-1))){ 			

		/* 2- Correct ditance between N=O--H-C */
		/*printf("%ld passage => %c\n",i21,EntreDist2(m,i21,i21+2,0,3,2.0,4.0));*/
		if(EntreDist2(m,i21,i21+2,3,0,2.0,4.0)=='T'){
		/*printf("passe\n");*/
		/* 3- i+1 cannot be alpha-helix (PB m) */
		
		if((m->Assign_PB[i21+1]!=12)){
	
		/* 4- i to i+2 could not be beta-strand (PB d) */
	
		if((m->Assign_PB[i21]!=3)&&(m->Assign_PB[i21+1]!=3)&&(m->Assign_PB[i21+2]!=3)){

		/* 5 - the 2 gamma - turns */
		
		test=0;	
		
		for(numtype=0;numtype<NB_GAMMA_TURN;numtype++){ 
		
			anglediff=40.0;
			phi1=gamma_turn[numtype][0]; psi1=gamma_turn[numtype][1];
	
			if((SearchPhi2(m,i21+1,phi1,anglediff)=='T')&&(SearchPsi2(m,i21+1,psi1,anglediff)=='T')){
				if(Werboze=='T') printf("Clean %s trouve avec :  i+1 %6.2f (%6.2f) %6.2f (%6.2f) \n",gamma_turn_name[numtype],m->Phi[i21+1],phi1,m->Psi[i21+1],psi1);
				if(test!=0)num[0]++;
				test=numtype+10;
				nbturn++;
				switch(test){
					case (10): for(i=0;i<3;i++)m->Turn_GammaClass[i21+i]=1; break;
					case (11): for(i=0;i<3;i++)m->Turn_GammaClassI[i21+i]=1; break;				
				}
			
				if(test!=0){
				num[test]++;
				WriteTurnInfo(m,test,i21,i21,i21+2,1,1,3);
				
				if(PDBTurn2=='T'){
					nospace(gamma_turn_name[test-10],naming);
					
					clean_str(stmp,60);
					if((test>=10)&&(test<=11))
						sprintf(stmp,"Results/Zx/%s_%ld.pdb",naming,num[test]);
					else sprintf(stmp,"Results/Zx/Problem_%d_will_%ld.pdb",test,num[test]);
				
					if(Werboze=='T') printf("Writing PDB turn files %s\n",stmp);
					 clean_str(stmp2,60);
	  				 sprintf(stmp2,"Results/Zx/Clean_GammaTurns_%d.txt",test);
					 WriteThePDBturn(stmp, stmp2,3, m, i21, y21);
					 sumdist=CalculSum(m,test,10,1,i21);
					 researchbestturn(stmp, stmp2,3, m, i21, y21,sumdist,test,10,naming);
	  			
					}
	  			}
			}
			
		}/* B5 -end of the turns */
			
		}/* B4-end */
		}/* B3-end */
		}/* B2-end */
		}/* B1-end */	
		
		/*****************************/	
		/* C- Alpha-turn : 5 residues */
		/*****************************/
					
		/* 1- Maximum distance is 7 Angstroms between Calpha residue i and Calpha residue i+4 */		

		if(MaxDist(m,i21,i21+4,1,1,7.0)=='T'){

		/* 2- i+1 to i+3 cannot be alpha-helix (PB m) (not mentionned but must be done) */
	
		if((m->Assign_PB[i21+1]!=12)&&(m->Assign_PB[i21+2]!=12)&&(m->Assign_PB[i21+3]!=12)){
	
		/* 3- i to i+4 could not be beta-strand (PB d) */
	
		if((m->Assign_PB[i21]!=3)&&(m->Assign_PB[i21+1]!=3)&&(m->Assign_PB[i21+2]!=3)&&(m->Assign_PB[i21+3]!=3)&&(m->Assign_PB[i21+4]!=3)){
		
		/* 4 -no structural problems */
		
		if((m->Assign_PB[i21]!=(-1))&&(m->Assign_PB[i21+1]!=(-1))&&(m->Assign_PB[i21+2]!=(-1))&&(m->Assign_PB[i21+3]!=(-1))&&(m->Assign_PB[i21+4]!=(-1))){ 
		
		
		test=0;	
			
		/* 5 -passage des 9 turns */
			
		for(numtype=0;numtype<NB_ALPHA_TURN;numtype++){ 

			phi1=alpha_turn[numtype][0]; psi1=alpha_turn[numtype][1]; phi2=alpha_turn[numtype][2];psi2=alpha_turn[numtype][3]; phi3=alpha_turn[numtype][4]; psi3=alpha_turn[numtype][5];
			ok='T';
			anglediff=30.0;
			anglediffmax=45.0;
	
			/*for the alpha-C turns where omega 1 is cis*/
	
			if((numtype==(NB_ALPHA_TURN-1))){
				if(DistAngMin(m->Omega[i21+1],0.0)>89.99)ok='F';
				/*printf("%ld ==> %f for %f\t ==> %c\n",i21,DistAngMin(m->Omega[i21+1],0.0),m->Omega[i21+1],ok);*/
				}
				
			if((ok=='T')&&(SearchPhiEvol(m,i21+1,phi1,anglediff,&anglediffmax)=='T')&&(SearchPsiEvol(m,i21+1,psi1,anglediff,&anglediffmax)=='T')&&(SearchPhiEvol(m,i21+2,phi2,anglediff,&anglediffmax)=='T')&&(SearchPsiEvol(m,i21+2,psi2,anglediff,&anglediffmax)=='T')\
			&&(SearchPhiEvol(m,i21+3,phi3,anglediff,&anglediffmax)=='T')&&(SearchPsiEvol(m,i21+3,psi3,anglediff,&anglediffmax)=='T')){
				if(Werboze=='T') printf("*************************Clean %s trouve avec : i+1 %6.2f (%6.2f) %6.2f (%6.2f) i+2 %6.2f (%6.2f) %6.2f (%6.2f) i+2 %6.2f (%6.2f) %6.2f (%6.2f) [difangmax:%6.2f]\n",\
				alpha_turn_name[numtype],m->Phi[i21+1],phi1,m->Psi[i21+1],psi1,m->Phi[i21+2],phi2,m->Psi[i21+2],psi2,m->Phi[i21+3],phi3,m->Psi[i21+3],psi3,anglediffmax);
				if(test!=0)num[0]++;
				test=numtype+12;
				nbturn++;
				for(i=0;i<5;i++)m->Turn_Alpha[i21+i][numtype]=1;
				}
			
		}/*5- fin du tours des 8 turns !!!*/		
		
		if(test!=0){
			num[test]++;
			WriteTurnInfo(m,test,i21,i21,i21+4,1,1,5);
			if(PDBTurn2=='T'){
				nospace(alpha_turn_name[test-12],naming);
				printf("|%s|\n",naming);
			
				clean_str(stmp,60);
				if((test>=12)&&(test<=21))
					sprintf(stmp,"Results/Zx/%s_will_%ld.pdb",naming,num[test]);
				else sprintf(stmp,"Results/Zx/Problem_%d_will_%ld.pdb",test,num[test]);
				
				if(Werboze=='T') printf("Writing PDB turn files %s\n",stmp);
				 clean_str(stmp2,60);
	  			 sprintf(stmp2,"Results/Zx/Clean_AlphaTurns_%d.txt",test);
				 WriteThePDBturn(stmp, stmp2,5, m, i21, y21);
				 
				 sumdist=CalculSum(m,test,12,3,i21);
				 researchbestturn(stmp, stmp2,5, m, i21, y21,sumdist,test,12,naming);
	  			}
			}
			
		}/* 4-end */
		}/* 3-end */
		}/* 2-end */
		}/* 1-end */
	
				
	/* end of the turns */	
	}
	}
	}
	}
		
	if(Werboze=='T'){if(nbturn==1){ printf("il y a %3d turn interessant trouve\n",nbturn);}
			else{
			if(nbturn>0) printf("il y a %3d turns interessant trouves\n",nbturn);
			else  printf("aucun turn interessant trouve\n");
			}
		}	
	f_al=fopen(".typenext2","w");
	for(i=0;i<25;i++)
		fprintf(f_al,"%ld\n",num[i]);
	fclose(f_al);
	
	TransTypeNext();
	
}
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/



/************************************/
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/************************************/


/************************************/
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/************************************/


/************************************/
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/************************************/


/************************************/
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/************************************/


/************************************/
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/************************************/



/************************************/
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/*		Warning	            */
/************************************/


/***##***/
/* 0036 */
/***##***/

/*********************************************************************************************/
/*			Recherche de 7 types de turn differents			             */
/*********************************************************************************************/

void Turn(pdbfile *m){
	FILE *f_al;
	FILE *f21;
	FILE *f22;	
	long y21;
	short int test=0;
	long t21,i21;
	char cp='A';
	/*short int numchain=0;*/
	char stmp[60];
	char stmp2[60];
	long num[16];
	long x,y,i,x2;
	long cp2=0;
	int nbturn=0;
	int end;

	printf("WARNING ==> Please do not use this function (or if you know why)\n");


	/* sert a numeroter les fichiers PDB !!!*/		
	
	f_al=fopen(".typenext","r");
	for(i=0;i<10;i++)
		fscanf(f_al,"%ld",&num[i]);
	fclose(f_al);
	

	if(Werboze=='T')  printf("Recherche des turns en cours\t==>\t");
	
	t21=0;
	if(m->Nb_residues>0){
	for(y21=0;y21<((m->NB_chain)+1);y21++){
			
			/*printf("%d\n",y21);*/
		
			if((m->Pos_LastRes[y21]-m->Pos_FirstRes[y21]+1)>5){
/*			printf("m->Pos_FirstRes[y21]+2 %d Pos_LastRes[y21]-2 %d\n",m->Pos_FirstRes[y21]+2,m->Pos_LastRes[y21]-2);*/

			for(i21=m->Pos_FirstRes[y21]+2;i21<m->Pos_LastRes[y21]-2;i21++){
			
			test=0;
			
			/**********************************************************
								        Phi  Psi
			1- Type turn I : i+1   -60  -30
			   -----------   i+2   -90    0
				      
			2- Type turn II : i+1   -60  +120
			   ------------   i+2    80    0
			
			3- Type turn III : i+1   -60  -30
			   -------------   i+2   -60  -30
			
			6- 3.10 helice : 	 -71 -18 sur les i+1 i+2 
			   -------------
			
			7- 3.10 helice parfaite : -74 -4 sur les i+1 i+2
			   ----------------------
			
			il faut une liaison CO NH entre i et i+3 ==> pris distance N---O entre 2.5 et 3.5 Angstroms
			
			*********************************************************/
			
	if(EntreDist(m,i21,i21+3,3,0,2.5,3.5)=='T'){
		/* avec les residus i et i+3, avec 3 pour l'oxygene de C=0 du i et le 0 pour le N du i+3 */
		if((SearchPhi(m,i21+1,-60.0,5.0)=='T')&&(SearchPsi(m,i21+1,-30,5)=='T')&&(SearchPhi(m,i21+2,-90,5)=='T')&&(SearchPsi(m,i21+2,0,5)=='T')){
			if(Werboze=='T') printf("Turn Type I trouve avec : i+1 %6.2f (-60) %6.2f (-30) i+2 %6.2f (-90) %6.2f (0)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2]);
			test=1;nbturn++;
			}
	
		if((SearchPhi(m,i21+1,-60,5)=='T')&&(SearchPsi(m,i21+1,+120,5)=='T')&&(SearchPhi(m,i21+2,80,5)=='T')&&(SearchPsi(m,i21+2,0,5)=='T')){
			if(Werboze=='T') printf("Turn Type II trouve avec : i+1 %6.2f (-60) %6.2f (+120) i+2 %6.2f (80) %6.2f (0)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2]);
			test=2;nbturn++;
			}

		if((SearchPhi(m,i21+1,-60,5)=='T')&&(SearchPsi(m,i21+1,-30,5)=='T')&&(SearchPhi(m,i21+2,-60,5)=='T')&&(SearchPsi(m,i21+2,-30,5)=='T')){			
			if(Werboze=='T') printf("Turn Type III trouve avec : i+1 %6.2f (-60) %6.2f (-30) i+2 %6.2f (-60) %6.2f (-30)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2]);
			test=3;nbturn++;
			}
		
		if((SearchPhi(m,i21+1,-71,5)=='T')&&(SearchPsi(m,i21+1,-18,5)=='T')&&(SearchPhi(m,i21+2,-71,5)=='T')&&(SearchPsi(m,i21+2,-18,5)=='T')){			
			if(Werboze=='T') printf("3.10  helice trouve avec : i+1 %6.2f (-71) %6.2f (-18) i+2 %6.2f (-71) %6.2f (-18)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2]);
			test=6;nbturn++;
			}
		
		if((SearchPhi(m,i21+1,-74,5)=='T')&&(SearchPsi(m,i21+1,-4,5)=='T')&&(SearchPhi(m,i21+2,-74,5)=='T')&&(SearchPsi(m,i21+2,-4,5)=='T')){			
			if(Werboze=='T') printf("3.10 \"parfaite\" helice trouve avec : i+1 %6.2f (-74) %6.2f (-4) i+2 %6.2f (-74) %6.2f (-4)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2]);
			test=7;nbturn++;
			}
		
		}	
			
			
			/**********************************************************
			 				 Phi	Psi
							
			4- Gamma turn : 	   i+1   +70  -60
			   ----------
			5- Inverse Gamma turn :    i+1   -70  +60
			   ------------------
			   
			il faut une liaison CO NH entre i et i+2 ==> pris distance N---O entre 2.5 et 3.5 Angstroms
			
			*********************************************************/
			
		if(EntreDist(m,i21,i21+2,0,3,2.5,3.5)=='T'){
		if((SearchPhi(m,i21+1,+70,5)=='T')&&(SearchPsi(m,i21+1,-60,5)=='T')){
			if(Werboze=='T') printf("Gamma turn trouve avec :  i+1 %6.2f (+70) %6.2f (-60) i\n",m->Phi[i21+1],m->Psi[i21+1]);
			test=4;nbturn++;
			}
		if((SearchPhi(m,i21+1,-70,5)=='T')&&(SearchPsi(m,i21+1,+60,5)=='T')){
			if(Werboze=='T') printf("Inverse Gamma turn  trouve avec :  i+1 %6.2f (-70) %6.2f (+60) i\n",m->Phi[i21+1],m->Psi[i21+1]);
			test=5;nbturn++;
			}
			
		}
			
			/*
			

			  
			8- pi-helix : -57.1 -69.7 sur i+1 i+2 i+3 
			   ----------
			  
			  il faut une liaison CO NH entre i et i+5
			  			    
			*/
			
				
		if(EntreDist(m,i21,i21+5,0,3,2.5,3.5)=='T'){
		if((SearchPhi(m,i21+1,-57.1,5)=='T')&&(SearchPsi(m,i21+1,-69.7,5)=='T')&&(SearchPhi(m,i21+2,-57.1,5)=='T')&&(SearchPsi(m,i21+2,-69.7,5)=='T')&&\
		(SearchPhi(m,i21+3,-57.1,5)=='T')&&(SearchPsi(m,i21+3,-69.7,5)=='T')&&(SearchPhi(m,i21+4,-57.1,5)=='T')&&(SearchPsi(m,i21+4,-69.7,5)=='T')){
			if(Werboze=='T') printf("pi helice trouve avec : i+1 %6.2f (-57) %6.2f (-70) i+2 %6.2f (-57) %6.2f (-70)  i+3 %6.2f (-57) %6.2f (-70)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2],m->Phi[i21+3],m->Psi[i21+3]);
			test=8;nbturn++;
			}
		}
		
		if(EntreDist(m,i21,i21+5,0,3,2.5,7.5)=='T'){
		if((SearchPhi(m,i21+1,-57.1,15)=='T')&&(SearchPsi(m,i21+1,-69.7,15)=='T')&&(SearchPhi(m,i21+2,-57.1,15)=='T')&&(SearchPsi(m,i21+2,-69.7,15)=='T')&&\
			(SearchPhi(m,i21+3,-57.1,15)=='T')&&(SearchPsi(m,i21+3,-69.7,15)=='T')&&(SearchPhi(m,i21+4,-57.1,15)=='T')&&(SearchPsi(m,i21+4,-69.7,15)=='T')){
			if(Werboze=='T') printf("pi helice \"approxiamtive\" trouve avec : i+1 %6.2f (-57) %6.2f (-70) i+2 %6.2f (-57) %6.2f (-70)  i+3 %6.2f (-57) %6.2f (-70)\n",\
			m->Phi[i21+1],m->Psi[i21+1],m->Phi[i21+2],m->Psi[i21+2],m->Phi[i21+3],m->Psi[i21+3]);
			test=9;nbturn++;
			}
		}
			
			/* Non fait : alpha i i+4 et -60 +/-7 et -14 +/-7 ; le alpha  pur est a -57.8 et -47.0 */
			
			/*printf("i21 %d %d %f  %f\n",i21,test,m->Phi[i21+1],(fabsf(m->Phi[i21+1]+57)));*/
			
			if(test!=0){
				end=4;
				
				clean_str(stmp,60);
				switch (test){
				case (1) : sprintf(stmp,"Results/Zx/Turn_Type_I_%ld.pdb",num[test]); break;
				case (2) : sprintf(stmp,"Results/Zx/Turn_Type_II_%ld.pdb",num[test]); break;
				case (3) : sprintf(stmp,"Results/Zx/Turn_Type_III_%ld.pdb",num[test]); break;
				case (4) : sprintf(stmp,"Results/Zx/Turn_Gamma_%ld.pdb",num[test]); break;
				case (5) : sprintf(stmp,"Results/Zx/Turn_Gamma_Inverse_%ld.pdb",num[test]); break;
				case (6) : sprintf(stmp,"Results/Zx/helice_3.10_%ld.pdb",num[test]); end=6; break;
				case (7) : sprintf(stmp,"Results/Zx/helice_3.10_parfaite_%ld.pdb",num[test]); end=6; break;
				case (8) : sprintf(stmp,"Results/Zx/Pi_helice_%ld.pdb",num[test]); end=6; break;
				case (9) : sprintf(stmp,"Results/Zx/Pi_helice_floue_%ld.pdb",num[test]); end=6; break;
				case (0) : sprintf(stmp,"Results/Zx/Type_%d_will_%ld.pdb",test,num[test]); break;
				default  : printf("Il ya un probleme pour un turn introuvable de type %d\n",test); 
				sprintf(stmp,"Results/Zx/Type_%d_will_%ld.pdb",test,num[test]);
				};
				
				clean_str(stmp2,60);
				sprintf(stmp2,"Results/Zx/Type_%d.txt",test);
				/*printf("%s\n",stmp);*/
				f21=fopen(stmp,"w");
				f22=fopen(stmp2,"a+");
				fprintf(f21,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,cp,m->Pos_LastRes[y21]-m->Pos_FirstRes[y21]+1,m->resolution);
				cp2=1;
				/* 4  residus avec les 4 morceaux du backbone*/
				
				
				
				for(x2=0;x2<4;x2++){
					x=m->deb_residues[i21+x2];
					for(y=0;y<end;y++){
					     fprintf(f21,"ATOM    %3.0ld %3s %4s %c%4ld ",\
					     cp2,m->pdbatomtype[x+y].ATOM_name,m->pdbatomtype[x+y].ATOM_residuesname,\
					     cp,m->pdbatomtype[x+y].ATOM_residuesnumber);
					     fprintf(f21,"   %8.3f%8.3f%8.3f  1.00 19.19             %c\n",\
					     m->pdbatomtype[x+y].ATOM_CoordX,m->pdbatomtype[x+y].ATOM_CoordY,m->pdbatomtype[x+y].ATOM_CoordZ,m->pdbatomtype[x+y].ATOM_real);
					     cp2++;
					     }
					fprintf(f22,"%c",BPtrans(m->Assign_PB[i21+x2]));	
					}
				fprintf(f22,"\n");	
				fclose(f22);
				fprintf(f21,"END\n");
				fclose(f21);
				num[test]++;
				}
			}	
			t21=0;					
			cp++;
			}		
		}
		
	}
	
	if(Werboze=='T'){if(nbturn==1){ printf("il y a %3d turn interessant trouve\n",nbturn);}
			else{
			if(nbturn>0) printf("il y a %3d turns interessant trouves\n",nbturn);
			else  printf("aucun turn interessant trouve\n");
			}
		}	
	f_al=fopen(".typenext","w");
	for(i=0;i<10;i++)
		fprintf(f_al,"%ld\n",num[i]);
	fclose(f_al);
	
		
	
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

