# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/options.h"

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0043 */
/***##***/

/*********************************************************************************************/
/*				s'il n'y a pas de header			             */
/*********************************************************************************************/

void CheckName(pdbfile *m){
	int j43;
	
	if(CHECK_DBG=='T') printf("step 0043 |%s|0:%c|\n",m->name,m->name[0]);
	
	if((m->name[0]==' ')||(strlen(m->name)<1)){
		printf("recherche du nom de la proteine PDB\n");
	for(j43=strlen(nom_fichier)-8;j43<strlen(nom_fichier)-4;j43++)
		m->name[j43-(strlen(nom_fichier)-8)]=nom_fichier[j43];
	if(PRAPIA=='T')
	for(j43=0;j43<7;j43++)
		m->name[j43]=nom_fichier[j43];
	printf("recherche du nom de la proteine PDB %s\n",m->name);
	}
}
/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0032 */
/***##***/

double DistAngMin(const double A,const double B){
	double d=fabsf(A-B);
	if (d>180.) return(fabsf(d-360.));
	return(d);
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0031 */
/***##***/

/*********************************************************************************************/
/*			pour assignation au Protein Block reel				     */
/*********************************************************************************************/

short int WhichBP(double v[NB_ANGLES],double BP[NB_BP][NB_ANGLES]){
	double Fdist[NB_BP];
	short int y21,x21,best=0;
	
	for(y21=0;y21<NB_BP;Fdist[y21++]=0.);
	for(y21=0;y21<NB_BP;y21++)
		for(x21=0;x21<NB_ANGLES;x21++)
/* 0032 */		Fdist[y21]+=DistAngMin(BP[y21][x21],v[x21]);
			

	for(y21=1;y21<NB_BP;y21++)
		if (Fdist[y21]<Fdist[best])best=y21;
	if (CHECK_DBG=='T'){printf("%d %.2f\n",best,Fdist[best]);}
	return(best);
}

	/* retour de la valeur minimale associee */

float valWhichBP(double v[NB_ANGLES],double BP[NB_BP][NB_ANGLES]){
	double Fdist[NB_BP];
	short int y21,x21,best=0;
	
	for(y21=0;y21<NB_BP;Fdist[y21++]=0.0);
	for(y21=0;y21<NB_BP;y21++)
		for(x21=0;x21<NB_ANGLES;x21++)
/* 0032 */		Fdist[y21]+=DistAngMin(BP[y21][x21],v[x21]);
			

	for(y21=1;y21<NB_BP;y21++)
		if (Fdist[y21]<Fdist[best])best=y21;
	if (CHECK_DBG=='T'){printf("%d %.2f\n",best,Fdist[best]);}
	return(Fdist[best]);
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0030*/
/***##***/

/*********************************************************************************************/
/*			pour assignation des Blocks Proteik				     */
/*********************************************************************************************/

void AssignBP(pdbfile *m){
	FILE *fpb;
	FILE *f21;
	FILE *f21b;
	FILE *f21c;
	long y20,x20,z20,w20;
	long deb;
	double vect[NB_ANGLES];
	double bp[NB_BP][NB_ANGLES];
	double *X,*Y,*Z,*X_frag,*Y_frag,*Z_frag;
	
	float minrmsda[NB_BP];
	char stmp56[60];
	short int cp2;
	short int x2;
	int x,y;
	char stmp57[60];
	
	float decalX[16];
	float decalY[16];
	float fc;
	float decal=25.0;
	
	fc=0.0; for(x=0;x<16;x++){decalX[x]=fc;fc+=decal;	if(fc>=(4*decal)) 	fc=0;}
	y=0;fc=0.0; for(x=0;x<16;x++){decalY[x]=fc;y++;	if(y==4) 	{fc+=decal;y=0;}}
	
	if(Werboze=='T')  printf("Calcul des Blocs Proteiques de la proteine %s\n",m->name);
	
	if(WORK_BEST_PB=='T'){	
		/*printf("WORK_BEST_PB est %c\n",WORK_BEST_PB);*/
		fpb=fopen("CODE/DATA/Protein_Blocks/best.rmsda","r");
		for(x20=0;x20<NB_BP;fscanf(fpb,"%f",&minrmsda[x20++]));
		fclose(fpb);
		}
			
	fpb=flire("CODE/DATA/Angular_values.txt");for(x20=0;x20<NB_BP;x20++)for(y20=0;y20<NB_ANGLES;fscanf(fpb,"%lf ",&bp[x20][y20++]));fclose(fpb);
	
						if (CHECK_DBG=='T'){fpb=fopen("./Results/BSP_init_16.ord2","w");
							for(x20=0;x20<NB_BP;x20++){fprintf(fpb,"\n");
							for(y20=0;y20<NB_ANGLES;fprintf(fpb,"%8.2f ",bp[x20][y20++]));}fclose(fpb);}
	
	for(x20=0;x20<(m->Nb_residues);m->Assign_PB[x20++]=-1);			/* par default il y a rien */
	
	for(z20=0;z20<((m->NB_chain)+1);z20++){
		if((m->Pos_LastRes[z20]+m->Pos_FirstRes[z20]+1)>MIN_LONGEUR){
		for(w20=m->Pos_FirstRes[z20];w20<m->Pos_LastRes[z20]-4;w20++){
			deb=w20;/*printf("%ld\n",w20); ecrit la position */
			
/*			for(x=0;x<16;x++){printf("%2d %f %f \n",x,decalX[x],decalY[x]);}*/
			
			for(y20=0;y20<NB_ANGLES;){
				vect[y20++]=m->Psi[deb];			
				vect[y20++]=m->Phi[deb+1];
				deb++;}
/* 0031*/		m->Assign_PB[w20+2]=WhichBP(vect,bp);
	
		if(WORK_BEST_PB=='T'){
				if(minrmsda[(m->Assign_PB[w20+2])]>sqrt(valWhichBP(vect,bp)/(float)NB_ANGLES)){
				memset(stmp56,' ',60);
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/Angles_associes_a_PB_%d.txt",m->Assign_PB[w20+2]);
				f21c=fopen(stmp56,"a+");
				for(y20=0;y20<NB_ANGLES;fprintf(f21c,"%f ",vect[y20++]));
				fprintf(f21c,"\n");
				fclose(f21c);
				
				printf("Protein Block %d plus proche avec un rmsda de %8.2f\n",m->Assign_PB[w20+2],sqrt(valWhichBP(vect,bp)/(float)NB_ANGLES));
				minrmsda[(m->Assign_PB[w20+2])]=sqrt(valWhichBP(vect,bp)/(float)NB_ANGLES);
				memset(stmp56,' ',60);
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/%d.pdb",m->Assign_PB[w20+2]);
				f21=fopen(stmp56,"w");
				fprintf(f21,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',m->Pos_LastRes[w20]-m->Pos_FirstRes[w20]+1,m->resolution);
				cp2=1;
					/* 4  residus avec les 4 morceaux du backbone*/
				for(x2=0;x2<5;x2++){
					x=m->deb_residues[w20+x2];
					for(y=0;y<4;y++)
						{
						fprintf(f21,"ATOM    %3.0d %3s %4s %c%4ld ",\
						cp2,m->pdbatomtype[x+y].ATOM_name,m->pdbatomtype[x+y].ATOM_residuesname,\
						'A',m->pdbatomtype[x+y].ATOM_residuesnumber);
						fprintf(f21,"   %8.3f%8.3f%8.3f  1.00 19.19             %c\n",\
						m->pdbatomtype[x+y].ATOM_CoordX,m->pdbatomtype[x+y].ATOM_CoordY,m->pdbatomtype[x+y].ATOM_CoordZ,m->pdbatomtype[x+y].ATOM_real);
						cp2++;
						}
					}
				fprintf(f21,"END\n");
				fclose(f21);
				
				memset(stmp56,' ',60);
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/rearr_%d.pdb",m->Assign_PB[w20+2]);
				f21=fopen(stmp56,"w");
				fprintf(f21,"HEADER\t\t\t\t\t%4s%c %6ld BP16  %1.1f\n",m->name,'A',m->Pos_LastRes[w20]-m->Pos_FirstRes[w20]+1,m->resolution);
				cp2=1;
					/* 4  residus avec les 4 morceaux du backbone*/
				for(x2=0;x2<5;x2++){
					x=m->deb_residues[w20+x2];
					for(y=0;y<4;y++)
						{
						fprintf(f21,"ATOM    %3.0d %3s %4s %c%4ld ",\
						cp2,m->pdbatomtype[x+y].ATOM_name,m->pdbatomtype[x+y].ATOM_residuesname,\
						'A',m->pdbatomtype[x+y].ATOM_residuesnumber);
						fprintf(f21,"   %8.3f%8.3f%8.3f  1.00 19.19             %c\n",\
						(m->pdbatomtype[x+y].ATOM_CoordX)-m->pdbatomtype[m->deb_residues[w20+2]+1].ATOM_CoordX+decalX[m->Assign_PB[w20+2]],\
						(m->pdbatomtype[x+y].ATOM_CoordY)-m->pdbatomtype[m->deb_residues[w20+2]+1].ATOM_CoordY+decalY[m->Assign_PB[w20+2]],
						(m->pdbatomtype[x+y].ATOM_CoordZ)-m->pdbatomtype[m->deb_residues[w20+2]+1].ATOM_CoordZ,\
						m->pdbatomtype[x+y].ATOM_real);
						cp2++;
						}
					}
				fprintf(f21,"END\n");
				fclose(f21);
				
				
				memset(stmp56,' ',60);
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",m->Assign_PB[w20+2]);
				f21=fopen(stmp56,"w");
				for(x2=0;x2<5;x2++){
					x=m->deb_residues[w20+x2];y=1;
					fprintf(f21,"%8.3f\n%8.3f\n%8.3f\n",m->pdbatomtype[x+y].ATOM_CoordX,m->pdbatomtype[x+y].ATOM_CoordY,m->pdbatomtype[x+y].ATOM_CoordZ);
					}
				fclose(f21);
				}
			}
		
		if(PB_RMSD=='T'){
		
			X=(double*)calloc(5,sizeof(double));
			Y=(double*)calloc(5,sizeof(double));
			Z=(double*)calloc(5,sizeof(double));
			X_frag=(double*)calloc(5,sizeof(double));
			Y_frag=(double*)calloc(5,sizeof(double));
			Z_frag=(double*)calloc(5,sizeof(double));
		
				/* Pour superposer les fragments / PBs  */
			printf("test PB_RMSD en position %ld\n",w20);
			
				/* fragment de la proteine */
			for(x2=0;x2<5;x2++){x=m->deb_residues[w20+x2];	y=1;
					X_frag[x2]=m->pdbatomtype[x+y].ATOM_CoordX;
					Y_frag[x2]=m->pdbatomtype[x+y].ATOM_CoordY;
					Z_frag[x2]=m->pdbatomtype[x+y].ATOM_CoordZ;
					}
				memset(stmp56,' ',60);
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/x%d.txt",m->Assign_PB[w20+2]);
				f21=fopen(stmp56,"r");		
				for(x2=0;x2<5;x2++){
					fscanf(f21,"%lf\n",&X[x2]);
					fscanf(f21,"%lf\n",&Y[x2]);
					fscanf(f21,"%lf\n",&Z[x2]);
					/*printf("%lf %lf %lf | %lf %lf %lf\n",X_frag[x2],Y_frag[x2],Z_frag[x2],X[x2],Y[x2],Z[x2]);*/
					}
				fclose(f21);
				x2=w20;
/* vieille version 01 */				
				/* mainpass(X,Y,Z,X_frag,Y_frag,Z_frag,m->name,w20); */

/* vieille version 02 mise aprs Sippl maintenant */				

				/* mainpass2(X,Y,Z,X_frag,Y_frag,Z_frag,m->name,w20);
				printf("test PB_RMSD 01 %ld\n",w20);*/
				/* mainpass3(X,Y,Z,X_frag,Y_frag,Z_frag,m->name,w20,5);
				printf("test PB_RMSD 02 %ld\n",w20);*/
				
				mainpassSippl(X,Y,Z,X_frag,Y_frag,Z_frag,5);
				mainpass3(X,Y,Z,X_frag,Y_frag,Z_frag,m->name,w20,5);
				printf("test PB_RMSD 02 post Sippl %ld\n",w20);
				
				free(X);free(Y);free(Z);free(X_frag);free(Y_frag);free(Z_frag);
				
				}

		if(SIPPL=='T'){		/* Pour superposer les fragments / PBs  */
			printf("Sippl test %ld\n",w20);
			
			
			X=(double*)calloc(11,sizeof(double));
			Y=(double*)calloc(11,sizeof(double));
			Z=(double*)calloc(11,sizeof(double));
			X_frag=(double*)calloc(11,sizeof(double));
			Y_frag=(double*)calloc(11,sizeof(double));
			Z_frag=(double*)calloc(11,sizeof(double));
		
			printf("01\n");
				/* fragment de la proteine */
			for(x2=0;x2<11;x2++){x=m->deb_residues[w20+x2];	y=1;
					X_frag[x2]=m->pdbatomtype[x+y].ATOM_CoordX;
					Y_frag[x2]=m->pdbatomtype[x+y].ATOM_CoordY;
					Z_frag[x2]=m->pdbatomtype[x+y].ATOM_CoordZ;
					}
			
			printf("02\n");
								
				memset(stmp56,' ',60);
				sprintf(stmp56,"CODE/DATA/Protein_Blocks/11_x%d.txt",m->Assign_PB[w20+2]);
				f21=fopen(stmp56,"r");		
				for(x2=0;x2<11;x2++){
					fscanf(f21,"%lf\n",&X[x2]);
					fscanf(f21,"%lf\n",&Y[x2]);
					fscanf(f21,"%lf\n",&Z[x2]);
					/*printf("%lf %lf %lf | %lf %lf %lf\n",X_frag[x2],Y_frag[x2],Z_frag[x2],X[x2],Y[x2],Z[x2]);*/
					}
				fclose(f21);
			printf("02\n");				
				x2=w20;
				
				mainpassSippl(X,Y,Z,X_frag,Y_frag,Z_frag,11);
				mainpass4(X,Y,Z,X_frag,Y_frag,Z_frag,m->name,w20,11);
				printf("test PB_RMSD X01 post Sippl %ld\n",w20);
				
 				free(X);free(Y);free(Z);free(X_frag);free(Y_frag);free(Z_frag);
				}
				
				
			if(RAMA=='T'){
			memset(stmp57,' ',60);
			sprintf(stmp57,"Results/Rama/%d.ang",m->Assign_PB[w20+2]);
			f21b=fopen(stmp57,"a+");
			for(y20=0;y20<NB_ANGLES;fprintf(f21b,"%f ",vect[y20++]));
			fprintf(f21b,"\n");
			fclose(f21b);
			}
				
				
			/*printf("%d\n",m->Assign_PB[w20+2]); ecrit le bloc */
			}
		}	
	}
				/* s'il sont incomplets sur la chaine polypep. des acides amines */
	
		
	for(x20=((int)(NB_AAinuse)/2);x20<(m->Nb_residues)+(int)(-(NB_AAinuse)/2);x20++)
			if(m->Complete_Res[x20]=='I') 	/* donnera 'I' en fasta*/
				for(y20=(int)(-(NB_AAinuse)/2);y20<(int)NB_AAinuse/2;y20++){
					m->Assign_PB[x20+y20]=-3;
					}
				

	if(CHECK_DBG=='T') printf(" (m->NB_chain) %d step 0030\n",(m->NB_chain));
	
	if(WORK_BEST_PB=='T'){	
		fpb=fopen("CODE/DATA/Protein_Blocks/best.rmsda","w");
		for(x20=0;x20<NB_BP;fprintf(fpb,"%f\n",minrmsda[x20++]));
		fclose(fpb);
		}
	
		
	
		
		
	
		/************* Travail Actuel *************/
		
/*TODO	RekonST(m,bp);*/		/* reconstruction simple*/

/*TODO	RekonST_Lib01(m);*/   /* reconstruction librairie*/
	
/*TODO	WriteRekonST(m);*/    /*ecriture de la reconstruction*/
		
}		

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0029 */
/***##***/

/*********************************************************************************************/
/* 				passage Gradiant a degres 				     */
/*********************************************************************************************/

double GradToDeg(double ang){	
        return (double)(ang*180.)/(double)(M_PI);
        }

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0028 */
/***##***/

/*********************************************************************************************/
/*			Calculs des dihedres proprements dits				     */
/*********************************************************************************************/

double Calcul_Diehedral(double *X,double *Y,double *Z){

      double ABx,ABy,ABz;
      double BCx,BCy,BCz;
      double CDx,CDy,CDz;
      double Nx,Ny,Nz;
      double Mx,My,Mz;
      double Nnorm,Mnorm;
      double cosa;
      
      		/* calcul des vecteurs AB, BC et CD qui definissent les 2 plans ABC et BCD */
      
      ABx=X[1]-X[0];
      ABy=Y[1]-Y[0];
      ABz=Z[1]-Z[0];      
      
      BCx=X[2]-X[1];
      BCy=Y[2]-Y[1];
      BCz=Z[2]-Z[1];      

      CDx=X[3]-X[2];
      CDy=Y[3]-Y[2];
      CDz=Z[3]-Z[2];      

		/* calcul des norm. aux deux plans (le vecteur orthogonal) */

      Nx=ABy*BCz-ABz*BCy;
      Ny=ABz*BCx-ABx*BCz;
      Nz=ABx*BCy-ABy*BCx;
      
      Mx=BCy*CDz-BCz*CDy;
      My=BCz*CDx-BCx*CDz;
      Mz=BCx*CDy-BCy*CDx;

		/* le produit scalaire des deux vecteurs */

      Nnorm=sqrt(Nx*Nx+Ny*Ny+Nz*Nz);
      Mnorm=sqrt(Mx*Mx+My*My+Mz*Mz);
    
    		/* la formule donnant l'angle */
    
      cosa=(Nx*Mx+Ny*My+Nz*Mz)/(Nnorm*Mnorm);
      
      if(fabs(cosa)>1.1){ printf("ben y a pb %8.8f> 1.0000\n",cosa);
		}
      if(fabs(cosa)>1.)cosa=1.;		/* petit pb d'arrondi qui donne -1.00000012 */
		
      
      		/* passage de l'arcos a l'angle et passage en degree */
/* 0029 */      
      cosa=GradToDeg(acos(cosa));
      
      		/* verification pour voir le signe */
      
      ABx=Nx*(My*BCz-Mz*BCy)+\
          Ny*(Mz*BCx-Mx*BCz)+\
	  Nz*(Mx*BCy-My*BCx);
      if(ABx<0)	cosa=-cosa;
      
      return (cosa);
   
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0027*/
/***##***/

/*********************************************************************************************/
/*		passage des coordonnes de chaque atome (moulinette)			     */
/*********************************************************************************************/

void Designation_ATOM(pdbfile *m, double *X, double *Y, double *Z,const long n1,const long n2,const long n3, const long n4){
	long y_11=0; 
	long tamp_11=0;

			       for(y_11=0;y_11<4;y_11++){
					switch (y_11){
						case (0) : tamp_11 = n1; break;
						case (1) : tamp_11 = n2; break;
						case (2) : tamp_11 = n3; break;
						case (3) : tamp_11 = n4; break;
						default : printf("erreur y_11 donne %ld\n",y_11);
					};
			      		X[y_11]=m->pdbatomtype[tamp_11].ATOM_CoordX;	
				     	Y[y_11]=m->pdbatomtype[tamp_11].ATOM_CoordY;
				      	Z[y_11]=m->pdbatomtype[tamp_11].ATOM_CoordZ;
				}
}	

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0026 */
/***##***/

/*********************************************************************************************/
/*		Calculs des angles Phi, Psi, Omega et Xhi des proteines			     */
/*********************************************************************************************/

void Angles_Research(pdbfile *m){
	long y_09;
	double X[4];
	double Y[4];
	double Z[4];
	long numberOf_Residue,il,jl;
	short int cursor[4]={0,1,4,5};
/*	short int c_09;*/
	
	if(Werboze=='T') printf("calcul des angles de la proteine %s\n",m->name);
	
	/**printf("%d %d %d\n",m->NB_chain,m->Pos_FirstRes[0],m->Pos_LastRes[0]);*/
	
	for(il=0;il<(m->NB_chain)+1;il++){
		for(jl=m->Pos_FirstRes[il];jl<m->Pos_LastRes[il];jl++){
		
				numberOf_Residue=jl;	/* variable tampon plus lisible*/ 
				
	if(numberOf_Residue>m->Pos_FirstRes[il]){	
					/*************************/
					/* calcul de l'angle Phi */
					/*************************/			
				
			/******************************************************************************/
			/* le C' qui est au residue precedent : C'-1 & le N, C alpha et C' du residue */
			/******************************************************************************/
						      
/* 0027*/
			    Designation_ATOM(m,X,Y,Z,m->deb_residues[numberOf_Residue-1]+2,m->deb_residues[numberOf_Residue],\
			      		m->deb_residues[numberOf_Residue]+1,m->deb_residues[numberOf_Residue]+2);
/* 0028 */
			    m->Phi[numberOf_Residue]=Calcul_Diehedral(X,Y,Z);
			    }
			    else m->Phi[numberOf_Residue]=DEFAULT_ANGLE;
	
	if(numberOf_Residue<((m->Pos_LastRes[il])-1)){ 
				
					/*************************/
					/* calcul de l'angle Psi */
					/*************************/			
			/******************************************************************************/				
			/*  le N, C alpha et C' du residue & le C' qui est au residue suivant : N+1   */
			/******************************************************************************/
/* 0027*/						      
			      Designation_ATOM(m,X,Y,Z,m->deb_residues[numberOf_Residue],m->deb_residues[numberOf_Residue]+1,\
			      		m->deb_residues[numberOf_Residue]+2,m->deb_residues[numberOf_Residue+1]);
/* 0028 */
			      m->Psi[numberOf_Residue]=Calcul_Diehedral(X,Y,Z);
			     
			     		/***************************/
					/* calcul de l'angle Omega */
				     	/***************************/			
				
			     /* le C alpha et C' du residue &le C' qui est au residue precedent : N+1 et C alpha +1*/
/* 0027*/				 
			     Designation_ATOM(m,X,Y,Z,m->deb_residues[numberOf_Residue]+1,m->deb_residues[numberOf_Residue]+2,\
			      		m->deb_residues[numberOf_Residue+1],m->deb_residues[numberOf_Residue+1]+1);
/* 0028 */
			     m->Omega[numberOf_Residue]=Calcul_Diehedral(X,Y,Z);
			     }
			     else { m->Psi[numberOf_Residue]=DEFAULT_ANGLE;
			    	  m->Omega[numberOf_Residue]=DEFAULT_ANGLE;
			     }
					
					
					/*****************************/
					/* calcul de l'angle des Xhi */
				     	/*****************************/			
				
		if(Usable_Lg_AA[transAA(m->Nam_residues[numberOf_Residue])]>5){ 
	
				/*******************************************************************************/
				/* pour le Xhi 1 : le N, le C alpha, le C beta et l'atome suivant de la chaine */
				/*                       ensuite on suit la chaine                             */
				/*			pour ceux qui sont faisables			       */
				/*		il faudra ameliorer cela pour voir tous les Xhis	       */				
				/*******************************************************************************/				
				for(y_09=0;y_09<NB_MAX_XHI;y_09++){
					if(Usable_Lg_AA[transAA(m->Nam_residues[numberOf_Residue])]>(5+y_09)){
		/* on decale pour le prochain tour le curseur sur les atomes suivants*/
					cursor[0]=(short int)UseAtXhi[y_09][0];
					cursor[1]=(short int)UseAtXhi[y_09][1];
					cursor[2]=(short int)UseAtXhi[y_09][2];
					cursor[3]=(short int)UseAtXhi[y_09][3];

/* 0027*/
		Designation_ATOM(m,X,Y,Z,m->deb_residues[numberOf_Residue]+cursor[0],m->deb_residues[numberOf_Residue]+cursor[1],\
			      		 m->deb_residues[numberOf_Residue]+cursor[2],m->deb_residues[numberOf_Residue]+cursor[3]);
/* 0028 */
				m->Xhi[numberOf_Residue][y_09]=Calcul_Diehedral(X,Y,Z);
					}
				}
			     }
		}
	}						/* sur toute la proteine */	
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 00XX */
/***##***/

/*********************************************************************************************/
/*		pour les problemes de continuite dans les chaines			     */
/*********************************************************************************************/

void Check_AA(pdbfile *m){
	int z20;
	int w20=0;
	
	if(CHECK_DBG=='T') printf("step 00XX\n");
		
	for(z20=0;z20<((m->NB_chain)+1);z20++){
	if((m->Pos_LastRes[z20]+m->Pos_FirstRes[z20]+1)>2){
		for(w20=m->Pos_FirstRes[z20];w20<m->Pos_LastRes[z20]-1;w20++){
		if(CHECK_DBG=='T') printf("%ld %ld %d\n",m->pdbatomtype[m->deb_residues[w20]].ATOM_residuesnumber,m->pdbatomtype[m->deb_residues[w20+1]].ATOM_residuesnumber,abs((m->pdbatomtype[m->deb_residues[w20+1]].ATOM_residuesnumber)-(m->pdbatomtype[m->deb_residues[w20]].ATOM_residuesnumber)));
	if(fabsf((m->pdbatomtype[m->deb_residues[w20+1]].ATOM_residuesnumber)-(m->pdbatomtype[m->deb_residues[w20]].ATOM_residuesnumber))>1){
		(m->PB_AA)++;
		printf("non continuite entre les residus d'une meme chaine (%c) en %d pour les residus %ld et %ld\n",(z20+1+97),w20,(m->pdbatomtype[m->deb_residues[w20]].ATOM_residuesnumber),(m->pdbatomtype[m->deb_residues[w20+1]].ATOM_residuesnumber));
		m->Next_AA[w20]=((m->pdbatomtype[m->deb_residues[w20+1]].ATOM_residuesnumber)-(m->pdbatomtype[m->deb_residues[w20]].ATOM_residuesnumber));
		}
	else m->Next_AA[w20]=1;	
			}	
		}
		m->Next_AA[w20]=1;	/*aout 2000 pour le dernier sinon pb de format*/
	}

}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0025 */
/***##***/

/*********************************************************************************************/
/*		ecrasement de la seconde possiblite lors des Doublet			     */
/*********************************************************************************************/
			
void EcraseSuivant(pdbfile *m,const long place,const long finchaine){
	long y28;
	
	printf("a refaire EcraseSuivant \n");

	for(y28=place;y28<((m->NbAtome)-1);y28++){
		     strcpy(m->pdbatomtype[y28].ATOM_HETAM,m->pdbatomtype[y28+1].ATOM_HETAM);
		if(y28>finchaine)	/* pour ne decaler que quand on passe a la phase suivante */
			m->pdbatomtype[y28].ATOM_serialnumber=m->pdbatomtype[y28+1].ATOM_serialnumber; 
		      strcpy(m->pdbatomtype[y28].ATOM_name,m->pdbatomtype[y28+1].ATOM_name);	
		            m->pdbatomtype[y28].ATOM_altloc=m->pdbatomtype[y28+1].ATOM_altloc;
	       strcpy(m->pdbatomtype[y28].ATOM_residuesname,m->pdbatomtype[y28+1].ATOM_residuesname);	
		       m->pdbatomtype[y28].ATOM_chainnumber=m->pdbatomtype[y28+1].ATOM_chainnumber;
		      m->pdbatomtype[y28].ATOM_ichainnumber=m->pdbatomtype[y28+1].ATOM_ichainnumber;
		    m->pdbatomtype[y28].ATOM_residuesnumber=m->pdbatomtype[y28+1].ATOM_residuesnumber;
		            m->pdbatomtype[y28].ATOM_insert=m->pdbatomtype[y28+1].ATOM_insert;
		            m->pdbatomtype[y28].ATOM_CoordX=m->pdbatomtype[y28+1].ATOM_CoordX;
		            m->pdbatomtype[y28].ATOM_CoordY=m->pdbatomtype[y28+1].ATOM_CoordY;
		            m->pdbatomtype[y28].ATOM_CoordZ=m->pdbatomtype[y28+1].ATOM_CoordZ;
		         m->pdbatomtype[y28].ATOM_Occupancy=m->pdbatomtype[y28+1].ATOM_Occupancy;
		m->pdbatomtype[y28].ATOM_TemperatureFactor=m->pdbatomtype[y28+1].ATOM_TemperatureFactor;
		}
	(m->NbAtome)--;
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/



/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0024 */
/***##***/

/*********************************************************************************************/
/* 		procedure pour rechercher les acides amines en Doublet 		 	     */
/*********************************************************************************************/

void Recherche_Alternative_Location(pdbfile *m){
 	long y56,y08,i08;
	char c;
	short int test=0;

	/*printf(" a refaire car probleme avec les multi-chaines \n");*/
	
	for(y56=0;y56<(((m->NB_chain)));y56++)
		for(y08=m->Pos_chain[y56][0];y08<(m->Pos_chain[y56][1]);y08++){
				i08=y08+1;
				if((m->pdbatomtype[y08].ATOM_altloc)!=0){				/* il y a quelque chose */
				if(CHECK_DBG=='T') printf("== %c %c pour %s %s\n",(m->pdbatomtype[y08].ATOM_altloc),(m->pdbatomtype[y08+1].ATOM_altloc),m->pdbatomtype[y08].ATOM_name,m->pdbatomtype[y08+1].ATOM_name);
					c=m->pdbatomtype[y08].ATOM_altloc; /* on met dans le tampon*/
												
					if((m->pdbatomtype[y08+1].ATOM_altloc)!=c){
/* 0025 */						EcraseSuivant(m,i08,m->Pos_chain[y56][1]);
					(m->PB_Doublet)++;
					}
				}
			}
	c='A';			
	for(y56=0;y56<(((m->NbAtome)));y56++)
		if(((m->pdbatomtype[y56].ATOM_altloc)!=c)&&((m->pdbatomtype[y56].ATOM_altloc)!=0)){
				test=1;
			if(CHECK_DBG=='T') printf("Pb 0001 d'alternative location mal redefini ==> il y a |%c| pour pb en %ld\n",m->pdbatomtype[y56].ATOM_altloc,y56);
			}
	
	if(test==0)for(y56=0;y56<(m->NbAtome);m->pdbatomtype[y56++].ATOM_altloc=' ');
}			

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***##***/
/* 0023 */
/***##***/

/*********************************************************************************************/
/* 		procedure pour rechercher le nombre de chaines 		     		     */
/*********************************************************************************************/

void UnChainMyH(pdbfile *m){
	long yindix;
/*	long nbres=0;*/

	m->NB_chain=0;m->Pos_chain[m->NB_chain][0]=0;m->Pos_FirstRes[0]=0;
	
	if(CHECK_DBG=='T') printf("debut de la recherche du nombre de chaine  step 0023\n");
	
	for(yindix=0;yindix<((m->Nb_residues)-1);yindix++){
	if(((m->pdbatomtype[m->deb_residues[yindix]].ATOM_chainnumber)!=(m->pdbatomtype[m->deb_residues[yindix+1]].ATOM_chainnumber))\
	||((m->pdbatomtype[m->deb_residues[yindix]].ATOM_ichainnumber)!=(m->pdbatomtype[m->deb_residues[yindix+1]].ATOM_ichainnumber))){
				
				/*     pour les residus      */
				
				m->Pos_LastRes[(m->NB_chain)]=yindix;
				m->Pos_FirstRes[(m->NB_chain)+1]=yindix+1;
			 	

				/* pour les positions reelles */

				m->Pos_chain[(m->NB_chain)][1]=m->deb_residues[yindix+1];
				m->Pos_chain[(m->NB_chain)+1][0]=m->deb_residues[yindix];
				
				(m->NB_chain)++;
				}
			}
			m->Pos_chain[(m->NB_chain)][1]=(m->NbAtome);				/* le dernier */
			m->Pos_LastRes[(m->NB_chain)]=(m->Nb_residues);

	 if(CHECK_DBG=='T') printf("fin avec %d+1 chaine(s)\n",(m->NB_chain));
}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/
