# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>
# include <assert.h>
# include <sys/wait.h>

# include "../HEADER/lib_define.h"
# include "../HEADER/options.h"				
# include "../HEADER/lib_protoC.h"
# include "../HEADER/lib_local_secstr.h"
# include "protein_network.h"

int repet(int x){
	if(x==3) return (1);
	else if(x==12) return (0);
	else return (2);

}

char check_seq(int pos,int b,int decal,int fin, char *AA ){
	if(((pos+b+decal)<0)||((pos+b+decal)>=fin)) return ('X');
	else return (AA[(pos+b+decal)]);
}				


void SWs_recovering_evol(pdbfile *m){
			/****************************/
	FILE *f101;	/* Pour les entres sorties */
			/***************************/	
	int c101,a101,b101,d101,w101;
	long bp_coded_real=m->Nb_residues;	
	int swinpn_use[DEF_SIZE];	
	long cp_swinpn=0;
	
	char x1[6];
	char x2[6];	
	
	f101=fopen("Results/evol_recover_72_SWs.txt","a+;");
	for(w101=1;w101<NB_Structural_Words+1;w101++){
		for(a101=0;a101<DEF_SIZE;swinpn_use[a101++]=0);
		cp_swinpn=0;
		for(a101=0;a101<((m->NB_chain)+1);a101++){
			if((m->Pos_LastRes[a101]-m->Pos_FirstRes[a101]+1)>MIN_LONGEUR){
				for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101]-4;b101++){
					for(c101=0;c101<5;c101++)
						x1[c101]=BPtrans(m->Assign_PB[b101+c101]);
						x1[5]='\0';
				for(d101=0;d101<w101;d101++){
					for(c101=0;c101<5;c101++)
						x2[c101]=SWs[d101][c101];
					x2[5]='\0';	
					if(strcmp(x1,x2)==(0)){
							for(c101=-2;c101<7;c101++)
								swinpn_use[b101+c101]++;
						d101=NB_Structural_Words;
						}			
					}
				}
				for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
					if(swinpn_use[b101]!=0) cp_swinpn++;			
				}
/*			printf("SWs classic %2d\t%8.3f\n",w101,(100.0)*((double)cp_swinpn)/((double)bp_coded_real));*/
			fprintf(f101,"%8.3f\t",(100.0)*((double)cp_swinpn)/((double)bp_coded_real));
			}
		}
	}
	printf("SWs classic %2d\t%8.3f\n",w101,(100.0)*((double)cp_swinpn)/((double)bp_coded_real));
	fprintf(f101,"\n");
	fclose(f101);	
	
}

void SWs_recovering_evol_PAPIA(pdbfile *m){
			/****************************/
	FILE *f101;	/* Pour les entres sorties */
			/***************************/	
	int c101,a101,b101,d101,w101;
	long bp_coded_real=m->Nb_residues;	
	int swinpn_use[DEF_SIZE];	
	long cp_swinpn=0;
	
	char x1[6];
	char x2[6];	

/****************************************************************/
/*	vrification de la lecture des Structural Words		*/
/****************************************************************/
/*
	
	for(d101=0;d101<NB_SWs_PAPIA;d101++){
					for(c101=0;c101<5;c101++)
						x2[c101]=SWs_PAPIA[d101][c101];
					x2[5]='\n';	
					printf("%d|%s|\n",d101,x2);	
	}	
*/
	
	f101=fopen("Results/evol_recover_190_SWs_PAPIA.txt","a+;");
	for(w101=1;w101<NB_SWs_PAPIA+1;w101++){
		for(a101=0;a101<DEF_SIZE;swinpn_use[a101++]=0);
		cp_swinpn=0;
		for(a101=0;a101<((m->NB_chain)+1);a101++){
			if((m->Pos_LastRes[a101]-m->Pos_FirstRes[a101]+1)>MIN_LONGEUR){
				for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101]-4;b101++){
					for(c101=0;c101<5;c101++)
						x1[c101]=BPtrans(m->Assign_PB[b101+c101]);
						x1[5]='\0';
				for(d101=0;d101<w101;d101++){
					for(c101=0;c101<5;c101++)
						x2[c101]=SWs_PAPIA[d101][c101];
					x2[5]='\0';	
					if(strcmp(x1,x2)==(0)){
							for(c101=-2;c101<7;c101++)
								swinpn_use[b101+c101]++;
						d101=NB_SWs_PAPIA;
						}			
					}
				}
				for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
					if(swinpn_use[b101]!=0) cp_swinpn++;			
				}
/*			printf("PAPIA %2d\t%8.3f\n",w101,(100.0)*((double)cp_swinpn)/((double)bp_coded_real));*/
			fprintf(f101,"%8.3f\t",(100.0)*((double)cp_swinpn)/((double)bp_coded_real));
			}
		}
	}
	printf("PAPIA %2d\t%8.3f\n",w101,(100.0)*((double)cp_swinpn)/((double)bp_coded_real));
	fprintf(f101,"\n");
	fclose(f101);	
	
}


/*********************************************************************************************/
/*					             */
/*********************************************************************************************/

void Protein_Network(pdbfile *m){
			/****************************/
	FILE *f100;	/* Pour les entres sorties */
	FILE *f101;	/* Pour les entres sorties */
	FILE *f102;	/* Pour les entres sorties */
	FILE *f103;	/* Pour les entres sorties */
	FILE *f104;	/* Pour les entres sorties */
	FILE *f104b;	/* Pour les entres sorties */
	FILE *f105;	/* Pour les entres sorties */	
			/***************************/	
	int c101,a101,b101,d101,i101,u101;
	int i21,cp;
	int central_use[DEF_SIZE];
	long bp_coded_central=m->Nb_residues-4;
	long cp_central=0;
	int real_use[DEF_SIZE];	
	long bp_coded_real=m->Nb_residues;	
	long cp_real=0;
	int swinpn_use[DEF_SIZE];	
	long cp_swinpn=0;
	char x1[6];
	char x2[6];	
	char tampon_file[100];
	int lg_out=0;
	int nbcut=0;
	
	int BPsee[16];
	int BPtotal[16];
	int colori;
	int typeofS2seasee[3];
	int typeofS2seaglobal[3];
	int typeofS2seaseePB[3][16];
	int typeofS2seaglobalPB[3][16];
	int typeofS2strsee[3];
	int typeofS2strglobal[3];
	int typeofS2strseePB[3][16];
	int typeofS2strglobalPB[3][16];
	int repetPBsee[3];
	int repetPBglobal[3];
	
	int deb, fin;
	char tamponfile[255];
/*	char tamponfile2[255];
	char *coloriz[16]={"gold","LightGoldenrod","DarkGoldenrod","RosyBrown","IndianRed","SaddleBrown","sienna","peru","beige","LightSlateBlue","MediumBlue","RoyalBlue","blue","DodgerBlue","DeepSkyBlue","SkyBlue"};
	int lg_color[16]={4,14,13,9,9,11,6,4,5,14,10,9,4,10,11,7};
*/	
/****************************************************************/
/*	vrification de la lecture des Structural Words		*/
/****************************************************************/
/*
	for(d101=0;d101<NB_Structural_Words;d101++){
					for(c101=0;c101<5;c101++)
						x2[c101]=SWs[d101][c101];
					x2[5]='\n';	
					printf("%d|%s|\n",d101,x2);	
	}				
*/
	
/****************************************************************/
/*		vrification de la lecture des AA		*/
/****************************************************************/
/*
	
	for(a101=0;a101<((m->NB_chain)+1);a101++){
		if((m->Pos_LastRes[a101]-m->Pos_FirstRes[a101]+1)>MIN_LONGEUR){
			for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101]-4;b101++){
				for(c101=0;c101<5;c101++)
					x1[c101]=BPtrans(m->Assign_PB[b101+c101]);
					x1[5]='\n';	
				printf("%d|%s|\n",b101,x1);	
				}	
		}
	}		

*/
	f100=fopen("Results/central-use","a+");
	for(a101=0;a101<DEF_SIZE;central_use[a101++]=0);
	f102=fopen("Results/real-use","a+");	
	for(a101=0;a101<DEF_SIZE;real_use[a101++]=0);
	for(a101=0;a101<DEF_SIZE;swinpn_use[a101++]=0);
	f104=fopen("Results/lg_cut","a+");		
	for(i101=0;i101<255;tamponfile[i101++]='\0');
	sprintf(tamponfile,"Results/Rasta/%s.cut",m->name);				
	f104b=fopen(tamponfile,"a+");
	for(a101=0;a101<16;BPsee[a101++]=0);
	for(a101=0;a101<16;BPtotal[a101++]=0);	
	for(a101=0;a101<3;typeofS2seasee[a101++]=0);
	for(a101=0;a101<3;typeofS2seaglobal[a101++]=0);

	for(a101=0;a101<3;a101++)
		for(b101=0;b101<16;typeofS2seaseePB[a101][b101++]=0);
	for(a101=0;a101<3;a101++)
		for(b101=0;b101<16;typeofS2seaglobalPB[a101][b101++]=0);
	
	for(a101=0;a101<3;typeofS2seasee[a101++]=0);
	for(a101=0;a101<3;typeofS2seaglobal[a101++]=0);

	for(a101=0;a101<3;a101++)
		for(b101=0;b101<16;typeofS2strseePB[a101][b101++]=0);
	for(a101=0;a101<3;a101++)
		for(b101=0;b101<16;typeofS2strglobalPB[a101][b101++]=0);
	for(a101=0;a101<3;repetPBsee[a101++]=0);
	for(a101=0;a101<3;repetPBglobal[a101++]=0);
	
if(CHAIN!='-') {printf("chaine :*%c*\n",CHAIN);	
	deb=(int)(CHAIN)-(int)('A');
	fin=deb+1;
	bp_coded_central=(m->Pos_LastRes[deb]-m->Pos_FirstRes[deb]+1)-4;
	bp_coded_real=(m->Pos_LastRes[deb]-m->Pos_FirstRes[deb]+1);
	}
	else{
	deb=0;
	fin=((m->NB_chain)+1);
	}
	for(a101=deb;a101<fin;a101++){
		if((m->Pos_LastRes[a101]-m->Pos_FirstRes[a101]+1)>MIN_LONGEUR){
			fprintf(f100,"\n>%4s%c %6ld BP16  %1.1f\n",m->name,'A',m->Pos_LastRes[a101]-m->Pos_FirstRes[a101]+1,m->resolution);
			for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101]-4;b101++){
				for(c101=0;c101<5;c101++)
					x1[c101]=BPtrans(m->Assign_PB[b101+c101]);
					x1[5]='\0';
		if(WRITE_DBank_AMTRIX=='T'){ 
				clean(tampon_file,100);
				sprintf(tampon_file,"Results/Sequence_SWs_%s",x1);
				f103=fopen(tampon_file,"a+");
				for(c101=0;c101<15;c101++)
					fprintf(f103,"%c",check_seq(b101,c101,-5,m->Pos_LastRes[a101],m->Nam_residues));
				fprintf(f103,"\n");
				fclose(f103);
				clean(tampon_file,100);
				sprintf(tampon_file,"Results/Sequence_PB_%c",BPtrans(m->Assign_PB[b101+2]));
				f103=fopen(tampon_file,"a+");
				for(c101=0;c101<15;c101++)
					fprintf(f103,"%c",check_seq(b101,c101,-5,m->Pos_LastRes[a101],m->Nam_residues));
				fprintf(f103,"\n");
				fclose(f103);
				}								
		for(d101=0;d101<NB_Structural_Words;d101++){
			for(c101=0;c101<5;c101++)
				x2[c101]=SWs[d101][c101];
			x2[5]='\0';	
			if(strcmp(x1,x2)==(0)){
				for(c101=0;c101<5;c101++)
					central_use[b101+c101]++;
				for(c101=-2;c101<7;c101++)
					real_use[b101+c101]++;
				if(Prot_Net[d101]=='Y'){	
					for(c101=-2;c101<7;c101++)
						swinpn_use[b101+c101]++;
							}
						/*printf("==> %s %s\n",x1,x2);	*/
						d101=NB_Structural_Words;
						}			
					}
				}
		for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
			fprintf(f100,"%d",central_use[b101]);	
			if(central_use[b101]!=0){cp_central++;
					if(BPin=='5') BPsee[m->Assign_PB[b101]]++;
					}
			fprintf(f102,"%d",real_use[b101]);	
			if(real_use[b101]!=0)cp_real++;
			BPtotal[m->Assign_PB[b101]]++;
			if(swinpn_use[b101]!=0){
				if(LECT_SEA=='T') {typeofS2seasee[((int)(m->S2sea[b101]))-((int)('a'))]++;
									typeofS2seaseePB[((int)(m->S2sea[b101]))-((int)('a'))][m->Assign_PB[b101]]++;}
						if(LECT_STRIDE=='T') {typeofS2strsee[TroisEtatsStride(m->S2stride[b101])]++;
									typeofS2strseePB[TroisEtatsStride(m->S2stride[b101])][m->Assign_PB[b101]]++;}
						if(REPET=='T') {repetPBsee[repet(m->Assign_PB[b101])]++;}
								cp_swinpn++;
								if((lg_out)>=(1)){
									fprintf(f104,"%d %ld\n",lg_out,bp_coded_real);
									lg_out=0;
									nbcut++;
									}
								if(BPin=='9')	BPsee[m->Assign_PB[b101]]++;			
						}			
					else  {
						lg_out++;
						f105=fopen("Results/what_forget.txt","a+");
/*						fprintf("%c",m->Nam_residues[b101]);*/
						fclose(f105);
					}
					if(LECT_SEA=='T')  {typeofS2seaglobal[((int)(m->S2sea[b101]))-((int)('a'))]++;
							    typeofS2seaglobalPB[((int)(m->S2sea[b101]))-((int)('a'))][m->Assign_PB[b101]]++;}
					if(LECT_STRIDE=='T') {typeofS2strglobal[TroisEtatsStride(m->S2stride[b101])]++;
								typeofS2strglobalPB[TroisEtatsStride(m->S2stride[b101])][m->Assign_PB[b101]]++;}
					if(REPET=='T') {repetPBglobal[repet(m->Assign_PB[b101])]++;}													    
						
				}
				if((lg_out)>=(1)){		fprintf(f104b,"%d\n",lg_out);
								fprintf(f104,"%d %ld\n",lg_out,bp_coded_real);
									lg_out=0;
									nbcut++;
									}	
			if(RSMOL_HIR=='T'){
					

/*					f105=fopen("Results/rasmol_protnet.txt","w");*/
					
					/* rasmol 01 */
					
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Rasmol/rasmol_1_%s",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"background white\nselect all\ncolor [255,0,0]\n");
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
					fprintf(f105,"select %d\n",b101+1);
					colori=(int)(((double)swinpn_use[b101]*(double)255)/(double)9);
					fprintf(f105,"color [%d,0,0]\n",colori);
					}
					fprintf(f105,"background white\nselect all\n");
					fclose(f105);
					
					/* rasmol 02 */
										
					f105=fopen("Results/recouvrement_final.txt","a+");
					fprintf(f105,">%s\n",m->name);
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++)
					fprintf(f105,"%d",swinpn_use[b101]);
					fprintf(f105,"\n");
					fprintf(f105,">%s\n",m->name);
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++)
					if(swinpn_use[b101]!=0) fprintf(f105,"*");
					else fprintf(f105,"-");
					fprintf(f105,"\n");
					fclose(f105);

					/* rasmol 03 */

					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Rasmol/rasmol_1_%s",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"background white\nselect all\ncolor [255,0,0]\n");
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
					fprintf(f105,"select %d\n",b101+1);
					if(swinpn_use[b101]!=0) colori=255;
					else colori=0;
					fprintf(f105,"color [%d,0,0]\n",colori);
					}
					fprintf(f105,"background white\nselect all\n");
					fclose(f105);

					/* rasmol 04 */
					
					f105=fopen("Results/Rasmol/rasmol_script.txt","a+");
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"rasmol -pdb papia/%s.pdb -script Results/Rasmol/rasmol_1_%s",m->name,m->name);
					fprintf(f105,"%s\n",tamponfile);
					fclose(f105);

					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Rasmol/rasmol_bp_%s",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"background white\nselect all\ncolor [255,0,0]\n");
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
					fprintf(f105,"select %d\n",b101+1);
					switch (m->Assign_PB[b101]){
						case  (0) : fprintf(f105,"color Cyan\n"); break;
						case  (1) : fprintf(f105,"color BlueTint\n"); break;
						case  (2) : fprintf(f105,"color Blue\n"); break;
						case  (3) : fprintf(f105,"color SkyBlue\n"); break;
						case  (4) : fprintf(f105,"color White\n"); break;
						case  (5) : fprintf(f105,"color Yellow\n"); break;
						case  (6) : fprintf(f105,"color YellowTint\n"); break;
						case  (7) : fprintf(f105,"color Orange\n"); break;
						case  (8) : fprintf(f105,"color Gold\n"); break;
						case  (9) : fprintf(f105,"color Pink\n"); break;
						case (10) : fprintf(f105,"color PinkTint\n"); break;
						case (11) : fprintf(f105,"color Red\n"); break;
						case (12) : fprintf(f105,"color RedOrange\n"); break;
						case (13) : fprintf(f105,"color Purple\n"); break;
						case (14) : fprintf(f105,"color Brown\n"); break;
						case (15) : fprintf(f105,"color GreenBlue\n"); break;
						default: fprintf(f105,"color [0,0,0]\n");   break;
						}
					}
					fprintf(f105,"background white\nselect all\n");
					fclose(f105);
					

					/* dino 01 */
					
					f105=fopen("Results/dino/dino_script","a+");					     for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"dino_2 -s dino_%s.scr\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"x-povray -I %s -w1000 -h1000 +A +Opov_%s.jpg \n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"x-povray -I %s -w500 -h500 +A +O%s.jpg \n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"tifftopnm  %s.tiff >  %s.ppm\n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"ppmtojpeg --optimize %s.ppm > one_%s.jpg \n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					
					sprintf(tamponfile,"dino_2 -s dino_recov_%s.scr\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"x-povray -I %s -w1000 -h1000 +A +Opov_%sb.jpg \n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"x-povray -I %s -w500 -h500 +A +O%sb.jpg \n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"tifftopnm  %s.tiff >  %s.ppm\n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"ppmtojpeg --optimize %s.ppm > one_%s_b.jpg \n",m->name,m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"mv pov*.jpg  ../Jpeg2 \n mv one*.jpg  ../Jpeg2 \n");	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"mv *.jpg  ../Jpeg \nrm *.pov *.tiff *.inc *.ppm *.png\n");	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');

					
					fclose(f105);

					/* dino 02 */
					
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/dino/dino_%s.scr",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"//// dino script version alpha 0.001\n");				     
					for(u101=0;u101<16;u101++){
						sprintf(tamponfile,"set PB%d  rnum=",u101);
						fprintf(f105,"%s",tamponfile);	
						for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
							if(m->Assign_PB[b101]==u101)
								fprintf(f105,"%d:%d,",b101,b101+1);	
							}
						fprintf(f105,"\n");							
						}
					 for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"load ../PDB/%s.pdb\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s new -name all\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"scene center [.%s.all]\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.all hide\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					
					sprintf(tamponfile,".%s new -name ca -type trace\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=Lavender -sel $PB0\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=SkyBlue -sel $PB1\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=NavyBlue -sel $PB2\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=CornflowerBlue -sel $PB3\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=CadetBlue -sel $PB4\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=LightSeaGreen -sel $PB5\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=MediumAquamarine -sel $PB6\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=LightGoldenrodYellow -sel $PB7\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=moccasin -sel $PB8\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');					
					sprintf(tamponfile,".%s.ca set color=MistyRose1 -sel $PB9\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=coral1 -sel $PB10\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=tomato1 -sel $PB11\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=Red -sel $PB12\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=HotPink4 -sel $PB13\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=plum2 -sel $PB14\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=PeachPuff -sel $PB15\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');					
					sprintf(tamponfile,".%s.ca render hsc  \n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');										
					
					sprintf(tamponfile,"write  %s.tiff \n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');															
					sprintf(tamponfile,"write %s.pov \nexit\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');															
					fclose(f105);	
					
					/* dino 03 */
										
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/dino/dino_recov_%s.scr",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"//// dino script version alpha 0.002\n");				     
					for(u101=0;u101<2;u101++){
						sprintf(tamponfile,"set recov%d  rnum=",u101);
						fprintf(f105,"%s",tamponfile);	
						for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
							if(u101==0) if(swinpn_use[b101]==0)	fprintf(f105,"%d:%d,",b101,b101+1);	
							if(u101!=0) if(swinpn_use[b101]!=0)	fprintf(f105,"%d:%d,",b101,b101+1);	
							}
						fprintf(f105,"\n");							
						}
					 for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"load ../PDB/%s.pdb\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s new -name all\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"scene center [.%s.all]\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.all hide\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					
					sprintf(tamponfile,".%s new -name ca -type trace\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=green -sel $recov0\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca set color=blue -sel $recov1\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.ca render hsc  \n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');										
					
					sprintf(tamponfile,"write  %s.tiff \n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');															
					sprintf(tamponfile,"write %s.pov \nexit\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');															
					fclose(f105);
					
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Fasta/%s_fasta.txt",m->name);				
					f105=fopen(tamponfile,"w");
					
					for(i21=m->Pos_FirstRes[a101];i21<m->Pos_LastRes[a101];i21++){
						fprintf(f105,"    %d\n",i21+1);
						for(cp=0;cp<39;cp++){if(cp==0)fprintf(f105,"(A) ");
						if(m->Next_AA[i21+cp]==1)fprintf(f105,"%c",m->Nam_residues[i21+cp]); if((i21+cp+1)>m->Pos_LastRes[a101])cp=50;}	fprintf(f105,"\n");
						for(cp=0;cp<39;cp++){if(cp==0)fprintf(f105,"(B) ");
						if((m->Next_AA[i21+cp]==1))fprintf(f105,"%c",BPtrans(m->Assign_PB[i21+cp]));if((i21+cp+1)>m->Pos_LastRes[a101])cp=50;}	fprintf(f105,"\n");
						for(cp=0;cp<39;cp++){if(cp==0)fprintf(f105,"(C) ");
						if((m->Next_AA[i21+cp]==1))fprintf(f105,"%d",swinpn_use[i21+cp]);if((i21+cp+1)>m->Pos_LastRes[a101])cp=50;}		fprintf(f105,"\n");
						for(cp=0;cp<39;cp++){if(cp==0)fprintf(f105,"(D) ");
						if((m->Next_AA[i21+cp]==1)) {if(swinpn_use[i21+cp]==0)fprintf(f105,"-"); else fprintf(f105,"*");} if((i21+cp+1)>m->Pos_LastRes[a101])cp=50;}	fprintf(f105,"\n");

						for(cp=0;cp<39;cp++){if(cp==0)fprintf(f105,"(E) ");
						if((m->Next_AA[i21+cp]==1))if(LECT_SEA=='T')	fprintf(f105,"%c",m->S2sea[i21+cp]);if((i21+cp+1)>m->Pos_LastRes[a101])cp=50;}	fprintf(f105,"\n");
						for(cp=0;cp<39;cp++){if(cp==0)fprintf(f105,"(F) ");
						if((m->Next_AA[i21+cp]==1))if(LECT_STRIDE=='T')	fprintf(f105,"%c",m->S2stride[i21+cp]);if((i21+cp+1)>m->Pos_LastRes[a101])cp=50;}	fprintf(f105,"\n");									
						fprintf(f105,"\n");
						i21+=39;		
					}
	
					fclose(f105);
					
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Fasta/%s_fasta2.txt",m->name);				
					f105=fopen(tamponfile,"w");
					
					for(i21=m->Pos_FirstRes[a101];i21<m->Pos_LastRes[a101];i21++){
						fprintf(f105,"    %d\n",i21+1);
						for(cp=0;cp<100;cp++){if(cp==0)fprintf(f105,"(A) ");
						if(m->Next_AA[i21+cp]==1)fprintf(f105,"%c",m->Nam_residues[i21+cp]); if((i21+cp+1)>m->Pos_LastRes[a101])cp=200;}	fprintf(f105,"\n");
						for(cp=0;cp<100;cp++){if(cp==0)fprintf(f105,"(B) ");
						if((m->Next_AA[i21+cp]==1))fprintf(f105,"%c",BPtrans(m->Assign_PB[i21+cp]));if((i21+cp+1)>m->Pos_LastRes[a101])cp=200;}	fprintf(f105,"\n");
						for(cp=0;cp<100;cp++){if(cp==0)fprintf(f105,"(C) ");
						if((m->Next_AA[i21+cp]==1))fprintf(f105,"%d",swinpn_use[i21+cp]);if((i21+cp+1)>m->Pos_LastRes[a101])cp=200;}		fprintf(f105,"\n");
						for(cp=0;cp<100;cp++){if(cp==0)fprintf(f105,"(D) ");
						if((m->Next_AA[i21+cp]==1)) {if(swinpn_use[i21+cp]==0)fprintf(f105,"-"); else fprintf(f105,"*");}if((i21+cp+1)>m->Pos_LastRes[a101])cp=200;}	fprintf(f105,"\n");
						fprintf(f105,"\n");
						i21+=99;		
					}
	
					fclose(f105);
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Fasta/%s.phi",m->name);				
					f105=fopen(tamponfile,"w");
					for(i21=m->Pos_FirstRes[a101];i21<m->Pos_LastRes[a101];fprintf(f105,"%f\n",m->Phi[i21++]));
					fclose(f105);
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/Fasta/%s.psi",m->name);				
					f105=fopen(tamponfile,"w");
					for(i21=m->Pos_FirstRes[a101];i21<m->Pos_LastRes[a101];fprintf(f105,"%f\n",m->Psi[i21++]));
					fclose(f105);
						
					}

			printf("%8.3f %8.3f %8.3f",(100.0)*((double)cp_central)/((double)bp_coded_central),(100.0)*((double)cp_real)/((double)bp_coded_real),(100.0)*((double)cp_swinpn)/((double)bp_coded_real));
			
			
			f101=fopen("Results/recovering","a+");
			fprintf(f101,"%8.3f	%ld 	%8.3f	%ld	%8.3f	%ld %ld %ld\n",(100.0)*((double)cp_central)/((double)bp_coded_central),cp_central,(100.0)*((double)cp_real)/((double)bp_coded_real),cp_real,(100.0)*((double)cp_swinpn)/((double)bp_coded_real),cp_swinpn,bp_coded_central,bp_coded_real);
			fclose(f101);
			
			for(i101=0;i101<255;tamponfile[i101++]='\0'); sprintf(tamponfile,"Results/Rasta/%s.info",m->name);
			f101=fopen(tamponfile,"w");
			fprintf(f101,"%ld\n%8.2f\n%8.2f\n%8.2f\n",bp_coded_real,(100.0)*((double)cp_central)/((double)bp_coded_central),(100.0)*((double)cp_real)/((double)bp_coded_real),(100.0)*((double)cp_swinpn)/((double)bp_coded_real));
			fclose(f101);
			
			for(i101=0;i101<255;tamponfile[i101++]='\0'); sprintf(tamponfile,"Results/Rasta/%s.bp",m->name);
			f105=fopen(tamponfile,"w");
			for(a101=0;a101<16;a101++)
				if(BPsee[a101]==0)
				fprintf(f105,"%8.2f\n",0.0);
				else 
			fprintf(f105,"%8.2f\n",(100.0)*((double)BPsee[a101]/((double)bp_coded_real)));
			fprintf(f105,"\n");
			fclose(f105);				
		if(LECT_SEA=='T') {
			for(i101=0;i101<255;tamponfile[i101++]='\0'); sprintf(tamponfile,"Results/Rasta/%s.s2",m->name);
			f105=fopen(tamponfile,"w");
			for(a101=0;a101<3;a101++)
				fprintf(f105,"%8.2f\n",(100.0)*((double)typeofS2seasee[a101]/((double)bp_coded_real)));
			fprintf(f105,"\n");
			fclose(f105);
			}
			
				
		}
	}


	fprintf(f100,"\n");	
	fclose(f100);
	fprintf(f102,"\n");			
	fclose(f102);	
	fclose(f104);	
	fclose(f104b);
	f104=fopen("Results/lng_cut","a+");
	fprintf(f104,"%d %ld\n",nbcut,bp_coded_real);
	fclose(f104);	
	f105=fopen("Results/pbinpn.txt","a+");
	for(a101=0;a101<16;a101++)
		if(BPsee[a101]==0)
		fprintf(f105,"%8.3f\t",(00.0));
		else 
		fprintf(f105,"%8.3f\t",(100.0)*((double)BPsee[a101])/((double)BPtotal[a101]));
	fprintf(f105,"\n");
	fclose(f105);
			
	f105=fopen("Results/pbinpn2.txt","a+");
	for(a101=0;a101<16;a101++)
		if(BPsee[a101]==0)
		fprintf(f105,"%6d\t",0);
		else 
		fprintf(f105,"%6d\t",BPsee[a101]);
	fprintf(f105,"\n");
	fclose(f105);				

	f105=fopen("Results/pbinpn3.txt","a+");
	for(a101=0;a101<16;a101++)
		if(BPtotal[a101]==0)
		fprintf(f105,"%6d\t",0);
		else 
		fprintf(f105,"%6d\t",BPtotal[a101]);
	fprintf(f105,"\n");
	fclose(f105);				
	if(LECT_SEA=='T') {
		f105=fopen("Results/sea_see.txt","a+");
		for(a101=0;a101<3;a101++)
			fprintf(f105,"%6d\t",typeofS2seasee[a101]);
		fprintf(f105,"\n");
		fclose(f105);
		f105=fopen("Results/sea_glob.txt","a+");
		for(a101=0;a101<3;a101++)
			fprintf(f105,"%6d\t",typeofS2seaglobal[a101]);
		fprintf(f105,"\n");
		fclose(f105);	
		f105=fopen("Results/sea_seePB.txt","a+");
		for(a101=0;a101<3;a101++)
			for(b101=0;b101<16;fprintf(f105,"%6d\t",typeofS2seaseePB[a101][b101++]));
		fprintf(f105,"\n");
		fclose(f105);
		f105=fopen("Results/sea_globPB.txt","a+");
		for(a101=0;a101<3;a101++)
			for(b101=0;b101<16;fprintf(f105,"%6d\t",typeofS2seaglobalPB[a101][b101++]));
		fprintf(f105,"\n");
		fclose(f105);
		}
	
	if(LECT_STRIDE=='T') {
		f105=fopen("Results/str_see.txt","a+");
		for(a101=0;a101<3;a101++)
			fprintf(f105,"%6d\t",typeofS2strsee[a101]);
		fprintf(f105,"\n");
		fclose(f105);
		f105=fopen("Results/str_glob.txt","a+");
		for(a101=0;a101<3;a101++)
			fprintf(f105,"%6d\t",typeofS2strglobal[a101]);
		fprintf(f105,"\n");
		fclose(f105);	
		f105=fopen("Results/str_seePB.txt","a+");
		for(a101=0;a101<3;a101++)
			for(b101=0;b101<16;fprintf(f105,"%6d\t",typeofS2strseePB[a101][b101++]));
		fprintf(f105,"\n");
		fclose(f105);
		f105=fopen("Results/str_globPB.txt","a+");
		for(a101=0;a101<3;a101++)
			for(b101=0;b101<16;fprintf(f105,"%6d\t",typeofS2strglobalPB[a101][b101++]));
		fprintf(f105,"\n");
		fclose(f105);
		}
		
	if(REPET=='T') {
		f105=fopen("Results/pbrepet_see.txt","a+");
		for(a101=0;a101<3;a101++)
			fprintf(f105,"%6d\t",repetPBsee[a101]);
		fprintf(f105,"\n");
		fclose(f105);
		f105=fopen("Results/pbrepet_glob.txt","a+");
		for(a101=0;a101<3;a101++)
			fprintf(f105,"%6d\t",repetPBglobal[a101]);
		fprintf(f105,"\n");
		fclose(f105);
		}
	printf("%s\n",m->name);
	

	
	
if(RECOV_CLASSIC=='T')	SWs_recovering_evol(m);
if(RECOV_PAPIA=='T')	SWs_recovering_evol_PAPIA(m);

}





/*					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/dino/dino_%s.scr",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"\\\\ dino script version alpha 0.001\n");				      for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"load %s.pdb\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s new -name all\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"scene center [.%s.all]\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.all hide\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
						sprintf(tamponfile,".%s new -name A%d -sel rnum=%d:%d -type trace\n",m->name,b101,b101,b101+1);	fprintf(f105,"%s",tamponfile);	for(i101=0;i101<255;tamponfile[i101++]='\0');
						switch(m->Assign_PB[b101]){
							case(0) : sprintf(tamponfile,".%s.A%d set color=%s\n",m->name,b101,"gold"); break;
							default : sprintf(tamponfile,".%s.A%d set color=%s\n",m->name,b101,"sienna"); break;
						}
						fprintf(f105,"%s",tamponfile);	for(i101=0;i101<255;tamponfile[i101++]='\0');
						sprintf(tamponfile,".%s.A%d render hsc\n",m->name,b101);						fprintf(f105,"%s",tamponfile);	for(i101=0;i101<255;tamponfile[i101++]='\0');
						}
					fclose(f105);
										
					for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"Results/dino/dino_2_%s.scr",m->name);
					f105=fopen(tamponfile,"w");
					fprintf(f105,"// dino script version alpha 0.001\n");				      for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"load %s.pdb\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s new -name all\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,"scene center [.%s.all]\n",m->name);	fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					sprintf(tamponfile,".%s.all hide\n",m->name);		fprintf(f105,"%s",tamponfile);for(i101=0;i101<255;tamponfile[i101++]='\0');
					
					for(b101=m->Pos_FirstRes[a101];b101<m->Pos_LastRes[a101];b101++){
						sprintf(tamponfile,".%s renew -name A -sel rnum=%d:%d -type trace\n",m->name,b101,b101+1);	fprintf(f105,"%s",tamponfile);	for(i101=0;i101<255;tamponfile[i101++]='\0');
						switch(m->Assign_PB[b101]){
							case(0) : sprintf(tamponfile,".%s.A set color=%s\n",m->name,"gold"); break;
							default : sprintf(tamponfile,".%s.A set color=%s\n",m->name,"sienna"); break;
						}
						fprintf(f105,"%s",tamponfile);	for(i101=0;i101<255;tamponfile[i101++]='\0');
						sprintf(tamponfile,".%s.A%d render hsc\n",m->name,b101);						fprintf(f105,"%s",tamponfile);	for(i101=0;i101<255;tamponfile[i101++]='\0');
						}
					fclose(f105);
					}
*/					


